# Terms of Service

Terms of Use
2019/08/13 04:20:35Read more
Please read these Terms of Use and the Risk Disclosure Statement carefully. By clicking the “Start trading now” button or by accessing or using any service made available by us, you agree to be legally bound by these Terms of Use (including the Fee Structure and Risk Disclosure Statement), the Privacy Policy and all terms incorporated by reference in the foregoing.

Summary of Terms of Use

We, Bicrypto (hereinafter referred to as “Bicrypto”, “we” or “us”), summarize below our Terms of Use to give an overview of the key terms that apply to your use of our website and trading services. While we hope this summary section is helpful, you must read the complete Terms of Use below since they provide important information about our services, our respective legal rights and obligations, and the risks involved in trading in cryptographic tokens.

Our Services

Bicrypto provides you with a simple and convenient way to trade one type of Digital Token for another type of Digital Token. Bicrypto provides you with a platform that matches your orders with open orders from other users of our Services. Users are not able to predetermine a trade with a particular user or with a particular account. Additionally, an order may be partially filled or may be filled by multiple matching orders. As of today, Bicrypto does not provide services for the trading of legal tender  (“Fiat Currency”) for Digital Tokens or vice versa. Bicrypto does not provide services for the trading of one type of Fiat Currency for another type of Fiat Currency.

Eligibility and Acceptable Use

You must meet certain eligibility criteria to use Bicrypto’s services. You must be at least 18 years of age and there are certain locations from which you may not be able to use some or all of Bicrypto’s services. Other eligibility criteria may also apply. Additionally, there are certain things you cannot do when using Bicrypto’s services, such as engage in market misconduct or illegal activities, lie, or do anything that would cause damage to our services or systems. Please see Section 12 below on “Acceptable Use” for more details.

Trading Risks

Engaging in trades in cryptographic tokens may be highly risky. Please do not use Bicrypto’s services for trading in Digital Tokens if you do not understand these risks.

Other Important Legal Terms

There are important legal terms provided below in the complete Terms of Use, including your indemnification responsibilities, our limitation of liability and warranty disclaimers, and your agreement to arbitrate disputes. Please take the time to read these terms carefully. You can always contact us through Bicrypto Help Center if you have any questions.



Complete Terms of Use

These Terms of Use and any terms expressly incorporated herein (“Terms”) apply to your use of the website operated and maintained by Bicrypto (collectively, “Bicrypto”, “we”, or “us”), and the trading services provided by Bicrypto as described in these Terms (collectively, our “Services”).

1. Key Definitions

Capitalized terms not otherwise defined in these Terms will have the following meaning:

1.1.“External Account” means any Digital Token Account: (i) from which you may transfer Funds into your Bicrypto Account, and (ii) to which you may transfer Funds from your Bicrypto Account and which has been approved by Bicrypto for the foregoing purposes.

1.2.“Funds” means Digital Tokens.

1.3.“Fiat Currency” means any national currency.

1.4.“Bicrypto Account” means a user account accessible via the Services where Funds may be stored by Bicrypto on behalf of a user.

1.5.“Bicrypto Help Center” means Bicrypto’s customer service center with address at https://support.Bicrypto.plus/hc/en-us where you could get online support from Bicrypto.

1.6.“Digital Tokens” means Bitcoins, Bicrypto Tokens, Ripples and other digital mediums of exchange that may be purchased, sold or traded via the Services.

1.7.“Digital Token Account” means any Digital Token address or account owned or operated by you that is maintained outside of the Services, and is not owned, controlled or operated by Bicrypto.

2. Eligibility

2.1. Bicrypto may not make the Services available in all markets and jurisdictions, and may restrict or prohibit use of the Services from certain jurisdictions (“Restricted Locations”).

2.2. You further represent and warrant that you: (a) are at least 18 years old; (b) have not previously been suspended or removed from using our Services or other similar services provided by other parties; (c) have full power and authority to enter into these Terms and in doing so will not violate any other agreement to which you are a party; (d) using our platform in your own name and solely for your own benefit; (e) are not located in, under the jurisdiction of, or a national or resident of any Restricted Locations (as defined in Section 2.1 above); (f) will not use our Services if any applicable laws in your country prohibit you from doing so in accordance with these Terms; (g) are not a designated person under regulations issued pursuant to the lists of individuals or entities identified by the Security Council of the United Nations or the Committee as individuals or entities to whom or which apply the measures referred to in paragraph 8(d) of Resolution 1718 (2006)(including any such list as updated from time to time by the Security Council or the Committee, and made available on the Internet through the official United Nations website at http://www.un.org/) ; and (h) have read and understood these Terms and the Risk Disclosure Statement.

2.3. Bicrypto maintains an anti-money laundering, countering the financing of terrorism and know your customer compliance policy (the “AML/CFT Policy”). Pursuant to such policy, Bicrypto may, in its discretion, require identity verification and go through other screening procedures with respect to you or transactions associated with your Bicrypto Account. You agree and undertake to provide Bicrypto with any and all information and documents that Bicrypto may from time to time request or require for the purposes of these Terms or in connection with your Bicrypto Account (including, but not limited to, your name, address, telephone number, email address, date of birth, government-issued identification number, photograph of your government-issued identity card or document or other photographic proof of your identity, and information regarding your Digital Token Account). Bicrypto will have no liability or responsibility for any permanent or temporary inability to access or use any Services as a result of any identity verification or other screening procedures.

Further, pursuant to the AML/CFT Policy, Bicrypto may, in its discretion, carry out continuous monitoring of all Bicrypto Accounts. If any unusually large or unusual patterns of trades or any inexplicable or suspicious circumstances are observed, Bicrypto may, in its discretion, place an administrative hold on or freeze your Bicrypto Account. You agree that Bicrypto will have no liability or responsibility for any permanent or temporary inability to access or use any Service caused by such action.

2.4. Additionally, by agreeing to these terms you certify that you pursue participation in blockchain-based networks as a part of your professional activity and are familiar with digital tokens or cryptographic tokens and trading in them and the risks attached to them and their trading, including but not limited to the risks highlighted in the Risk Disclosure Statement.

3. Bicrypto Account

3.1. Number of Bicrypto Accounts. Bicrypto may, in its sole discretion, limit the number of Bicrypto Accounts that you may hold, maintain or acquire.

3.2. Bicrypto Account information and security. In order to engage in any trades via the Services, you must create a Bicrypto Account and provide any requested information. When you create a Bicrypto Account, you agree to: (a) create a strong password that you do not use for any other website or online service; (b) provide accurate, complete and truthful information; (c) maintain and promptly update your Bicrypto Account information; (d) maintain the security of your Bicrypto Account by protecting your password and restricting access to your Bicrypto Account; (e) promptly notify us if you discover or otherwise suspect any security breaches related to your Bicrypto Account; and (f) take responsibility for all activities that occur under your Bicrypto Account and accept all risks of any authorized or unauthorized access to your Bicrypto Account, to the maximum extent permitted by law.

3.3. You are solely responsible for doing all things and taking all actions necessary to monitor and secure your Bicrypto Account, and to enable or receive financial or other benefits made available to Digital Token holders.

3.4. You must not create security or any other collateral interest over the Funds in your Bicrypto Account except with our prior written consent.

4. Privacy Policy

Please refer to our Privacy Policy for information about how we collect, use and disclose your personal data.

5. General Obligations

This Section 5 applies to: (i) all trades completed via the Services, and (ii) any transaction in which you transfer Funds into your Bicrypto Account from your External Account or transfer Funds from your Bicrypto Account into an External Account.

5.1. Conditions and Restrictions. We may, at any time and in our sole discretion, refuse any trade submitted via the Services, impose limits on the trade amount permitted via the Services or impose any other conditions or restrictions upon your use of the Services without prior notice. For example, we may limit the number of open orders that you may establish via the Services or we may restrict trades from certain locations.

5.2. Accuracy of Information. You must provide any information required when creating a Bicrypto Account or when prompted by any screen displayed within the Services. You represent and warrant that any information you provide via the Services is accurate and complete.

5.3. Cancellations.

Cancellation of orders. You may only cancel an order initiated via the Services if such cancellation occurs before Bicrypto executes the transaction. Once your order has been executed, you may not change, withdraw or cancel your authorization for Bicrypto to complete such transaction. If an order has been partially filled, you may cancel the unfilled remainder. We may cancel your order in the following circumstances: (i) you have, in our view, engaged in market manipulation or abuse (as described in Section 12.1 below); (ii) your order under the circumstances involves an obvious error with respect to price, quantity or other parameters; (iii) your order would result in self-execution as described in Section 7.1 below;(iv) if required by any applicable law or regulation; and/or (v) if required for technical reasons, such as system maintenance and/or upgrade.
Cancellation of trades. Subject to Section 7.7 below, in contrast to exchange orders, all trades are irreversible once initiated. While we may, at our sole discretion, reverse a trade in the case of Manifest Error or if required by any applicable law or regulation or under certain extraordinary conditions, a customer does not have a right to a reversal of a trade.
5.4. Insufficient Funds. If you have an insufficient amount of Funds in your Bicrypto Account to complete an order via the Services, we may cancel the entire order or may fulfill a partial order using the amount of Funds currently available in your Bicrypto Account, less any fees owed to Bicrypto in connection with our execution of the trade (as described in Section 9 below).

5.5. Taxes. It is your responsibility to determine what, if any, taxes apply to the trades you complete via the Services, and it is your responsibility to report and remit the correct tax to the appropriate tax authority. You agree that Bicrypto is not responsible for determining whether taxes apply to your trades or for collecting, reporting, withholding or remitting any taxes arising from any trades.

5.6. Compliance with all applicable laws and regulations. You represent, warrant and undertake that you have and shall at all times comply with all applicable laws and regulations in all jurisdictions relevant to any Service provided or made available by us to you.

6. Bicrypto Account Funds

6.1. Transferring Funds to your Bicrypto Account. In order to place or match an order or trade via the Services (as described in Section 7), you must first transfer Funds to your Bicrypto Account using one of the approved External Accounts identified via the Services. You may be required to verify that you control the External Account that you use to load Funds to your Bicrypto Account. You may be charged fees by the External Account you use to transfer Funds to your Bicrypto Account. Bicrypto is not responsible for any External Account fees or for the management and security of any External Account. You are solely responsible for your use of any External Account, and you agree to comply with all terms and conditions applicable to any External Account. The timing associated with a transaction for the transfer of Funds to or from an External Account will depend in part upon the performance of third parties responsible for maintaining the applicable External Account, and Bicrypto makes no guarantee regarding the amount of time it may take to transfer Funds into your Bicrypto Account.

6.2. Transferring Funds to an External Account. Provided that the balance of Funds in your Bicrypto Account is greater than any minimum balance requirements needed to satisfy all of your open orders and trades and any fees payable to Bicrypto, and subject to your compliance with all identity verification and other screening procedures and your satisfaction of all requirements under Bicrypto’s AML/CFT Policy as provided in Section 2.3 above, Bicrypto may (but is not obligated to) agree to your request to transfer any amount of Funds, up to the total amount of Funds in your Bicrypto Account in excess of such minimum balance requirements, from your Bicrypto Account to an External Account, less any fees charged by Bicrypto for such transactions (as described in the Fee Structure at the time of your request to transfer Funds to an External Account).

6.3. Transfer Authorization. When you request that we transfer Funds into your Bicrypto Account from your External Account or request that we transfer Funds to your External Account from your Bicrypto Account, you authorize Bicrypto to execute such transaction via the Services.

6.4. Rejected Transactions. In some cases, the External Account may reject your Funds or may otherwise be unavailable. You agree that you will not hold Bicrypto liable for any loss resulting from such rejected transactions.

6.5. Ownership of Digital Tokens. You hereby represent and warrant that any Digital Tokens transferred to your Bicrypto Account from an External Account or otherwise used by you in connection with the Services are owned by you legally and beneficially, and that all orders, trades and transactions initiated with your Bicrypto Account are for your own account and not on behalf of any other person or entity.

7. Exchange Orders and Trades

This Section applies when you use the Services to trade one type of Digital Tokens for another type of Digital Tokens. A trade is a binding agreement between you and another user to exchange an agreed amount of one form of Digital Tokens, for an agreed amount of another form of Digital Tokens, which exchange is supported by the Services and which is in accordance with these Terms. Bicrypto does not purchase, sell, or exchange any Digital Tokens on its own behalf, does not provide services for the trading of Digital Tokens for Fiat Currency and vice versa, and does not provide services for the trading of one Fiat Currency for another Fiat Currency.

7.1. Order Placement, Authorization. An order is created when you enter an instruction to buy or sell a specified quantity of a type of Digital Token at a specified price. To place an order, you must have a sufficient amount of the relevant Funds in your Bicrypto Account to cover the total value of the order plus any applicable fees (as described in Section 9 below).
You are not able to place an order which would result in self-execution, that is, where you would act as both the buyer and seller in respect of the same trade. If two orders of the same quantity would result in self-execution, both orders are cancelled.
When you submit a new order via the Services, and it is matched with another order and it results in a trade under the Services, you will be deemed to have authorized Bicrypto to execute and settle the trade in accordance with such order on a spot basis and charge you any applicable fees (as described in Section 9 below).

7.2. Modes of Orders. We provide different modes of orders for your options as described below. For the purpose of description, the terms shall bear the below meanings:

Targeted Token: the type of Digital Token you intended to trade upon placement of an order or orders.

Latest Market Price: the latest unit price of the Targeted Token when the order placed by you shall be executed;

Specified Price: the unit price of the Targeted Token, which is preset by you and shall be the final executed unit price of the Targeted Token.

Specified Quantity: the quantity of the Targeted Token, which is preset by you and shall be the final executed quantity of the Targeted Token.

Specified Gross Amount: the total value of an order placed by you of the Targeted Token, which is preset by you and shall be the final executed total value of the Targeted Token.

Preset Stop Price: the unit price of the Targeted Token, and you can preset its upper limit or its inferior limit; when the Latest Market Price reach this Preset Stop Price at its upper limit or its inferior limit, it shall trigger the execution of an order, of which ways may varies based on different modes of matching the order you chose.

（i）Market Order:

A Market Order is placed to buy or sell a Specified Quantity or a Specific Gross Amount of Targeted Token at the best available Latest Market Price.

（ii）Limit Order:

A Limit Order is placed to buy or sell a Specific Quantity of the Targeted Token at a Specific Price and shall be filled at such Specific Quantity and Specific Price.

（iii）Stop Market Order:

A Stop Market Order is placed to buy a Specific Quantity of Targeted Token or to buy a Specific Gross Amount of Targeted Token at the Latest Market Price when the upper limit of the Preset Stop Price is triggered. This means that when the Latest Market Price reach or beyond the upper limit of the Preset Stop Price, this order will be executed and filled at the Latest Market Price which may end up higher than the upper limit of the Preset Stop Price.

（iv）Stop Limit Order:

A Stop Limit Order is placed to sell a Specific Quantity of Targeted Token at the Specific Price when the inferior limit of Preset Stop Price is triggered. This means that when the Latest Market Price reach or below the inferior limit of the Preset Stop Price, this order will be executed and filled at the Specific Quantity as well as the Specific Price.

7.3  Advanced Order Function:

If you place a Limit Order or Stop Limit Order, the Advanced Order Function can then be enabled at your choice. The Advanced Order Function will allow you to use a variety of advanced functions as described below:

（i）Post-Only

Enabling Post-Only function means that your order will be included in KucCoin’s buy or sell book and will be canceled unless any part of your order is executed and filled immediately due to the fulfillment of your preset Specific Price and Quantity identified by our matching engine.If you choose not to enable Post-Only function, any executable part of your order will be executed and fulfilled immediately and the any remaining part of your order will stay in Bicrypto’s buy or sell book until it is executed and fulfilled.

（ii）Time in Force

Enabling Time in Force means you can decide when and how long you would like to cancel or keep your order in Bicrypto’s buy or sell book. This function includes the following modes:

Good Til Cancelled (GTC): under this mode, your order will stay in Bicrypto’s buy or sell book waiting to be executed and filled in queue and remain valid until it is cancelled.

Good Til Time (GTT): under this mode, your order will be cancelled automatically if it fails to be executed and filled within a preset period time.

Immediate or Cancel (IOC): under this mode, any executable part of your order will be executed and filled immediately, and the remaining part of this order will be cancelled and will be excluded from Bicrypto’s buy or sell book.

Fill or Kill (FOK): under this mode, your order should be executed and filled entirely and immediately, otherwise, it will be cancelled.

Please noted that the default mode under Advanced Order Function regarding Time in Force will be GTC mode unless otherwise choice has been made.

（iii）Hidden Order

Hidden Order can be enabled by clicking on the “Hidden” option when you place a Limit Order or Stop Limit Order. This means that this Hidden Order can be seen by no other users but you on the Bicrypto’s buy or sell book. This mode can help you hide your intentions to buy or sell any Targeted Token. However, other users can still look up the details of this Hidden Order in “Trade History”.

(iv)Iceberg Order

Iceberg Order can be regarded as an upgrade version of Hidden Order and also can be enabled by clicking on the “Hidden” option when you place a Limit Order or Stop Limit Order. When you click on the “Hidden” option, there will be a place for you to input an “effective quantity to display” and in that you can choose how much quantity out of your order that you would like to display in Bicrypto’s buy or sell book.

Further explanations with respect to the above Modes of Orders and Advanced Order Function could be found by link

. Should you find any error in the trade, you agree to notify us within 48 hours upon the execution of the order, otherwise the execution is conclusive and binding on you.

Notwithstanding anything in these Terms, we reserve the right at all times to make changes to the order matching process or any aspects thereof as necessary on any occasions in order to ensure fair, transparent and orderly functioning of the Services or to protect our interests, whether in the event of a market disruption, or for any other purposes as we deem necessary in our sole discretion.

7.4. Market rates. You acknowledge and agree that (i) the exchange rate information made available via our Services may differ from prevailing exchange rates made available via other sources outside of the Services; (ii) an order may be matched with other order(s) at a number of different prices, based on the quantity of the order and the quantities of existing orders on the order book at the time; and (iii) depending on the volume and prices of orders on the order book at the time when an order is placed, the order may be matched with another order at a price less favorable than the most recent trade price, in some cases significantly so.

7.5. Market volatility. Particularly during periods of high volume, illiquidity, fast movement or volatility in the marketplace for any particular, or one or more Digital Tokens, the actual market rate at which a trade is executed may be different from the prevailing rate indicated via the Services at the time of your order or trade. You understand that we are not liable for any such price fluctuations. In the event of a market disruption or Force Majeure event (as defined in Section 22), Bicrypto may do one or more of the following: (a) suspend access to the Services; or (b) prevent you from completing any actions via the Services, including closing any open positions. Following any such event, when trading resumes, you acknowledge that prevailing market rates may differ significantly from the rates available prior to such event.

7.6. Trade Settlement. Subject to the terms and conditions in these Terms, we will use commercially reasonable efforts to settle trades on a spot basis within two (2) days of the date of the execution of a user’s trade via the Services.

7.7. Error Correction Attempts. A Manifest Error is an error or omission, which by fault of you or us or any user or third party or due to any disruptions, errors, distortions or delays, is materially and clearly incorrect when taking into account market conditions, rates and prices which prevailed at that time. It may include, but is not limited to, an incorrect price, date, time, Digital Token pair, fee, or any error or lack of clarity of any information or source.

If an order, trade or transfer is based on a Manifest Error (regardless of whether you or we or any other user gains from the error) and/or executed and/or settled on the basis of Manifest Error, Bicrypto may (but is not obliged to), at its option and sole discretion, act reasonably and in good faith to: (a) correct, reverse or cancel any order, trade or transfer; (b) void a trade as if it had never taken place; and/or (b) amend a trade so that its terms are the same as the trade which would have been executed if there had been no Manifest Error.

We will exercise the foregoing rights as soon as reasonably practicable after we become aware of the Manifest Error. To the extent practicable we will give you prior notice of any action we take under this clause but if this is not practicable we will give you notice as soon as practicable afterwards. If you consider that an order, trade or transfer is based on a Manifest Error, then you must notify us immediately. We will consider in good faith whether it is appropriate to take any action under this Section 7.7 taking into account all the information relating to the situation, including market conditions and your level of expertise.

You hereby authorize Bicrypto to attempt and/or perform any such correction, reversal, cancellation, voiding or amendment described in this section. Bicrypto provides no guarantee or warranty that any such attempt will be successful and will have no responsibility or liability for the Manifest Error or the making or failure of any correction attempt, except if caused by the gross negligence, willful default or fraud of Bicrypto. There is a risk that you may be prejudiced by any action or omission of Bicrypto in this regard, and you accept that you have no recourse whatsoever against Bicrypto.

7.8. Independent Relationship, No Advice. You acknowledge and agree that: (a) Bicrypto is not holding monies and/or Funds as your trustee, and is not acting as your broker, intermediary, agent, or advisor or in any fiduciary capacity, and (b) no communication or information provided to you by Bicrypto shall be considered or construed as advice.

We shall not give advice to you on the merits of any trade and shall deal with you on an execution-only basis. None of our employees or staff are authorised by us to give you investment advice. Accordingly, you should not regard any proposed trades, suggested trading strategies or other written or oral communications from us as investment recommendations or advice or as expressing our view as to whether a particular trade is suitable for you or meets your financial objectives. You must rely on your own judgement for any investment decision you make in relation to your Bicrypto Account. If you require investment or tax advice, please contact an independent investment or tax adviser. You acknowledge and agree that you have made your own independent analysis and decision when executing a trade and such trades are entered into without reliance upon any views, representations (whether written or oral), advice, recommendation, information or other statement by us.

8. Risk Disclosure

8.Please refer to the Risk Disclosure Statement .  

9. Fees

9.1. Amount of Fees. You agree to pay the fees for trades completed via our Services (“Fees”) as made available via the Fee Structure, which we may change from time to time. Changes to the Fee Structure are effective as of the effective date indicated in the posting of the revised Fee Structure to the Services, and will apply prospectively to any trades that take place following the effective date of such revised Fee Structure.

9.2. Third-Party Fees. In addition to the Fees, your External Account may impose fees in connection with your use of your designated External Account via the Services. Any fees imposed by your External Account provider will not be reflected on the transaction screens containing information regarding applicable Fees. You are solely responsible for paying any fees imposed by an External Account provider.

9.3. Payment of Fees. You authorize us, or our designated payment processor, to charge or deduct your Bicrypto Account Funds for any applicable Fees owed in connection with trades you complete via the Services.

10. Electronic Notices

10.1. Consent to Electronic Delivery. You agree and consent to receive electronically all communications, agreements, documents, receipts, notices and disclosures (collectively, “Communications”) that Bicrypto provides in connection with your Bicrypto Account and/or use of the Bicrypto Services. You agree that Bicrypto may provide these Communications to you by posting them via the Services, by emailing them to you at the email address you provide. You should maintain copies of electronic Communications by printing a paper copy or saving an electronic copy. You may also contact us through support to request additional electronic copies of Communications or, for a fee, paper copies of Communications (as described below).

10.2. Hardware and Software Requirements. In order to access and retain electronic Communications, you will need a computer with an Internet connection that has a current web browser with cookies enabled and 128-bit encryption. You will also need to have a valid email address on file with Bicrypto and have sufficient storage space to save past Communications or an installed printer to print them.

10.3. Withdrawal of Consent. You may withdraw your consent to receive electronic Communications by contacting Bicrypto Help Center. If you decline or withdraw consent to receive electronic Communications, Bicrypto may suspend or terminate your use of the Services.

10.4. Requesting Paper Copies. If, after you consent to receive Communications electronically, you would like a paper copy of a Communication we previously sent you, you may request a copy within 30 days after the date we provided the Communication to you by contacting Bicrypto Help Center. In order for us to send paper copies to you, you must have a current street address on file with Bicrypto. Please note that Bicrypto operates exclusively online and it is very burdensome for us to produce paper copies of Communications. Therefore, if you request paper copies, you understand and agree that Bicrypto may charge you a processing fee, in the amount described in the Fee Structure, for each page of Communication requested.

10.5. Updating Contact Information. It is your responsibility to keep your email address on file with Bicrypto up to date so that Bicrypto can communicate with you electronically. You understand and agree that if Bicrypto sends you an electronic Communication but you do not receive it because your email address on file is incorrect, out of date, blocked by your service provider, or you are otherwise unable to receive electronic Communications, Bicrypto will be deemed to have provided the Communication to you. Please note that if you use a spam filter that blocks or re-routes emails from senders not listed in your email address book, you must add Bicrypto to your email address book so that you will be able to receive the Communications we send to you. You can update your email address at any time by logging into your Bicrypto Account or by contacting Bicrypto Help Center. If your email address becomes invalid such that electronic Communications sent to you by Bicrypto are returned, Bicrypto may deem your account to be inactive, and you may not be able to complete any transaction via our Services until we receive a valid, working email address from you. We shall not be liable for any failure of communication (for any reason).

11. Unclaimed or Disputed Property

If for any reason Bicrypto is holding Funds in your Bicrypto Account, such Funds remain unclaimed, and Bicrypto is unable to return your Funds to your designated External Account after a period of three years after your last login to Bicrypto or any specified period notified by Bicrypto, and Bicrypto determines in good faith that it is not able to trace you, you agree that all such Funds shall be deemed to have been abandoned by you in favour of Bicrypto and may be appropriated by Bicrypto to and for itself, and you thereafter shall have no right to claim such Funds.
If Bicrypto receives notice that any Digital Tokens held in your Bicrypto Account are alleged to have been stolen or otherwise are not lawfully possessed by you, Bicrypto may, but has no obligation to, place an administrative hold on or freeze the affected Digital Tokens or your Bicrypto Account. If Bicrypto does place an administrative hold on or freeze some or all of your Digital Tokens, Bicrypto may continue such hold until such time as the dispute has been resolved and evidence of the resolution acceptable to Bicrypto has been provided to Bicrypto in a form acceptable to Bicrypto. Bicrypto will not involve itself in any such dispute or the resolution of the dispute. You agree that Bicrypto will have no liability or responsibility for any losses, damages or prejudice arising from or in connection with such hold or freeze, or for your inability to withdraw Digital Tokens or execute trades during the period of any such hold or freeze.

12. Acceptable Use

12.1. When accessing or using the Services, you agree that you will not violate any law or any contractual, intellectual property or other third-party right or commit a tort, and that you are solely responsible for your conduct while using our Services. Without limiting the generality of the foregoing, you agree that you will not:

Use our Services in any manner that could interfere with, disrupt, negatively affect or inhibit other users from fully enjoying our Services, or that could damage, disable, overburden or impair the functioning of our Services or bring disrepute to our Services in any manner;
Use our Services to pay for, support or otherwise engage in any illegal gambling activities; fraud; market manipulation or abuse (including but not limited to your taking actions, or acting in concert with another user to take actions, on or outside the Services, which are intended to deceive or mislead other users, or artificially control or manipulate the price or trading volume of a Digital Token); money-laundering; or terrorist activities; or other illegal activities;
Use any robot, spider, crawler, scraper or other automated means or interface not provided by us to access our Services or to extract data;
Use or attempt to use another user’s account without authorization;
Attempt to circumvent any content filtering techniques we employ, or attempt to access any service or area of our Services that you are not authorized to access;
Introduce to the Services any malware, virus, trojan worms, logic bombs, or other harmful material;
Develop any third-party applications that interact with our Services without our prior written consent;
Provide false, inaccurate, or misleading information;
Encourage or induce any third party to engage in any of the activities prohibited under this section.

13. Feedback

We will own exclusive rights, including all intellectual property rights, to any feedback, suggestions, and ideas or other information or materials regarding Bicrypto or our Services that you provide, whether by email, posting through our Services or otherwise (“Feedback”). Any Feedback you submit is non-confidential and shall become the sole property of Bicrypto. We will be entitled to the unrestricted use and dissemination of such Feedback for any purpose, commercial or otherwise, without acknowledgment or compensation to you. You waive any rights you may have to the Feedback (including any copyrights). Do not send us Feedback if you expect to be paid or want to continue to own or claim rights in them; your idea might be great, but we may have already had the same or a similar idea and we do not want disputes. You also acknowledge and agree that we have the right to disclose your identity to any third party who is claiming that any content posted by you constitutes a violation of their intellectual property rights, or of their right to privacy. We have the right to remove any posting you make on our website if, in our opinion, your post does not comply with the content standards set out in our website.

14. Copyrights and Other Intellectual Property Rights

14.1. Unless otherwise indicated by us, all copyright and other intellectual property rights in all content and other materials contained on our website or provided in connection with the Services, including, without limitation, the Bicrypto or Bicrypto logo and all designs, text, graphics, pictures, information, data, software, sound files, other files and the selection and arrangement thereof (collectively, “Bicrypto Materials”) are the proprietary property of Bicrypto or our licensors or suppliers and are protected by international copyright laws and other intellectual property rights laws.

14.2. We hereby grant you a limited, nonexclusive and non-sublicensable license to access and use the Bicrypto Materials for your personal use. Such license is subject to these Terms and does not permit (a) any resale of the Bicrypto Materials; (b) the distribution, public performance or public display of any Bicrypto Materials; (c) modifying or otherwise making any derivative uses of the Bicrypto Materials, or any portion thereof; or (d) any use of the Bicrypto Materials other than for their intended purposes. The license granted under this section will automatically terminate if we suspend or terminate your access to the Services.

15.Fiat Trading Service Provider

Prior to conducting Fiat Trading, in accordance with type of fiat trading, you shall separately read and sign User Agreements with various Bicrypto partnered OTC platforms, and comply with the User Guide of P2P Fiat Trade Platform on Anti-money Laundering and Counter-Terrorist Financing Rules for Fiat Transactions and other specific Rules for Fiat Trandactions as well as the business rules of such partners, and open an account on such Bicrypto OTC platforms, following the completion of the registration and identity verification for your Bicrypto Account, if applicable. a. Fiat Payments. Bicrypto has engaged many payment service providers as authorized service providers on our platform, Bicrypto has published the details of these entities as following:- Kufun Limited (registration number: 2610027) having its registered office at Flat/Rm B5 1/F Manning Ind. Building, 116-118, How Ming Street, Kwun Tong, Hong Kong (the “Payment Entities”). These entities are never facilitating any other service than the fiat on ramp to its exchange service(for the avoidance of doubt this means that all our Securities and Derivatives products are not serviced through these entities). You could also see “Payment Entities” on our Announcement. If you choose to utilise Fiat Trading, you agree that any and/or all Payment Entities may provide payment service to you and shall be responsible for the transaction (including for the purpose of refunds and cancellations). These terms and conditions shall be governed and construed in the laws of Hong Kong, and you submit to the non-exclusive jurisdiction of the courts of Hong Kong.


16. Suspension; Termination

In the event of any Force Majeure Event (as defined in Section 22.5), breach of these Terms or any laws or regulations, or any other event that would make provision of the Services commercially unreasonable for Bicrypto, we may, in our discretion and without liability to you, with or without prior notice, suspend your access to all or a portion of our Services and/or as may be required by applicable laws, file a suspicious transaction report with the relevant authorities or otherwise report or inform the relevant authorities or take any other steps to protect Bicrypto’s interests as Bicrypto deems appropriate. We may also terminate your access to the Services in our sole discretion, immediately and without prior notice, and delete or deactivate your Bicrypto Account and all related information and files in such account without liability to you, including, for instance, in the event that you breach any term of these Terms. In the event of discontinuation of all Services or termination of your access to the Services or deletion or deactivation of your Bicrypto Account: (a) all amounts payable by you to Bicrypto will immediately become due; (b) Bicrypto may cancel any open orders or other transaction requests that are pending at the time of discontinuation or termination or deletion or disactivation;(c) Bicrypto will, where possible, return any Funds stored in your Bicrypto Account not otherwise owed to Bicrypto and/or will use commercially reasonable efforts to provide you with a period of 90 days to transfer affected Digital Tokens from your Bicrypto Account, unless prohibited by applicable laws or regulations or by order of law enforcement or governmental authority, or Bicrypto believes you have committed fraud, negligence or other misconduct; and/or (d) Bicrypto may take such other steps as Bicrypto deems necessary or desirable to protect its own interests. We are not and shall not be responsible or liable for any loss or damages incurred as a result of or arising from any actions taken under this section.

17. Support for Digital Tokens and Discontinuance of Services

We may, in our sole discretion and without liability to you, with or without prior notice and at any time, modify or discontinue, temporarily or permanently, all or any portion of our Services, which may include but is not limited to suspending trading in or ceasing to offer Services in respect of any of the Digital Tokens or prohibiting use of the Services in or from certain jurisdictions.

Unless Bicrypto notifies you or makes a public statement to the contrary, Bicrypto does not support related side chains or other Underlying Technology of Digital Tokens that are based on a fork, enhancement, or derivative of a different Digital Token or the software, networks, protocols, systems and other technology (including, if applicable, any blockchain) used to administer, create, issue, transfer, cancel, use or transact in any Digital Token (“Derivative Protocols”), even if such is based on a Digital Token that is supported by Bicrypto, and you should not use your Bicrypto Account to attempt to transfer, store, trade or engage in any other type of transaction based on such Derivative Protocols. Bicrypto will have no responsibility or liability whatsoever for any losses or damages in respect of any Derivative Protocol.

18. Disclaimer of Warranties

18.1. Except as expressly provided to the contrary in a writing by us, our services are provided on an “As is” and “As available” basis. We expressly disclaim, and you waive, all warranties of any kind, whether express or implied, including, without limitation, implied warranties of merchantability, fitness for a particular purpose, title and non-infringement as to our services, including the information, content and materials contained therein, to the fullest extent permitted by applicable laws.

18.2. You acknowledge that information you store or transfer through our services may become irretrievably lost or corrupted or temporarily unavailable due to a variety of causes, including software failures, protocol changes by third party providers, internet outages, force majeure event or other disasters including third party Distributed Denial of Service attacks, scheduled or unscheduled maintenance, or other causes either within or outside our control. You are solely responsible for backing up and maintaining duplicate copies of any information you store or transfer through our Services.

Some jurisdictions do not allow the disclaimer of implied terms in contracts with consumer, so some or all of the disclaimers in this section may not apply to you.

19. Limitation of Liability

19.1. Except as otherwise required by law, in no event shall Bicrypto, our directors, officers, members, employees, agents or contractors be liable for any special, indirect or consequential damages, or any other damages of any kind, including but not limited to loss of use, loss of profits or loss of data, whether in an action in contract, tort (including but not limited to negligence) or otherwise, arising out of or in any way connected with the use of or inability to use our Services or the Bicrypto Materials, including without limitation any damages caused by or resulting from reliance by any user on any information obtained from Bicrypto, or that result from mistakes, omissions, interruptions, deletion of files or email, errors, defects, viruses, delays in operation or transmission or any failure of performance, whether or not resulting from a force majeure event, communications failure, theft of, destruction of or unauthorized access to Bicrypto’s records, programs or services.
Some jurisdictions do not allow the exclusion of certain warranties or the limitation or exclusion of liability for incidental or consequential damages. Accordingly, some of the limitations of this section may not apply to you.

19.2. To the maximum extent permitted by applicable law, in no event shall the aggregate liability of Bicrypto (including our directors, officers, members, employees and agents), whether in contract, warranty, tort (including negligence, whether active, passive or imputed), product liability, strict liability or other theory, arising out of or relating to the use of, or inability to use the Services, Bicrypto or to these terms exceed the fees paid by you to Bicrypto during the 12 months immediately preceding the date of any claim giving rise to such liability.

19.3. We have no control over, or liability for, the delivery, quality, safety, legality or any other aspect of any Digital Tokens that you may purchase or sell to or from a user of the Services. We are not responsible for ensuring that a third-party buyer or a seller you transact with will complete a trade or transaction or is authorised to do so. If you experience a problem with any Digital Tokens or services purchased from, or sold to, a user using the Services, or if you have a dispute with such user, you should resolve the dispute directly with that user. If you believe a user has behaved in a fraudulent, misleading, or inappropriate manner, or if you cannot adequately resolve a dispute with a third party, you may notify Bicrypto Help Center if you have any questions.

19.4. You acknowledge that there is no guarantee fund established or other arrangement in place to cover or compensate you for any pecuniary loss suffered by you as a result of any defaults by or the insolvency of any other users of the Services.

20. Indemnity

You agree to defend, indemnify and hold harmless Bicrypto (and each of our officers, directors, members, employees, agents and affiliates) from any claim, demand, action, damage, loss, cost or expense, including without limitation reasonable attorneys’ fees, arising out or relating to (a) your use of, or conduct in connection with, our Services; (b) any Feedback you provide; (c) your violation of these Terms or any agreement incorporated by reference in these Terms; and/or (d) your violation of any rights of any other person or entity or of any laws and regulations including but not limited to anti-money laundering and countering the financing of terrorism laws and regulations. If you are obligated to indemnify us, we will have the right, in our sole discretion, to control any action or proceeding (at our expense) and determine whether we wish to settle it.

21. Applicable Law and Disputes Resolution
Please read the following paragraph carefully because it requires you to settle disputes with us and it limits the manner in which you can seek relief.
You and Bicrypto agree to notify each other in writing of any dispute within thirty (30) days of when it arises. Notice to Bicrypto shall be sent to Bicrypto Support Center. You and Bicrypto further agree that you and Bicrypto shall spend not less than three (3) months on full communication, consultation or mediation before either party submits the disputes in question for litigation. If no settlement can be reached through consultation, the litigation shall be under the jurisdiction of the court located in the place where the plaintiff has his/her/its domicile.

These Terms shall be governed by and construed in accordance with English Common Law. The International Business Companies Act 1994 is the principal legislation that governs corporates in the Republic of Seychelles.

22. Miscellaneous

22.1. Entire Agreement; Order of Precedence.

These Terms contain the entire agreement, and supersede all prior and contemporaneous understandings between the parties regarding the Services. These Terms do not alter the terms or conditions of any other electronic or written agreement you may have with Bicrypto for the Services or for any other Bicrypto product or service or otherwise. In the event of any conflict between these Terms and any other agreement you may have with Bicrypto, the terms of that other agreement will prevail only if these Terms are specifically identified and declared to be overridden by such other agreement.

22.2. Third Party Rights

A person who is not a party to these Terms has no right to enforce any term of these Terms.

22.3. Amendment

We reserve the right to make changes or modifications to these Terms from time to time, in our sole discretion. If we make changes to these Terms, we will provide you with notice of such changes, such as by sending an email, providing notice on the homepage of our website and/or by posting the amended Terms via the applicable Bicrypto websites and mobile applications and updating the “Last Updated” date at the top of these Terms. The amended Terms will be deemed effective immediately upon posting for any new users of the Services. In all other cases, the amended Terms will become effective for preexisting users upon the earlier of either: (i) the date users click or press a button to accept such changes, or (ii) continued use of our Services 30 days after Bicrypto provides notice of such changes. Any amended Terms will apply prospectively to use of the Services after such changes become effective in accordance with these Terms. If you do not agree to any amended Terms, you must discontinue using our Services and contact us to terminate your account.

22.4. Waiver

Our failure or delay in exercising any right, power or privilege under these Terms shall not operate as a waiver thereof.

22.5. Severability

The invalidity or unenforceability of any of these Terms shall not affect the validity or enforceability of any other of these Terms, all of which shall remain in full force and effect.

22.6. Force Majeure Events

Bicrypto shall not be liable for (1) any inaccuracy, error, failure, delay in, or omission of (i) any information, (ii) the transmission or delivery of information, or (iii) carrying out its obligations under these Terms; (2) any loss or damage in any and all cases arising from any event beyond Bicrypto’s reasonable control, including but not limited to flood, extraordinary weather conditions, earthquake, or other act of God, fire, war, insurrection, riot, labor dispute, accident, action of government, terrorist attacks, market failure or disruption, telecommunications or network breakdown or disruption, communications, power failure, attacks on the security, integrity or operation of Digital Tokens, the Services and/or the Bicrypto Accounts and Funds held therein, or equipment or software malfunction or any other cause beyond Bicrypto’s reasonable control (each, a “Force Majeure Event”).

22.7. Assignment

You may not assign or transfer any of your rights or obligations under these Terms without prior written consent from Bicrypto, including by operation of law or in connection with any change of control. Bicrypto may assign or transfer any or all of its rights under these Terms, in whole or in part, without obtaining your consent or approval.

22.8. Headings

Headings of sections are for convenience only and shall not be used to limit or construe such sections.

22.9. Governing language and translations

These Terms, the Privacy Policy, and other agreements or communications notified through the Services have been drafted in English. Although translations in other languages of any of the foregoing documents may be available, such translations may not be up to date or complete. Accordingly, you agree that in the event of any conflict between the English language version of the foregoing documents and any other translations thereof, the English language version of such documents shall govern and prevail.  

22.10. Survival

Sections 2 (Eligibility), Section 3 (Bicrypto Account), Section 8 (Risk Disclosure), Section 9 (Fees), Section 11 (Unclaimed Property), Section 13 (Feedback), Section 14 (Copyrights and other Intellectual Property Rights), Section 15 (Third-Party Content), Section 18 (Disclaimer of Warranties), Section 19 (Limitation of Liability); Section 20 (Indemnity), Section 21 (Applicable Law; Arbitration) and this Section 22 (Miscellaneous) shall survive any termination or expiration of these Terms.
