<?php
use mobiledetect\mobiledetectlib\Detection;
$detect = new Mobile_Detect();
?>
<?php $__env->startSection('title', 'Login Page'); ?>

<?php $__env->startSection('page-style'); ?>
    
    <link rel="stylesheet" href="<?php echo e(asset(mix('css/base/pages/authentication.css'))); ?>">
<?php $__env->stopSection(); ?>

<?php $__env->startSection('content'); ?>
    <div class="auth-wrapper auth-basic px-2">
        <div class="auth-inner my-2">
            <!-- Login basic -->
            <div class="card mb-0">
                <div class="card-body">
                    <a href="#" class="col d-flex justify-content-center mb-1">
                        <div class="brand-text"><img
                                src="<?php echo e(getImage(imagePath()['logoIcon']['path'] . '/logo.png')); ?>"
                                alt="<?php echo e(__('locale.image')); ?>"></div>
                    </a>

                    <h4 class="card-title mb-1">Welcome! 👋</h4>
                    <p class="card-text mb-2">Please sign-in to your account and start the adventure</p>

                    <?php if(session('status')): ?>
                        <div class="alert alert-success mb-1 rounded-0" role="alert">
                            <div class="alert-body">
                                <?php echo e(session('status')); ?>

                            </div>
                        </div>
                    <?php endif; ?>

                    <form class="auth-login-form mt-2" method="POST" action="<?php echo e(route('login')); ?>" id="loginForm">
                        <?php echo csrf_field(); ?>
                        <div class="mb-1">
                            <label for="login-email" class="form-label">Email / Username</label>
                            <input type="text"
                                class="form-control <?php $__errorArgs = ['email'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?> <?php $__errorArgs = ['username'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>"
                                id="login-email" name="email" placeholder="john@example.com" aria-describedby="login-email"
                                tabindex="1" autofocus value="<?php echo e(old('email')); ?>" />
                            <?php $__errorArgs = ['email'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                <span class="invalid-feedback" role="alert">
                                    <strong><?php echo e($message); ?></strong>
                                </span>
                            <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                        </div>

                        <div class="mb-1">
                            <div class="d-flex justify-content-between">
                                <label class="form-label" for="login-password">Password</label>
                                <?php if(Route::has('password.request')): ?>
                                    <a href="<?php echo e(route('password.request')); ?>">
                                        <small>Forgot Password?</small>
                                    </a>
                                <?php endif; ?>
                            </div>
                            <div class="input-group input-group-merge form-password-toggle">
                                <input type="password" class="form-control form-control-merge" id="login-password"
                                    name="password" tabindex="2"
                                    placeholder="&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;&#xb7;"
                                    aria-describedby="login-password" />
                                <span class="input-group-text cursor-pointer"><i data-feather="eye"></i></span>
                            </div>
                        </div>
                        <div class="mb-1">
                            <div class="form-check">
                                <input class="form-check-input" type="checkbox" id="remember" name="remember" tabindex="3"
                                    <?php echo e(old('remember') ? 'checked' : ''); ?> />
                                <label class="form-check-label" for="remember"> Remember Me </label>
                            </div>
                        </div>
                        <button type="submit" class="btn btn-primary w-100" tabindex="4">Sign in</button>
                    </form>

                    <p class="text-center mt-2">
                        <span>New on our platform?</span>
                        <?php if(Route::has('register')): ?>
                            <a href="<?php echo e(route('register')); ?>">
                                <span>Create an account</span>
                            </a>
                        <?php endif; ?>
                    </p>
                    <?php if(getExt('7')->status == 1): ?>
                        <div class="divider my-2">
                            <div class="divider-text">or</div>
                        </div>

                        <div class="auth-footer-btn d-flex justify-content-center">
                            <button type="button" class="btn btn-success w-100 walletConnectBtc" data-bs-toggle="modal"
                                data-bs-target="#walletConnect">
                                Sign In With Wallet
                            </button>
                            
                            </a>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
            <!-- /Login basic -->
        </div>
    </div>
    <?php if(getExt('7')->status == 1): ?>
        <div class="modal fade" tabindex="-1" id="walletConnect">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Wallet Connect</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                        <div style="display: grid; grid-template-columns: 1fr 1fr;">
                            <?php if(!$detect->isMobile() && !$detect->isTablet()): ?>
                                <div onclick="login('Metamask')"
                                    style="align-items: center; display: flex; flex-direction: column; height: auto; justify-content: center; margin-left: auto; margin-right: auto; padding: 20px 5px; cursor: pointer;">
                                    <img src="<?php echo e(asset('assets/images/wallets/metamaskWallet.png')); ?>" alt="Metamask"
                                        style="align-self: center; fill: rgb(40, 13, 95); flex-shrink: 0; margin-bottom: 8px; height: 30px;"><span
                                        class="ant-typography" style="font-size: 14px;">Metamask</span>
                                </div>
                            <?php endif; ?>
                            <div onclick="login('WalletConnect')"
                                style="align-items: center; display: flex; flex-direction: column; height: auto; justify-content: center; margin-left: auto; margin-right: auto; padding: 20px 5px; cursor: pointer;">
                                <img src="<?php echo e(asset('assets/images/wallets/wallet-connect.svg')); ?>" alt="WalletConnect"
                                    style="align-self: center; fill: rgb(40, 13, 95); flex-shrink: 0; margin-bottom: 8px; height: 30px;"><span
                                    class="ant-typography" style="font-size: 14px;">WalletConnect</span>
                            </div>
                        </div>
                        <div class="card-footer text-end">
                            <button onclick="logOut()" class="btn btn-danger">Disconnect</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    <?php endif; ?>
<?php $__env->stopSection(); ?>

<?php if(getExt('7')->status == 1): ?>
    <?php $__env->startSection('page-script'); ?>
        <script src="https://unpkg.com/moralis@1.5.10/dist/moralis.js"></script>
        <script>
            $(".walletConnectBtc").click(function() {
                $.getScript(
                    "https://github.com/WalletConnect/walletconnect-monorepo/releases/download/1.7.7/web3-provider.min.js"
                );
            });
            const serverUrl = "<?php echo e(getGen()->moralis_server_url); ?>";
            const appId = "<?php echo e(getGen()->moralis_app_id); ?>";

            /* Authentication code */
            async function login($a) {
                await Moralis.start({
                    serverUrl,
                    appId
                });
                let user = Moralis.User.current();
                if (!user) {
                    if ($a == 'Metamask') {
                        user = await Moralis.authenticate({
                                signingMessage: "Log to <?php echo e(siteName()); ?> using MetaMask"
                            })
                            .then(function(user) {
                                let ethAddress = user.get("ethAddress")
                                $.ajax({
                                    headers: {
                                        "X-CSRF-TOKEN": "<?php echo e(csrf_token()); ?>",
                                    },
                                    url: "<?php echo e(route('metamask.login')); ?>",
                                    method: "POST",
                                    data: {
                                        ethAddress: ethAddress,
                                    },
                                    success: function(response) {
                                        if (response == 1) {
                                            notify('success', 'Successfully Logged in')
                                            window.location.href = "<?php echo e(route('user.home')); ?>";
                                        } else {
                                            notify('error', 'Login Failed')
                                        }
                                    }
                                });
                            })
                            .catch((error) => {
                                if (error.responseJSON.message.includes('No query results for')) {
                                    notify('error', 'Your Account Dont Have Connected Wallet')
                                }
                            });
                    } else if ($a == 'WalletConnect') {
                        user = await Moralis.authenticate({
                                provider: "walletconnect"
                            })
                            .then(function(user) {
                                let ethAddress = user.get("ethAddress")
                                $.ajax({
                                    headers: {
                                        "X-CSRF-TOKEN": "<?php echo e(csrf_token()); ?>",
                                    },
                                    url: "<?php echo e(route('metamask.login')); ?>",
                                    method: "POST",
                                    data: {
                                        ethAddress: ethAddress,
                                    },
                                    success: function(response) {
                                        if (response == 1) {
                                            notify('success', 'Successfully Logged in')
                                            window.location.href = "<?php echo e(route('user.home')); ?>";
                                        } else {
                                            notify('error', 'Login Failed')
                                        }
                                    }
                                });
                            })
                            .catch((error) => {
                                if (error.responseJSON.message.includes('No query results for')) {
                                    notify('error', 'Your Account Dont Have Connected Wallet')
                                };
                            });
                    }
                } else {
                    let ethAddress = user.get("ethAddress")
                    $.ajax({
                            headers: {
                                "X-CSRF-TOKEN": "<?php echo e(csrf_token()); ?>",
                            },
                            url: "<?php echo e(route('metamask.login')); ?>",
                            method: "POST",
                            data: {
                                ethAddress: ethAddress,
                            },
                            success: function(response) {
                                if (response == 1) {
                                    notify('success', 'Successfully Logged in')
                                    window.location.href = "<?php echo e(route('user.home')); ?>";
                                } else {
                                    notify('error', 'Login Failed')
                                }
                            }
                        })
                        .catch((error) => {
                            if (error.responseJSON.message.includes('No query results for')) {
                                notify('error', 'Your Account Dont Have Connected Wallet')
                            };
                        });
                }
            }

            async function logOut() {
                await Moralis.start({
                    serverUrl,
                    appId
                });
                await Moralis.User.logOut();
                notify('success', 'Wallet Disconnected Successfully')
            }
        </script>
    <?php $__env->stopSection(); ?>
<?php endif; ?>

<?php echo $__env->make('layouts/fullLayoutMaster', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH C:\xampp\htdocs\resources\views/auth/login.blade.php ENDPATH**/ ?>