<?php $__env->startSection('content'); ?>
<div class="row" id="table-hover-row">
    <div class="col-12">
        <div class="card">
            <div class="card-header d-flex justify-content-between align-items-center">
                <h4 class="card-title">Extensions</h4><div class="card-search"></div>
            </div>
            <div class="table-responsive">
                <table class="table table-hover custom-data-bs-table">
                    <thead class="table-dark">
                                <tr>
                                    <th scope="col"><?php echo e(__('locale.Extension')); ?></th>
                                    <th scope="col"><?php echo e(__('locale.Status')); ?></th>
                                    <th scope="col"><?php echo e(__('locale.Action')); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                            <?php $__currentLoopData = $extensions; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $extension): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                <tr>
                                    <td data-label="<?php echo e(__('locale.Extension')); ?>">
                                        <div class="row centerize">
                                            <div class="col-md-3 thumb">
                                                <img src="<?php echo e(getImage(imagePath()['extensions']['path'] .'/'. $extension->image,'36x36')); ?>" alt="<?php echo e(__($extension->name)); ?>" class="plugin_bg"></div>
                                            <span class="col-md-9 name"><?php echo e(__($extension->name)); ?></span>
                                        </div>
                                    </td>
                                    <td data-label="<?php echo e(__('locale.Status')); ?>">
                                        <?php if($extension->installed == 1): ?>
                                            <?php if($extension->status == 1): ?>
                                                <span class="badge bg-success"><?php echo e(__('locale.Active')); ?></span>
                                            <?php else: ?>
                                                <span class="badge bg-warning"><?php echo e(__('locale.Disabled')); ?></span>
                                            <?php endif; ?>
                                        <?php else: ?>
                                            <span class="badge bg-secondary"><?php echo e(__('locale.Not Installed')); ?></span>
                                        <?php endif; ?>
                                    </td>
                                    <td data-label="<?php echo e(__('locale.Action')); ?>">
                                        <?php if($extension->installed == 1): ?>
                                            <?php
                                                $res = $api->check_update($extension->product_id);
                                            ?>
                                            <?php if($res['status']): ?>
                                                <a type="button" class="btn btn-warning" style="top:80%" href="<?php echo e(route('admin.extensions.install',[$extension->product_id])); ?>">
                                                    <i class="bi bi-download"></i> Update V<?php echo e($res['version']); ?> Available</a>
                                            <?php endif; ?>
                                            <?php if($extension->status == 0): ?>
                                                <button type="button"
                                                        class="btn btn-icon btn-success rounded ms-1 activateBtn"
                                                        data-bs-toggle="modal" data-bs-target="#activateModal"
                                                        data-id="<?php echo e($extension->id); ?>" data-name="<?php echo e(__($extension->name)); ?>"
                                                        title="<?php echo e(__('locale.Enable')); ?>">
                                                    <i class="bi bi-eye"></i>
                                                </button>
                                            <?php else: ?>
                                                <button type="button"
                                                        class="btn btn-icon btn-danger ms-1 deactivateBtn"
                                                        data-bs-toggle="modal" data-bs-target="#deactivateModal"
                                                        data-id="<?php echo e($extension->id); ?>" data-name="<?php echo e(__($extension->name)); ?>"
                                                        title="<?php echo e(__('locale.Disable')); ?>">
                                                    <i class="bi bi-eye-slash"></i>
                                                </button>
                                            <?php endif; ?>
                                            <a href="<?php echo e(route('admin.extensions.activater',[$extension->product_id])); ?>" class="btn btn-icon btn-success ms-1" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo e(__('locale.Re-Verify License')); ?>">
                                                <i class="bi bi-check-lg"></i>
                                            </a>
                                        <?php else: ?>
                                            <?php if($extension->activated == 0): ?>
                                                <a href="<?php echo e(route('admin.extensions.activater',[$extension->product_id])); ?>" class="btn btn-icon btn-success ms-1" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo e(__('locale.Verify License')); ?>">
                                                    <i class="bi bi-check-lg"></i>
                                                </a>
                                            <?php else: ?>
                                                <a href="<?php echo e(route('admin.extensions.install',[$extension->product_id])); ?>" class="btn btn-icon btn-dark ms-1" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo e(__('locale.Install')); ?>">
                                                    <i class="bi bi-download"></i>
                                                </a>
                                                <a href="<?php echo e(route('admin.extensions.activater',[$extension->product_id])); ?>" class="btn btn-icon btn-success ms-1" data-bs-toggle="tooltip" data-bs-placement="top" title="<?php echo e(__('locale.Re-Verify License')); ?>">
                                                    <i class="bi bi-check-lg"></i>
                                                </a>
                                            <?php endif; ?>
                                        <?php endif; ?>
                                    </td>
                                </tr>
                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>




    
    <div id="editModal" class="modal fade text-start" tabindex="-1" aria-hidden="true" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo e(__('locale.Update Extension')); ?>: <span class="extension-name"></span></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <form method="POST">
                    <?php echo csrf_field(); ?>
                    <div class="modal-body">
                        <div class="col">
                            <label class="col-md-12 control-label fw-bold"><?php echo e(__('locale.Script')); ?> <span class="text-danger">*</span></label>
                            <div class="col-md-12">
                                <textarea name="script" class="form-control" rows="8" placeholder="<?php echo e(__('locale.Paste your script with proper key')); ?>"></textarea>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-dark" data-bs-dismiss="modal"><?php echo e(__('locale.Close')); ?></button>
                        <button type="submit" class="btn btn-primary" id="editBtn"><?php echo e(__('locale.Update')); ?></button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    
    <div id="activateModal" class="modal fade text-start" tabindex="-1" aria-hidden="true" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo e(__('locale.Extension Activation Confirmation')); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <form action="<?php echo e(route('admin.extensions.activate')); ?>" method="POST">
                    <?php echo csrf_field(); ?>
                    <input type="hidden" name="id">
                    <div class="modal-body">
                        <p><?php echo e(__('locale.Are you sure to activate')); ?> <span class="fw-bold extension-name"></span> <?php echo e(__('locale.extension')); ?>?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-dark" data-bs-dismiss="modal"><?php echo e(__('locale.Close')); ?></button>
                        <button type="submit" class="btn btn-primary"><?php echo e(__('locale.Activate')); ?></button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    
    <div id="deactivateModal" class="modal fade text-start" tabindex="-1" aria-hidden="true" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo e(__('locale.Extension Disable Confirmation')); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <form action="<?php echo e(route('admin.extensions.deactivate')); ?>" method="POST">
                    <?php echo csrf_field(); ?>
                    <input type="hidden" name="id">
                    <div class="modal-body">
                        <p><?php echo e(__('locale.Are you sure to disable')); ?> <span class="fw-bold extension-name"></span> <?php echo e(__('locale.extension')); ?>?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-dark" data-bs-dismiss="modal"><?php echo e(__('locale.Close')); ?></button>
                        <button type="submit" class="btn btn-danger"><?php echo e(__('locale.Disable')); ?></button>
                    </div>
                </form>
            </div>
        </div>
    </div>
<?php $__env->stopSection(); ?>

<?php $__env->startSection('page-script'); ?>
<script src="//js.nicedit.com/nicEdit-latest.js" type="text/javascript"></script>
<script type="text/javascript">bkLib.onDomLoaded(nicEditors.allTextAreas);</script>
<?php $__env->stopSection(); ?>
<?php $__env->startPush('script'); ?>
    <script>
        $(function () {
            "use strict";

            $('.activateBtn').on('click', function () {
                var modal = $('#activateModal');
                modal.find('.extension-name').text($(this).data('name'));
                modal.find('input[name=id]').val($(this).data('id'));
            });

            $('.deactivateBtn').on('click', function () {
                var modal = $('#deactivateModal');
                modal.find('.extension-name').text($(this).data('name'));
                modal.find('input[name=id]').val($(this).data('id'));
            });

            $('.editBtn').on('click', function () {
                var modal = $('#editModal');
                var shortcode = $(this).data('shortcode');

                modal.find('.extension-name').text($(this).data('name'));
                modal.find('form').attr('action', $(this).data('action'));

                var html = '';
                $.each(shortcode, function (key, item) {
                    html += `<div class="col">
                        <label class="col-md-12 control-label fw-bold">${item.title}<span class="text-danger">*</span></label>
                        <div class="col-md-12">
                            <input name="${key}" class="form-control" placeholder="--" value="${item.value}" required>
                        </div>
                    </div>`;
                })
                modal.find('.modal-body').html(html);

                modal.modal('show');
            });

            $('.helpBtn').on('click', function () {
                var modal = $('#helpModal');
                var path = "<?php echo e(asset(imagePath()['extensions']['path'])); ?>";
                modal.find('.modal-body').html(`<div class="mb-2">${$(this).data('description')}</div>`);
                if ($(this).data('support') != 'na') {
                    modal.find('.modal-body').append(`<img src="${path}/${$(this).data('support')}">`);
                }
                modal.modal('show');
            });


        });

    </script>
<?php $__env->stopPush(); ?>

<?php echo $__env->make('layouts.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH C:\xampp\htdocs\resources\views/admin/extension/index.blade.php ENDPATH**/ ?>