<?php $__env->startSection('content'); ?>
    <div class="row" id="table-hover-row">
        <div class="col-12">
            <div class="card">
                <div class="card-header d-flex justify-content-between align-items-center">
                    <h4 class="card-title"><?php echo e(__('locale.Tokens')); ?></h4>
                    <div class="card-search"></div>
                </div>
                <div class="table-responsive">
                    <table class="table table-hover custom-data-bs-table">
                        <thead class="table-dark">
                            <tr>
                                <th scope="col"><?php echo e(__('locale.Name')); ?></th>
                                <th scope="col"><?php echo e(__('locale.Symbol')); ?></th>
                                <th scope="col"><?php echo e(__('locale.Price')); ?></th>
                                <th scope="col"><?php echo e(__('locale.Type')); ?></th>
                                <th scope="col"><?php echo e(__('locale.Status')); ?></th>
                                <th scope="col"><?php echo e(__('locale.Action')); ?></th>
                            </tr>
                        </thead>
                        <tbody>
                            <?php $__empty_1 = true; $__currentLoopData = $icos; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $ico): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); $__empty_1 = false; ?>
                                <tr>
                                    <td data-label="<?php echo e(__('locale.Name')); ?>"><?php echo e($ico->name); ?></td>
                                    <td data-label="<?php echo e(__('locale.Symbol')); ?>"><?php echo e($ico->symbol); ?></td>
                                    <td data-label="<?php echo e(__('locale.Price')); ?>">
                                        <div span class="text-danger"><?php echo e(__('locale.Soft Cap')); ?>: <span
                                                class="fw-bold"><?php echo e(getAmount($ico->soft_price)); ?></span></div>
                                        <div span class="text-success"><?php echo e(__('locale.Hard Cap')); ?>: <span
                                                class="fw-bold"><?php echo e(getAmount($ico->hard_price)); ?></span></div>
                                    </td>
                                    <td data-label="<?php echo e(__('locale.Type')); ?>">
                                        <?php if($ico->type == 1): ?>
                                            <span class="badge bg-info"><?php echo e(__('locale.Soft')); ?></span>
                                        <?php elseif($ico->type == 2): ?>
                                            <span class="badge bg-info"><?php echo e(__('locale.Soft/Hard')); ?></span>
                                        <?php endif; ?>
                                    </td>
                                    <td data-label="<?php echo e(__('locale.Status')); ?>">
                                        <?php if($ico->status == 0): ?>
                                            <span class="badge bg-warning"><?php echo e(__('locale.Upcoming')); ?></span>
                                        <?php elseif($ico->status == 1): ?>
                                            <?php if($ico->stage == 0): ?>
                                                <span class="badge bg-success"><?php echo e(__('locale.Soft Cap Started')); ?></span>
                                            <?php elseif($ico->stage == 1): ?>
                                                <span class="badge bg-success"><?php echo e(__('locale.Soft Cap Ended')); ?></span>
                                            <?php elseif($ico->stage == 2): ?>
                                                <span class="badge bg-success"><?php echo e(__('locale.Hard Cap Started')); ?></span>
                                            <?php endif; ?>
                                        <?php elseif($ico->status == 2): ?>
                                            <span class="badge bg-danger"><?php echo e(__('locale.Sale Ended')); ?></span>
                                        <?php elseif($ico->status == 3): ?>
                                            <span class="badge bg-secondary"><?php echo e(__('locale.Canceled')); ?></span>
                                        <?php endif; ?>
                                    </td>
                                    <td data-label="<?php echo e(__('locale.Action')); ?>">
                                        <a href="javascript:void(0)" data-id="<?php echo e($ico->id); ?>"
                                            class="btn btn-icon btn-danger btn-sm removeModalBtn" data-bs-toggle="tooltip"
                                            data-bs-placement="top" title="<?php echo e(__('locale.Remove')); ?>"
                                            onclick="$('#removeModal').find('input[name=id]').val($(this).data('id'));$('#removeModal').modal('show');">
                                            <i class="bi bi-trash"></i>
                                        </a>
                                        <a href="<?php echo e(route('admin.ico.edit', $ico->id)); ?>"
                                            class="btn btn-icon btn-warning btn-sm" data-bs-toggle="tooltip"
                                            data-bs-placement="top" title="<?php echo e(__('locale.Edit')); ?>">
                                            <i class="bi bi-pencil-square"></i>
                                        </a>
                                    </td>
                                </tr>
                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); if ($__empty_1): ?>
                                <tr>
                                    <td class="text-muted text-center" colspan="100%"><?php echo e(__($empty_message)); ?></td>
                                </tr>
                            <?php endif; ?>

                        </tbody>
                    </table><!-- table end -->
                </div>
            </div><!-- card end -->
            <div class="mb-1"><?php echo e(paginateLinks($icos)); ?></div>

        </div>


    </div>

    
    <div id="removeModal" class="modal fade text-start" tabindex="-1" aria-hidden="true" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title"><?php echo e(__('locale.Are you sure want to remove?')); ?></h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <form action="<?php echo e(route('admin.ico.remove')); ?>" method="POST">
                    <?php echo csrf_field(); ?>
                    <div class="modal-body">
                        <input type="hidden" name="id" id="id">
                        <p><span class="fw-bold"></span> <?php echo e(__('locale.ico will be removed.')); ?></p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-dark"
                            data-bs-dismiss="modal"><?php echo e(__('locale.Close')); ?></button>
                        <button type="submit" class="btn btn-danger"><?php echo e(__('locale.Remove')); ?></button>
                    </div>
                </form>
            </div>
        </div>
    </div>
<?php $__env->stopSection(); ?>

<?php $__env->startPush('breadcrumb-plugins'); ?>
    <a href="<?php echo e(route('admin.ico.new')); ?>" class="btn btn-primary btn-sm"><i class="bi bi-plus-lg"></i>
        <?php echo e(__('locale.New Token')); ?></a>
<?php $__env->stopPush(); ?>

<?php echo $__env->make('layouts.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH C:\xampp\htdocs\resources\views/admin/ico/index.blade.php ENDPATH**/ ?>