<?php $__env->startSection('content'); ?>
        <form action="<?php echo e(route('admin.platform.update')); ?>" method="POST" enctype="multipart/form-data">
            <?php echo csrf_field(); ?>
            <div class="card">
                <h4 class="card-header">Trading Settings</h4>
                <div class="card-body">
                    <div class="row g-2">
                        <div class="col-xl-3 col-lg-4 col-sm-6">
                            <div class="border-primary rounded p-1">
                                <div class="d-flex align-items-center justify-content-between">
                                    <label class="me-1" for="binary_status"><?php echo e(__('locale.Binary Trading')); ?></label>
                                    <input class="form-check-input" type="checkbox" data-bs-toggle="toggle"
                                        data-onstyle="success" data-offstyle="danger" data-on="<?php echo e(__('locale.Active')); ?>"
                                        data-off="<?php echo e(__('locale.Inactive')); ?>" name="binary_status" id="binary_status"
                                        <?php if($platform->trading->binary_status): ?> checked <?php endif; ?>>
                                </div>
                                <small class="text-warning">Disabled = Crypto Exchange becomes the default dashboard</small>
                            </div>
                        </div>
                        <div class="col-xl-3 col-lg-4 col-sm-6">
                            <div class="border-primary rounded p-1">
                                <div class="d-flex align-items-center justify-content-between">
                                    <label class="me-1" for="kyc_status"><?php echo e(__('locale.KYC')); ?></label>
                                    <input class="form-check-input" type="checkbox" data-bs-toggle="toggle"
                                        data-onstyle="success" data-offstyle="danger" data-on="<?php echo e(__('locale.Active')); ?>"
                                        data-off="<?php echo e(__('locale.Inactive')); ?>" name="kyc_status" id="kyc_status" <?php if($platform->kyc->kyc_status): ?>
                                    checked <?php endif; ?>>
                                </div>
                                <small class="text-warning">Disabled = Client directly start trading without any verifications</small>
                            </div>
                        </div>
                        <div class="col-xl-3 col-lg-4 col-sm-6">
                            <div class="border-primary rounded p-1">
                                <div class="d-flex align-items-center justify-content-between">
                                    <label class="me-1"
                                        for="frontend_status"><?php echo e(__('locale.Frontend')); ?></label>
                                    <input class="form-check-input" type="checkbox" data-bs-toggle="toggle"
                                        data-onstyle="success" data-offstyle="danger" data-on="<?php echo e(__('locale.Active')); ?>"
                                        data-off="<?php echo e(__('locale.Inactive')); ?>" name="frontend_status" id="frontend_status"
                                        <?php if($platform->frontend->frontend_status): ?> checked <?php endif; ?>>
                                </div>
                                <small class="text-warning">Disabled = Login page becomes the homepage</small>
                            </div>
                        </div>
                        <div class="col-xl-3 col-lg-4 col-sm-6">
                            <div class="border-primary rounded p-1">
                                <div class="d-flex align-items-center justify-content-between">
                                    <label class="me-1"
                                        for="preloader"><?php echo e(__('locale.Frontend Preloader')); ?></label>
                                    <input class="form-check-input" type="checkbox" data-bs-toggle="toggle"
                                        data-onstyle="success" data-offstyle="danger" data-on="<?php echo e(__('locale.Active')); ?>"
                                        data-off="<?php echo e(__('locale.Inactive')); ?>" name="preloader" id="preloader"
                                        <?php if($platform->frontend->preloader): ?> checked <?php endif; ?>>
                                </div>
                                <small class="text-warning">Disabled = directly show frontend without waiting</small>
                            </div>
                        </div>
                        <div class="col-xl-3 col-lg-4 col-sm-6">
                            <div class="border-primary rounded p-1">
                                <div class="d-flex align-items-center justify-content-between">
                                    <label class="me-1"
                                        for="pair_prices"><?php echo e(__('locale.Trading Page Pair Prices')); ?></label>
                                    <input class="form-check-input" type="checkbox" data-bs-toggle="toggle"
                                        data-onstyle="success" data-offstyle="danger" data-on="<?php echo e(__('locale.Active')); ?>"
                                        data-off="<?php echo e(__('locale.Inactive')); ?>" name="pair_prices" id="pair_prices"
                                        <?php if($platform->trading->pair_prices ?? ''): ?> checked <?php endif; ?>>
                                </div>
                                <small class="text-warning">Disabled = No pairs live price updates, faster loading</small>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="card">
                <h4 class="card-header">Bot Settings</h4>
                <div class="card-body">
                    <div class="row g-2">
                        <?php if($bot->installed == 1): ?>
                        <div class="col-xl-3 col-lg-4 col-sm-6">
                            <div class="border-primary rounded p-1">
                                <div class="d-flex align-items-center justify-content-between">
                                    <label class="me-1"
                                        for="data"><?php echo e(__('locale.Bot Trader Fake/Real Data')); ?></label>
                                    <input class="form-check-input" type="checkbox" data-bs-toggle="toggle"
                                        data-onstyle="success" data-offstyle="danger" data-on="<?php echo e(__('locale.Active')); ?>"
                                        data-off="<?php echo e(__('locale.Inactive')); ?>" name="data" id="data"
                                        <?php if($platform->bot->data): ?> checked <?php endif; ?>>
                                </div>
                                <small class="text-warning">Enabled = Fake Data, Disabled = Real Data</small>
                            </div>
                        </div>
                        <?php endif; ?>
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-body text-end">
                    <div class="col">
                        <button type="submit" class="btn btn-primary"><?php echo e(__('locale.Update')); ?></button>
                    </div>
                </div>
            </div>
        </form>
<?php $__env->stopSection(); ?>


<?php echo $__env->make('layouts.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH C:\xampp\htdocs\resources\views/admin/setting/platform.blade.php ENDPATH**/ ?>