<?php

namespace ccxt;

// PLEASE DO NOT EDIT THIS FILE, IT IS GENERATED AND WILL BE OVERWRITTEN:
// https://github.com/ccxt/ccxt/blob/master/CONTRIBUTING.md#how-to-contribute-code

use Exception; // a common import
use \ccxt\ExchangeError;
use \ccxt\ArgumentsRequired;
use \ccxt\BadRequest;
use \ccxt\BadSymbol;

class bitget extends Exchange {

    public function describe() {
        return $this->deep_extend(parent::describe (), array(
            'id' => 'bitget',
            'name' => 'Bitget',
            'countries' => array( 'SG' ),
            'version' => 'v1',
            'rateLimit' => 50, // up to 3000 requests per 5 minutes ≈ 600 requests per minute ≈ 10 requests per second ≈ 100 ms
            'has' => array(
                'CORS' => null,
                'spot' => true,
                'margin' => false,
                'swap' => true,
                'future' => false,
                'option' => false,
                'addMargin' => true,
                'cancelOrder' => true,
                'cancelOrders' => true,
                'createOrder' => true,
                'createReduceOnlyOrder' => false,
                'fetchAccounts' => false,
                'fetchBalance' => true,
                'fetchBorrowRate' => false,
                'fetchBorrowRateHistories' => false,
                'fetchBorrowRateHistory' => false,
                'fetchBorrowRates' => false,
                'fetchBorrowRatesPerSymbol' => false,
                'fetchClosedOrders' => true,
                'fetchCurrencies' => true,
                'fetchDeposits' => false,
                'fetchFundingHistory' => false,
                'fetchFundingRate' => true,
                'fetchFundingRateHistory' => true,
                'fetchFundingRates' => false,
                'fetchIndexOHLCV' => false,
                'fetchLedger' => true,
                'fetchLeverage' => true,
                'fetchLeverageTiers' => false,
                'fetchMarketLeverageTiers' => false,
                'fetchMarkets' => true,
                'fetchMarkOHLCV' => false,
                'fetchMyTrades' => true,
                'fetchOHLCV' => true,
                'fetchOpenOrders' => true,
                'fetchOrder' => true,
                'fetchOrderBook' => true,
                'fetchOrderTrades' => true,
                'fetchPosition' => true,
                'fetchPositions' => true,
                'fetchPositionsRisk' => false,
                'fetchPremiumIndexOHLCV' => false,
                'fetchTicker' => true,
                'fetchTickers' => true,
                'fetchTime' => true,
                'fetchTrades' => true,
                'fetchTradingFee' => true,
                'fetchTradingFees' => true,
                'fetchTransfer' => false,
                'fetchTransfers' => null,
                'fetchWithdrawal' => false,
                'fetchWithdrawals' => false,
                'reduceMargin' => true,
                'setLeverage' => true,
                'setMarginMode' => true,
                'setPositionMode' => false,
                'transfer' => false,
                'withdraw' => false,
            ),
            'timeframes' => array(
                'spot' => array(
                    '1m' => '1min',
                    '5m' => '5min',
                    '15m' => '15min',
                    '30m' => '30min',
                    '1h' => '1h',
                    '4h' => '4h',
                    '12h' => '12h',
                    '1d' => '1day',
                    '1w' => '7day',  // not documented on the website
                ),
                'swap' => array(
                    '1m' => '60',
                    '5m' => '300',
                    '15m' => '900',
                    '30m' => '1800',
                    '1h' => '3600',
                    '4h' => '14400',
                    '12h' => '43200',
                    '1d' => '86400',
                    '1w' => '604800',
                ),
            ),
            'hostname' => 'bitget.com',
            'urls' => array(
                'logo' => 'https://user-images.githubusercontent.com/51840849/88317935-a8a21c80-cd22-11ea-8e2b-4b9fac5975eb.jpg',
                'api' => array(
                    'spot' => 'https://api.{hostname}',
                    'mix' => 'https://api.{hostname}',
                ),
                'www' => 'https://www.bitget.com',
                'doc' => array(
                    'https://bitgetlimited.github.io/apidoc/en/swap',
                    'https://bitgetlimited.github.io/apidoc/en/spot',
                ),
                'fees' => 'https://www.bitget.cc/zh-CN/rate?tab=1',
                'test' => array(
                    'rest' => 'https://testnet.bitget.com',
                ),
                'referral' => 'https://www.bitget.com/expressly?languageType=0&channelCode=ccxt&vipCode=tg9j',
            ),
            'api' => array(
                'public' => array(
                    'spot' => array(
                        'get' => array(
                            'public/time' => 1,
                            'public/currencies' => 1,
                            'public/products' => 1,
                            'public/product' => 1,
                            'market/ticker' => 1,
                            'market/tickers' => 1,
                            'market/fills' => 1,
                            'market/candles' => 1,
                            'market/depth' => 1,
                        ),
                    ),
                    'mix' => array(
                        'get' => array(
                            'market/contracts' => 1,
                            'market/depth' => 1,
                            'market/ticker' => 1,
                            'market/tickers' => 1,
                            'market/fills' => 1,
                            'market/candles' => 1,
                            'market/index' => 1,
                            'market/funding-time' => 1,
                            'market/history-fundRate' => 1,
                            'market/current-fundRate' => 1,
                            'market/open-interest' => 1,
                            'market/mark-price' => 1,
                            'market/symbol-leverage' => 1,
                        ),
                    ),
                ),
                'private' => array(
                    'spot' => array(
                        'get' => array(
                            'account/assets' => 2,
                            'account/transferRecords' => 1,
                        ),
                        'post' => array(
                            'account/bills' => 2,
                            'trade/orders' => 2,
                            'trade/batch-orders' => 4,
                            'trade/cancel-order' => 2,
                            'trade/cancel-batch-orders' => 4,
                            'trade/orderInfo' => 1,
                            'trade/open-orders' => 1,
                            'trade/history' => 1,
                            'trade/fills' => 1,
                        ),
                    ),
                    'mix' => array(
                        'get' => array(
                            'account/account' => 2,
                            'account/accounts' => 2,
                            'account/open-count' => 1,
                            'order/current' => 2,
                            'order/history' => 2,
                            'order/detail' => 2,
                            'order/fills' => 2,
                            'plan/currentPlan' => 2,
                            'plan/historyPlan' => 2,
                            'position/singlePosition' => 2,
                            'position/allPosition' => 2,
                            'trace/currentTrack' => 2,
                            'trace/followerOrder' => 2,
                            'trace/historyTrack' => 2,
                            'trace/summary' => 2,
                            'trace/profitSettleTokenIdGroup' => 2,
                            'trace/profitDateGroupList' => 2,
                            'trade/profitDateList' => 2,
                            'trace/waitProfitDateList' => 2,
                            'trace/traderSymbols' => 2,
                        ),
                        'post' => array(
                            'account/setLeverage' => 8,
                            'account/setMargin' => 8,
                            'account/setMarginMode' => 8,
                            'order/placeOrder' => 2,
                            'order/batch-orders' => 2,
                            'order/cancel-order' => 2,
                            'order/cancel-batch-orders' => 2,
                            'plan/placePlan' => 2,
                            'plan/modifyPlan' => 2,
                            'plan/modifyPlanPreset' => 2,
                            'plan/placeTPSL' => 2,
                            'plan/modifyTPSLPlan' => 2,
                            'plan/cancelPlan' => 2,
                            'trace/closeTrackOrder' => 2,
                            'trace/setUpCopySymbols' => 2,
                        ),
                    ),
                ),
            ),
            'fees' => array(
                'spot' => array(
                    'taker' => $this->parse_number('0.002'),
                    'maker' => $this->parse_number('0.002'),
                ),
                'swap' => array(
                    'taker' => $this->parse_number('0.0006'),
                    'maker' => $this->parse_number('0.0004'),
                ),
            ),
            'requiredCredentials' => array(
                'apiKey' => true,
                'secret' => true,
                'password' => true,
            ),
            'exceptions' => array(
                // http error codes
                // 400 Bad Request — Invalid request format
                // 401 Unauthorized — Invalid API Key
                // 403 Forbidden — You do not have access to the requested resource
                // 404 Not Found
                // 500 Internal Server Error — We had a problem with our server
                'exact' => array(
                    '1' => '\\ccxt\\ExchangeError', // array( "code" => 1, "message" => "System error" )
                    // undocumented
                    'failure to get a peer from the ring-balancer' => '\\ccxt\\ExchangeNotAvailable', // array( "message" => "failure to get a peer from the ring-balancer" )
                    '4010' => '\\ccxt\\PermissionDenied', // array( "code" => 4010, "message" => "For the security of your funds, withdrawals are not permitted within 24 hours after changing fund password  / mobile number / Google Authenticator settings " )
                    // common
                    // '0' => '\\ccxt\\ExchangeError', // 200 successful,when the order placement / cancellation / operation is successful
                    '4001' => '\\ccxt\\ExchangeError', // no data received in 30s
                    '4002' => '\\ccxt\\ExchangeError', // Buffer full. cannot write data
                    // --------------------------------------------------------
                    '30001' => '\\ccxt\\AuthenticationError', // array( "code" => 30001, "message" => 'request header "OK_ACCESS_KEY" cannot be blank')
                    '30002' => '\\ccxt\\AuthenticationError', // array( "code" => 30002, "message" => 'request header "OK_ACCESS_SIGN" cannot be blank')
                    '30003' => '\\ccxt\\AuthenticationError', // array( "code" => 30003, "message" => 'request header "OK_ACCESS_TIMESTAMP" cannot be blank')
                    '30004' => '\\ccxt\\AuthenticationError', // array( "code" => 30004, "message" => 'request header "OK_ACCESS_PASSPHRASE" cannot be blank')
                    '30005' => '\\ccxt\\InvalidNonce', // array( "code" => 30005, "message" => "invalid OK_ACCESS_TIMESTAMP" )
                    '30006' => '\\ccxt\\AuthenticationError', // array( "code" => 30006, "message" => "invalid OK_ACCESS_KEY" )
                    '30007' => '\\ccxt\\BadRequest', // array( "code" => 30007, "message" => 'invalid Content_Type, please use "application/json" format')
                    '30008' => '\\ccxt\\RequestTimeout', // array( "code" => 30008, "message" => "timestamp request expired" )
                    '30009' => '\\ccxt\\ExchangeError', // array( "code" => 30009, "message" => "system error" )
                    '30010' => '\\ccxt\\AuthenticationError', // array( "code" => 30010, "message" => "API validation failed" )
                    '30011' => '\\ccxt\\PermissionDenied', // array( "code" => 30011, "message" => "invalid IP" )
                    '30012' => '\\ccxt\\AuthenticationError', // array( "code" => 30012, "message" => "invalid authorization" )
                    '30013' => '\\ccxt\\AuthenticationError', // array( "code" => 30013, "message" => "invalid sign" )
                    '30014' => '\\ccxt\\DDoSProtection', // array( "code" => 30014, "message" => "request too frequent" )
                    '30015' => '\\ccxt\\AuthenticationError', // array( "code" => 30015, "message" => 'request header "OK_ACCESS_PASSPHRASE" incorrect')
                    '30016' => '\\ccxt\\ExchangeError', // array( "code" => 30015, "message" => "you are using v1 apiKey, please use v1 endpoint. If you would like to use v3 endpoint, please subscribe to v3 apiKey" )
                    '30017' => '\\ccxt\\ExchangeError', // array( "code" => 30017, "message" => "apikey's broker id does not match" )
                    '30018' => '\\ccxt\\ExchangeError', // array( "code" => 30018, "message" => "apikey's domain does not match" )
                    '30019' => '\\ccxt\\ExchangeNotAvailable', // array( "code" => 30019, "message" => "Api is offline or unavailable" )
                    '30020' => '\\ccxt\\BadRequest', // array( "code" => 30020, "message" => "body cannot be blank" )
                    '30021' => '\\ccxt\\BadRequest', // array( "code" => 30021, "message" => "Json data format error" ), array( "code" => 30021, "message" => "json data format error" )
                    '30022' => '\\ccxt\\PermissionDenied', // array( "code" => 30022, "message" => "Api has been frozen" )
                    '30023' => '\\ccxt\\BadRequest', // array( "code" => 30023, "message" => "{0} parameter cannot be blank" )
                    '30024' => '\\ccxt\\BadSymbol', // array("code":30024,"message":"\"instrument_id\" is an invalid parameter")
                    '30025' => '\\ccxt\\BadRequest', // array( "code" => 30025, "message" => "{0} parameter category error" )
                    '30026' => '\\ccxt\\DDoSProtection', // array( "code" => 30026, "message" => "requested too frequent" )
                    '30027' => '\\ccxt\\AuthenticationError', // array( "code" => 30027, "message" => "login failure" )
                    '30028' => '\\ccxt\\PermissionDenied', // array( "code" => 30028, "message" => "unauthorized execution" )
                    '30029' => '\\ccxt\\AccountSuspended', // array( "code" => 30029, "message" => "account suspended" )
                    '30030' => '\\ccxt\\ExchangeError', // array( "code" => 30030, "message" => "endpoint request failed. Please try again" )
                    '30031' => '\\ccxt\\BadRequest', // array( "code" => 30031, "message" => "token does not exist" )
                    '30032' => '\\ccxt\\BadSymbol', // array( "code" => 30032, "message" => "pair does not exist" )
                    '30033' => '\\ccxt\\BadRequest', // array( "code" => 30033, "message" => "exchange domain does not exist" )
                    '30034' => '\\ccxt\\ExchangeError', // array( "code" => 30034, "message" => "exchange ID does not exist" )
                    '30035' => '\\ccxt\\ExchangeError', // array( "code" => 30035, "message" => "trading is not supported in this website" )
                    '30036' => '\\ccxt\\ExchangeError', // array( "code" => 30036, "message" => "no relevant data" )
                    '30037' => '\\ccxt\\ExchangeNotAvailable', // array( "code" => 30037, "message" => "endpoint is offline or unavailable" )
                    // '30038' => '\\ccxt\\AuthenticationError', // array( "code" => 30038, "message" => "user does not exist" )
                    '30038' => '\\ccxt\\OnMaintenance', // array("client_oid":"","code":"30038","error_code":"30038","error_message":"Matching engine is being upgraded. Please try in about 1 minute.","message":"Matching engine is being upgraded. Please try in about 1 minute.","order_id":"-1","result":false)
                    // futures
                    '32001' => '\\ccxt\\AccountSuspended', // array( "code" => 32001, "message" => "futures account suspended" )
                    '32002' => '\\ccxt\\PermissionDenied', // array( "code" => 32002, "message" => "futures account does not exist" )
                    '32003' => '\\ccxt\\CancelPending', // array( "code" => 32003, "message" => "canceling, please wait" )
                    '32004' => '\\ccxt\\ExchangeError', // array( "code" => 32004, "message" => "you have no unfilled orders" )
                    '32005' => '\\ccxt\\InvalidOrder', // array( "code" => 32005, "message" => "max order quantity" )
                    '32006' => '\\ccxt\\InvalidOrder', // array( "code" => 32006, "message" => "the order price or trigger price exceeds USD 1 million" )
                    '32007' => '\\ccxt\\InvalidOrder', // array( "code" => 32007, "message" => "leverage level must be the same for orders on the same side of the contract" )
                    '32008' => '\\ccxt\\InvalidOrder', // array( "code" => 32008, "message" => "Max. positions to open (cross margin)" )
                    '32009' => '\\ccxt\\InvalidOrder', // array( "code" => 32009, "message" => "Max. positions to open (fixed margin)" )
                    '32010' => '\\ccxt\\ExchangeError', // array( "code" => 32010, "message" => "leverage cannot be changed with open positions" )
                    '32011' => '\\ccxt\\ExchangeError', // array( "code" => 32011, "message" => "futures status error" )
                    '32012' => '\\ccxt\\ExchangeError', // array( "code" => 32012, "message" => "futures order update error" )
                    '32013' => '\\ccxt\\ExchangeError', // array( "code" => 32013, "message" => "token type is blank" )
                    '32014' => '\\ccxt\\ExchangeError', // array( "code" => 32014, "message" => "your number of contracts closing is larger than the number of contracts available" )
                    '32015' => '\\ccxt\\ExchangeError', // array( "code" => 32015, "message" => "margin ratio is lower than 100% before opening positions" )
                    '32016' => '\\ccxt\\ExchangeError', // array( "code" => 32016, "message" => "margin ratio is lower than 100% after opening position" )
                    '32017' => '\\ccxt\\ExchangeError', // array( "code" => 32017, "message" => "no BBO" )
                    '32018' => '\\ccxt\\ExchangeError', // array( "code" => 32018, "message" => "the order quantity is less than 1, please try again" )
                    '32019' => '\\ccxt\\ExchangeError', // array( "code" => 32019, "message" => "the order price deviates from the price of the previous minute by more than 3%" )
                    '32020' => '\\ccxt\\ExchangeError', // array( "code" => 32020, "message" => "the price is not in the range of the price limit" )
                    '32021' => '\\ccxt\\ExchangeError', // array( "code" => 32021, "message" => "leverage error" )
                    '32022' => '\\ccxt\\ExchangeError', // array( "code" => 32022, "message" => "this function is not supported in your country or region according to the regulations" )
                    '32023' => '\\ccxt\\ExchangeError', // array( "code" => 32023, "message" => "this account has outstanding loan" )
                    '32024' => '\\ccxt\\ExchangeError', // array( "code" => 32024, "message" => "order cannot be placed during delivery" )
                    '32025' => '\\ccxt\\ExchangeError', // array( "code" => 32025, "message" => "order cannot be placed during settlement" )
                    '32026' => '\\ccxt\\ExchangeError', // array( "code" => 32026, "message" => "your account is restricted from opening positions" )
                    '32027' => '\\ccxt\\ExchangeError', // array( "code" => 32027, "message" => "cancelled over 20 orders" )
                    '32028' => '\\ccxt\\AccountSuspended', // array( "code" => 32028, "message" => "account is suspended and liquidated" )
                    '32029' => '\\ccxt\\ExchangeError', // array( "code" => 32029, "message" => "order info does not exist" )
                    '32030' => '\\ccxt\\InvalidOrder', // The order cannot be cancelled
                    '32031' => '\\ccxt\\ArgumentsRequired', // client_oid or order_id is required.
                    '32038' => '\\ccxt\\AuthenticationError', // User does not exist
                    '32040' => '\\ccxt\\ExchangeError', // User have open contract orders or position
                    '32044' => '\\ccxt\\ExchangeError', // array( "code" => 32044, "message" => "The margin ratio after submitting this order is lower than the minimum requirement ({0}) for your tier." )
                    '32045' => '\\ccxt\\ExchangeError', // String of commission over 1 million
                    '32046' => '\\ccxt\\ExchangeError', // Each user can hold up to 10 trade plans at the same time
                    '32047' => '\\ccxt\\ExchangeError', // system error
                    '32048' => '\\ccxt\\InvalidOrder', // Order strategy track range error
                    '32049' => '\\ccxt\\ExchangeError', // Each user can hold up to 10 track plans at the same time
                    '32050' => '\\ccxt\\InvalidOrder', // Order strategy rang error
                    '32051' => '\\ccxt\\InvalidOrder', // Order strategy ice depth error
                    '32052' => '\\ccxt\\ExchangeError', // String of commission over 100 thousand
                    '32053' => '\\ccxt\\ExchangeError', // Each user can hold up to 6 ice plans at the same time
                    '32057' => '\\ccxt\\ExchangeError', // The order price is zero. Market-close-all function cannot be executed
                    '32054' => '\\ccxt\\ExchangeError', // Trade not allow
                    '32055' => '\\ccxt\\InvalidOrder', // cancel order error
                    '32056' => '\\ccxt\\ExchangeError', // iceberg per order average should between {0}-{1} contracts
                    '32058' => '\\ccxt\\ExchangeError', // Each user can hold up to 6 initiative plans at the same time
                    '32059' => '\\ccxt\\InvalidOrder', // Total amount should exceed per order amount
                    '32060' => '\\ccxt\\InvalidOrder', // Order strategy type error
                    '32061' => '\\ccxt\\InvalidOrder', // Order strategy initiative limit error
                    '32062' => '\\ccxt\\InvalidOrder', // Order strategy initiative range error
                    '32063' => '\\ccxt\\InvalidOrder', // Order strategy initiative rate error
                    '32064' => '\\ccxt\\ExchangeError', // Time Stringerval of orders should set between 5-120s
                    '32065' => '\\ccxt\\ExchangeError', // Close amount exceeds the limit of Market-close-all (999 for BTC, and 9999 for the rest tokens)
                    '32066' => '\\ccxt\\ExchangeError', // You have open orders. Please cancel all open orders before changing your leverage level.
                    '32067' => '\\ccxt\\ExchangeError', // Account equity < required margin in this setting. Please adjust your leverage level again.
                    '32068' => '\\ccxt\\ExchangeError', // The margin for this position will fall short of the required margin in this setting. Please adjust your leverage level or increase your margin to proceed.
                    '32069' => '\\ccxt\\ExchangeError', // Target leverage level too low. Your account balance is insufficient to cover the margin required. Please adjust the leverage level again.
                    '32070' => '\\ccxt\\ExchangeError', // Please check open position or unfilled order
                    '32071' => '\\ccxt\\ExchangeError', // Your current liquidation mode does not support this action.
                    '32072' => '\\ccxt\\ExchangeError', // The highest available margin for your order’s tier is {0}. Please edit your margin and place a new order.
                    '32073' => '\\ccxt\\ExchangeError', // The action does not apply to the token
                    '32074' => '\\ccxt\\ExchangeError', // The number of contracts of your position, open orders, and the current order has exceeded the maximum order limit of this asset.
                    '32075' => '\\ccxt\\ExchangeError', // Account risk rate breach
                    '32076' => '\\ccxt\\ExchangeError', // Liquidation of the holding position(s) at market price will require cancellation of all pending close orders of the contracts.
                    '32077' => '\\ccxt\\ExchangeError', // Your margin for this asset in futures account is insufficient and the position has been taken over for liquidation. (You will not be able to place orders, close positions, transfer funds, or add margin during this period of time. Your account will be restored after the liquidation is complete.)
                    '32078' => '\\ccxt\\ExchangeError', // Please cancel all open orders before switching the liquidation mode(Please cancel all open orders before switching the liquidation mode)
                    '32079' => '\\ccxt\\ExchangeError', // Your open positions are at high risk.(Please add margin or reduce positions before switching the mode)
                    '32080' => '\\ccxt\\ExchangeError', // Funds cannot be transferred out within 30 minutes after futures settlement
                    '32083' => '\\ccxt\\ExchangeError', // The number of contracts should be a positive multiple of %%. Please place your order again
                    // token and margin trading
                    '33001' => '\\ccxt\\PermissionDenied', // array( "code" => 33001, "message" => "margin account for this pair is not enabled yet" )
                    '33002' => '\\ccxt\\AccountSuspended', // array( "code" => 33002, "message" => "margin account for this pair is suspended" )
                    '33003' => '\\ccxt\\InsufficientFunds', // array( "code" => 33003, "message" => "no loan balance" )
                    '33004' => '\\ccxt\\ExchangeError', // array( "code" => 33004, "message" => "loan amount cannot be smaller than the minimum limit" )
                    '33005' => '\\ccxt\\ExchangeError', // array( "code" => 33005, "message" => "repayment amount must exceed 0" )
                    '33006' => '\\ccxt\\ExchangeError', // array( "code" => 33006, "message" => "loan order not found" )
                    '33007' => '\\ccxt\\ExchangeError', // array( "code" => 33007, "message" => "status not found" )
                    '33008' => '\\ccxt\\InsufficientFunds', // array( "code" => 33008, "message" => "loan amount cannot exceed the maximum limit" )
                    '33009' => '\\ccxt\\ExchangeError', // array( "code" => 33009, "message" => "user ID is blank" )
                    '33010' => '\\ccxt\\ExchangeError', // array( "code" => 33010, "message" => "you cannot cancel an order during session 2 of call auction" )
                    '33011' => '\\ccxt\\ExchangeError', // array( "code" => 33011, "message" => "no new market data" )
                    '33012' => '\\ccxt\\ExchangeError', // array( "code" => 33012, "message" => "order cancellation failed" )
                    '33013' => '\\ccxt\\InvalidOrder', // array( "code" => 33013, "message" => "order placement failed" )
                    '33014' => '\\ccxt\\OrderNotFound', // array( "code" => 33014, "message" => "order does not exist" )
                    '33015' => '\\ccxt\\InvalidOrder', // array( "code" => 33015, "message" => "exceeded maximum limit" )
                    '33016' => '\\ccxt\\ExchangeError', // array( "code" => 33016, "message" => "margin trading is not open for this token" )
                    '33017' => '\\ccxt\\InsufficientFunds', // array( "code" => 33017, "message" => "insufficient balance" )
                    '33018' => '\\ccxt\\ExchangeError', // array( "code" => 33018, "message" => "this parameter must be smaller than 1" )
                    '33020' => '\\ccxt\\ExchangeError', // array( "code" => 33020, "message" => "request not supported" )
                    '33021' => '\\ccxt\\BadRequest', // array( "code" => 33021, "message" => "token and the pair do not match" )
                    '33022' => '\\ccxt\\InvalidOrder', // array( "code" => 33022, "message" => "pair and the order do not match" )
                    '33023' => '\\ccxt\\ExchangeError', // array( "code" => 33023, "message" => "you can only place market orders during call auction" )
                    '33024' => '\\ccxt\\InvalidOrder', // array( "code" => 33024, "message" => "trading amount too small" )
                    '33025' => '\\ccxt\\InvalidOrder', // array( "code" => 33025, "message" => "base token amount is blank" )
                    '33026' => '\\ccxt\\ExchangeError', // array( "code" => 33026, "message" => "transaction completed" )
                    '33027' => '\\ccxt\\InvalidOrder', // array( "code" => 33027, "message" => "cancelled order or order cancelling" )
                    '33028' => '\\ccxt\\InvalidOrder', // array( "code" => 33028, "message" => "the decimal places of the trading price exceeded the limit" )
                    '33029' => '\\ccxt\\InvalidOrder', // array( "code" => 33029, "message" => "the decimal places of the trading size exceeded the limit" )
                    '33034' => '\\ccxt\\ExchangeError', // array( "code" => 33034, "message" => "You can only place limit order after Call Auction has started" )
                    '33035' => '\\ccxt\\ExchangeError', // This type of order cannot be canceled(This type of order cannot be canceled)
                    '33036' => '\\ccxt\\ExchangeError', // Exceeding the limit of entrust order
                    '33037' => '\\ccxt\\ExchangeError', // The buy order price should be lower than 130% of the trigger price
                    '33038' => '\\ccxt\\ExchangeError', // The sell order price should be higher than 70% of the trigger price
                    '33039' => '\\ccxt\\ExchangeError', // The limit of callback rate is 0 < x <= 5%
                    '33040' => '\\ccxt\\ExchangeError', // The trigger price of a buy order should be lower than the latest transaction price
                    '33041' => '\\ccxt\\ExchangeError', // The trigger price of a sell order should be higher than the latest transaction price
                    '33042' => '\\ccxt\\ExchangeError', // The limit of price variance is 0 < x <= 1%
                    '33043' => '\\ccxt\\ExchangeError', // The total amount must be larger than 0
                    '33044' => '\\ccxt\\ExchangeError', // The average amount should be 1/1000 * total amount <= x <= total amount
                    '33045' => '\\ccxt\\ExchangeError', // The price should not be 0, including trigger price, order price, and price limit
                    '33046' => '\\ccxt\\ExchangeError', // Price variance should be 0 < x <= 1%
                    '33047' => '\\ccxt\\ExchangeError', // Sweep ratio should be 0 < x <= 100%
                    '33048' => '\\ccxt\\ExchangeError', // Per order limit => Total amount/1000 < x <= Total amount
                    '33049' => '\\ccxt\\ExchangeError', // Total amount should be X > 0
                    '33050' => '\\ccxt\\ExchangeError', // Time interval should be 5 <= x <= 120s
                    '33051' => '\\ccxt\\ExchangeError', // cancel order number not higher limit => plan and track entrust no more than 10, ice and time entrust no more than 6
                    '33059' => '\\ccxt\\BadRequest', // array( "code" => 33059, "message" => "client_oid or order_id is required" )
                    '33060' => '\\ccxt\\BadRequest', // array( "code" => 33060, "message" => "Only fill in either parameter client_oid or order_id" )
                    '33061' => '\\ccxt\\ExchangeError', // Value of a single market price order cannot exceed 100,000 USD
                    '33062' => '\\ccxt\\ExchangeError', // The leverage ratio is too high. The borrowed position has exceeded the maximum position of this leverage ratio. Please readjust the leverage ratio
                    '33063' => '\\ccxt\\ExchangeError', // Leverage multiple is too low, there is insufficient margin in the account, please readjust the leverage ratio
                    '33064' => '\\ccxt\\ExchangeError', // The setting of the leverage ratio cannot be less than 2, please readjust the leverage ratio
                    '33065' => '\\ccxt\\ExchangeError', // Leverage ratio exceeds maximum leverage ratio, please readjust leverage ratio
                    // account
                    '21009' => '\\ccxt\\ExchangeError', // Funds cannot be transferred out within 30 minutes after swap settlement(Funds cannot be transferred out within 30 minutes after swap settlement)
                    '34001' => '\\ccxt\\PermissionDenied', // array( "code" => 34001, "message" => "withdrawal suspended" )
                    '34002' => '\\ccxt\\InvalidAddress', // array( "code" => 34002, "message" => "please add a withdrawal address" )
                    '34003' => '\\ccxt\\ExchangeError', // array( "code" => 34003, "message" => "sorry, this token cannot be withdrawn to xx at the moment" )
                    '34004' => '\\ccxt\\ExchangeError', // array( "code" => 34004, "message" => "withdrawal fee is smaller than minimum limit" )
                    '34005' => '\\ccxt\\ExchangeError', // array( "code" => 34005, "message" => "withdrawal fee exceeds the maximum limit" )
                    '34006' => '\\ccxt\\ExchangeError', // array( "code" => 34006, "message" => "withdrawal amount is lower than the minimum limit" )
                    '34007' => '\\ccxt\\ExchangeError', // array( "code" => 34007, "message" => "withdrawal amount exceeds the maximum limit" )
                    '34008' => '\\ccxt\\InsufficientFunds', // array( "code" => 34008, "message" => "insufficient balance" )
                    '34009' => '\\ccxt\\ExchangeError', // array( "code" => 34009, "message" => "your withdrawal amount exceeds the daily limit" )
                    '34010' => '\\ccxt\\ExchangeError', // array( "code" => 34010, "message" => "transfer amount must be larger than 0" )
                    '34011' => '\\ccxt\\ExchangeError', // array( "code" => 34011, "message" => "conditions not met" )
                    '34012' => '\\ccxt\\ExchangeError', // array( "code" => 34012, "message" => "the minimum withdrawal amount for NEO is 1, and the amount must be an integer" )
                    '34013' => '\\ccxt\\ExchangeError', // array( "code" => 34013, "message" => "please transfer" )
                    '34014' => '\\ccxt\\ExchangeError', // array( "code" => 34014, "message" => "transfer limited" )
                    '34015' => '\\ccxt\\ExchangeError', // array( "code" => 34015, "message" => "subaccount does not exist" )
                    '34016' => '\\ccxt\\PermissionDenied', // array( "code" => 34016, "message" => "transfer suspended" )
                    '34017' => '\\ccxt\\AccountSuspended', // array( "code" => 34017, "message" => "account suspended" )
                    '34018' => '\\ccxt\\AuthenticationError', // array( "code" => 34018, "message" => "incorrect trades password" )
                    '34019' => '\\ccxt\\PermissionDenied', // array( "code" => 34019, "message" => "please bind your email before withdrawal" )
                    '34020' => '\\ccxt\\PermissionDenied', // array( "code" => 34020, "message" => "please bind your funds password before withdrawal" )
                    '34021' => '\\ccxt\\InvalidAddress', // array( "code" => 34021, "message" => "Not verified address" )
                    '34022' => '\\ccxt\\ExchangeError', // array( "code" => 34022, "message" => "Withdrawals are not available for sub accounts" )
                    '34023' => '\\ccxt\\PermissionDenied', // array( "code" => 34023, "message" => "Please enable futures trading before transferring your funds" )
                    '34026' => '\\ccxt\\ExchangeError', // transfer too frequently(transfer too frequently)
                    '34036' => '\\ccxt\\ExchangeError', // Parameter is incorrect, please refer to API documentation
                    '34037' => '\\ccxt\\ExchangeError', // Get the sub-account balance interface, account type is not supported
                    '34038' => '\\ccxt\\ExchangeError', // Since your C2C transaction is unusual, you are restricted from fund transfer. Please contact our customer support to cancel the restriction
                    '34039' => '\\ccxt\\ExchangeError', // You are now restricted from transferring out your funds due to abnormal trades on C2C Market. Please transfer your fund on our website or app instead to verify your identity
                    // swap
                    '35001' => '\\ccxt\\ExchangeError', // array( "code" => 35001, "message" => "Contract does not exist" )
                    '35002' => '\\ccxt\\ExchangeError', // array( "code" => 35002, "message" => "Contract settling" )
                    '35003' => '\\ccxt\\ExchangeError', // array( "code" => 35003, "message" => "Contract paused" )
                    '35004' => '\\ccxt\\ExchangeError', // array( "code" => 35004, "message" => "Contract pending settlement" )
                    '35005' => '\\ccxt\\AuthenticationError', // array( "code" => 35005, "message" => "User does not exist" )
                    '35008' => '\\ccxt\\InvalidOrder', // array( "code" => 35008, "message" => "Risk ratio too high" )
                    '35010' => '\\ccxt\\InvalidOrder', // array( "code" => 35010, "message" => "Position closing too large" )
                    '35012' => '\\ccxt\\InvalidOrder', // array( "code" => 35012, "message" => "Incorrect order size" )
                    '35014' => '\\ccxt\\InvalidOrder', // array( "code" => 35014, "message" => "Order price is not within limit" )
                    '35015' => '\\ccxt\\InvalidOrder', // array( "code" => 35015, "message" => "Invalid leverage level" )
                    '35017' => '\\ccxt\\ExchangeError', // array( "code" => 35017, "message" => "Open orders exist" )
                    '35019' => '\\ccxt\\InvalidOrder', // array( "code" => 35019, "message" => "Order size too large" )
                    '35020' => '\\ccxt\\InvalidOrder', // array( "code" => 35020, "message" => "Order price too high" )
                    '35021' => '\\ccxt\\InvalidOrder', // array( "code" => 35021, "message" => "Order size exceeded current tier limit" )
                    '35022' => '\\ccxt\\ExchangeError', // array( "code" => 35022, "message" => "Contract status error" )
                    '35024' => '\\ccxt\\ExchangeError', // array( "code" => 35024, "message" => "Contract not initialized" )
                    '35025' => '\\ccxt\\InsufficientFunds', // array( "code" => 35025, "message" => "No account balance" )
                    '35026' => '\\ccxt\\ExchangeError', // array( "code" => 35026, "message" => "Contract settings not initialized" )
                    '35029' => '\\ccxt\\OrderNotFound', // array( "code" => 35029, "message" => "Order does not exist" )
                    '35030' => '\\ccxt\\InvalidOrder', // array( "code" => 35030, "message" => "Order size too large" )
                    '35031' => '\\ccxt\\InvalidOrder', // array( "code" => 35031, "message" => "Cancel order size too large" )
                    '35032' => '\\ccxt\\ExchangeError', // array( "code" => 35032, "message" => "Invalid user status" )
                    '35037' => '\\ccxt\\ExchangeError', // No last traded price in cache
                    '35039' => '\\ccxt\\ExchangeError', // array( "code" => 35039, "message" => "Open order quantity exceeds limit" )
                    '35040' => '\\ccxt\\InvalidOrder', // array("error_message":"Invalid order type","result":"true","error_code":"35040","order_id":"-1")
                    '35044' => '\\ccxt\\ExchangeError', // array( "code" => 35044, "message" => "Invalid order status" )
                    '35046' => '\\ccxt\\InsufficientFunds', // array( "code" => 35046, "message" => "Negative account balance" )
                    '35047' => '\\ccxt\\InsufficientFunds', // array( "code" => 35047, "message" => "Insufficient account balance" )
                    '35048' => '\\ccxt\\ExchangeError', // array( "code" => 35048, "message" => "User contract is frozen and liquidating" )
                    '35049' => '\\ccxt\\InvalidOrder', // array( "code" => 35049, "message" => "Invalid order type" )
                    '35050' => '\\ccxt\\InvalidOrder', // array( "code" => 35050, "message" => "Position settings are blank" )
                    '35052' => '\\ccxt\\InsufficientFunds', // array( "code" => 35052, "message" => "Insufficient cross margin" )
                    '35053' => '\\ccxt\\ExchangeError', // array( "code" => 35053, "message" => "Account risk too high" )
                    '35055' => '\\ccxt\\InsufficientFunds', // array( "code" => 35055, "message" => "Insufficient account balance" )
                    '35057' => '\\ccxt\\ExchangeError', // array( "code" => 35057, "message" => "No last traded price" )
                    '35058' => '\\ccxt\\ExchangeError', // array( "code" => 35058, "message" => "No limit" )
                    '35059' => '\\ccxt\\BadRequest', // array( "code" => 35059, "message" => "client_oid or order_id is required" )
                    '35060' => '\\ccxt\\BadRequest', // array( "code" => 35060, "message" => "Only fill in either parameter client_oid or order_id" )
                    '35061' => '\\ccxt\\BadRequest', // array( "code" => 35061, "message" => "Invalid instrument_id" )
                    '35062' => '\\ccxt\\InvalidOrder', // array( "code" => 35062, "message" => "Invalid match_price" )
                    '35063' => '\\ccxt\\InvalidOrder', // array( "code" => 35063, "message" => "Invalid order_size" )
                    '35064' => '\\ccxt\\InvalidOrder', // array( "code" => 35064, "message" => "Invalid client_oid" )
                    '35066' => '\\ccxt\\InvalidOrder', // Order interval error
                    '35067' => '\\ccxt\\InvalidOrder', // Time-weighted order ratio error
                    '35068' => '\\ccxt\\InvalidOrder', // Time-weighted order range error
                    '35069' => '\\ccxt\\InvalidOrder', // Time-weighted single transaction limit error
                    '35070' => '\\ccxt\\InvalidOrder', // Algo order type error
                    '35071' => '\\ccxt\\InvalidOrder', // Order total must be larger than single order limit
                    '35072' => '\\ccxt\\InvalidOrder', // Maximum 6 unfulfilled time-weighted orders can be held at the same time
                    '35073' => '\\ccxt\\InvalidOrder', // Order price is 0. Market-close-all not available
                    '35074' => '\\ccxt\\InvalidOrder', // Iceberg order single transaction average error
                    '35075' => '\\ccxt\\InvalidOrder', // Failed to cancel order
                    '35076' => '\\ccxt\\InvalidOrder', // LTC 20x leverage. Not allowed to open position
                    '35077' => '\\ccxt\\InvalidOrder', // Maximum 6 unfulfilled iceberg orders can be held at the same time
                    '35078' => '\\ccxt\\InvalidOrder', // Order amount exceeded 100,000
                    '35079' => '\\ccxt\\InvalidOrder', // Iceberg order price variance error
                    '35080' => '\\ccxt\\InvalidOrder', // Callback rate error
                    '35081' => '\\ccxt\\InvalidOrder', // Maximum 10 unfulfilled trail orders can be held at the same time
                    '35082' => '\\ccxt\\InvalidOrder', // Trail order callback rate error
                    '35083' => '\\ccxt\\InvalidOrder', // Each user can only hold a maximum of 10 unfulfilled stop-limit orders at the same time
                    '35084' => '\\ccxt\\InvalidOrder', // Order amount exceeded 1 million
                    '35085' => '\\ccxt\\InvalidOrder', // Order amount is not in the correct range
                    '35086' => '\\ccxt\\InvalidOrder', // Price exceeds 100 thousand
                    '35087' => '\\ccxt\\InvalidOrder', // Price exceeds 100 thousand
                    '35088' => '\\ccxt\\InvalidOrder', // Average amount error
                    '35089' => '\\ccxt\\InvalidOrder', // Price exceeds 100 thousand
                    '35090' => '\\ccxt\\ExchangeError', // No stop-limit orders available for cancelation
                    '35091' => '\\ccxt\\ExchangeError', // No trail orders available for cancellation
                    '35092' => '\\ccxt\\ExchangeError', // No iceberg orders available for cancellation
                    '35093' => '\\ccxt\\ExchangeError', // No trail orders available for cancellation
                    '35094' => '\\ccxt\\ExchangeError', // Stop-limit order last traded price error
                    '35095' => '\\ccxt\\BadRequest', // Instrument_id error
                    '35096' => '\\ccxt\\ExchangeError', // Algo order status error
                    '35097' => '\\ccxt\\ExchangeError', // Order status and order ID cannot exist at the same time
                    '35098' => '\\ccxt\\ExchangeError', // An order status or order ID must exist
                    '35099' => '\\ccxt\\ExchangeError', // Algo order ID error
                    // option
                    '36001' => '\\ccxt\\BadRequest', // Invalid underlying index.
                    '36002' => '\\ccxt\\BadRequest', // Instrument does not exist.
                    '36005' => '\\ccxt\\ExchangeError', // Instrument status is invalid.
                    '36101' => '\\ccxt\\AuthenticationError', // Account does not exist.
                    '36102' => '\\ccxt\\PermissionDenied', // Account status is invalid.
                    '36103' => '\\ccxt\\AccountSuspended', // Account is suspended due to ongoing liquidation.
                    '36104' => '\\ccxt\\PermissionDenied', // Account is not enabled for options trading.
                    '36105' => '\\ccxt\\PermissionDenied', // Please enable the account for option contract.
                    '36106' => '\\ccxt\\AccountSuspended', // Funds cannot be transferred in or out, as account is suspended.
                    '36107' => '\\ccxt\\PermissionDenied', // Funds cannot be transferred out within 30 minutes after option exercising or settlement.
                    '36108' => '\\ccxt\\InsufficientFunds', // Funds cannot be transferred in or out, as equity of the account is less than zero.
                    '36109' => '\\ccxt\\PermissionDenied', // Funds cannot be transferred in or out during option exercising or settlement.
                    '36201' => '\\ccxt\\PermissionDenied', // New order function is blocked.
                    '36202' => '\\ccxt\\PermissionDenied', // Account does not have permission to short option.
                    '36203' => '\\ccxt\\InvalidOrder', // Invalid format for client_oid.
                    '36204' => '\\ccxt\\ExchangeError', // Invalid format for request_id.
                    '36205' => '\\ccxt\\BadRequest', // Instrument id does not match underlying index.
                    '36206' => '\\ccxt\\BadRequest', // Order_id and client_oid can not be used at the same time.
                    '36207' => '\\ccxt\\InvalidOrder', // Either order price or fartouch price must be present.
                    '36208' => '\\ccxt\\InvalidOrder', // Either order price or size must be present.
                    '36209' => '\\ccxt\\InvalidOrder', // Either order_id or client_oid must be present.
                    '36210' => '\\ccxt\\InvalidOrder', // Either order_ids or client_oids must be present.
                    '36211' => '\\ccxt\\InvalidOrder', // Exceeding max batch size for order submission.
                    '36212' => '\\ccxt\\InvalidOrder', // Exceeding max batch size for oder cancellation.
                    '36213' => '\\ccxt\\InvalidOrder', // Exceeding max batch size for order amendment.
                    '36214' => '\\ccxt\\ExchangeError', // Instrument does not have valid bid/ask quote.
                    '36216' => '\\ccxt\\OrderNotFound', // Order does not exist.
                    '36217' => '\\ccxt\\InvalidOrder', // Order submission failed.
                    '36218' => '\\ccxt\\InvalidOrder', // Order cancellation failed.
                    '36219' => '\\ccxt\\InvalidOrder', // Order amendment failed.
                    '36220' => '\\ccxt\\InvalidOrder', // Order is pending cancel.
                    '36221' => '\\ccxt\\InvalidOrder', // Order qty is not valid multiple of lot size.
                    '36222' => '\\ccxt\\InvalidOrder', // Order price is breaching highest buy limit.
                    '36223' => '\\ccxt\\InvalidOrder', // Order price is breaching lowest sell limit.
                    '36224' => '\\ccxt\\InvalidOrder', // Exceeding max order size.
                    '36225' => '\\ccxt\\InvalidOrder', // Exceeding max open order count for instrument.
                    '36226' => '\\ccxt\\InvalidOrder', // Exceeding max open order count for underlying.
                    '36227' => '\\ccxt\\InvalidOrder', // Exceeding max open size across all orders for underlying
                    '36228' => '\\ccxt\\InvalidOrder', // Exceeding max available qty for instrument.
                    '36229' => '\\ccxt\\InvalidOrder', // Exceeding max available qty for underlying.
                    '36230' => '\\ccxt\\InvalidOrder', // Exceeding max position limit for underlying.
                    // --------------------------------------------------------
                    // swap
                    '400' => '\\ccxt\\BadRequest', // Bad Request
                    '401' => '\\ccxt\\AuthenticationError', // Unauthorized access
                    '403' => '\\ccxt\\PermissionDenied', // Access prohibited
                    '404' => '\\ccxt\\BadRequest', // Request address does not exist
                    '405' => '\\ccxt\\BadRequest', // The HTTP Method is not supported
                    '415' => '\\ccxt\\BadRequest', // The current media type is not supported
                    '429' => '\\ccxt\\DDoSProtection', // Too many requests
                    '500' => '\\ccxt\\ExchangeNotAvailable', // System busy
                    '1001' => '\\ccxt\\RateLimitExceeded', // The request is too frequent and has been throttled
                    '1002' => '\\ccxt\\ExchangeError', // {0} verifications within 24 hours
                    '1003' => '\\ccxt\\ExchangeError', // You failed more than {0} times today, the current operation is locked, please try again in 24 hours
                    // '00000' => '\\ccxt\\ExchangeError', // success
                    '40001' => '\\ccxt\\AuthenticationError', // ACCESS_KEY cannot be empty
                    '40002' => '\\ccxt\\AuthenticationError', // SECRET_KEY cannot be empty
                    '40003' => '\\ccxt\\AuthenticationError', // Signature cannot be empty
                    '40004' => '\\ccxt\\InvalidNonce', // Request timestamp expired
                    '40005' => '\\ccxt\\InvalidNonce', // Invalid ACCESS_TIMESTAMP
                    '40006' => '\\ccxt\\AuthenticationError', // Invalid ACCESS_KEY
                    '40007' => '\\ccxt\\BadRequest', // Invalid Content_Type
                    '40008' => '\\ccxt\\InvalidNonce', // Request timestamp expired
                    '40009' => '\\ccxt\\AuthenticationError', // sign signature error
                    '40010' => '\\ccxt\\AuthenticationError', // sign signature error
                    '40011' => '\\ccxt\\AuthenticationError', // ACCESS_PASSPHRASE cannot be empty
                    '40012' => '\\ccxt\\AuthenticationError', // apikey/password is incorrect
                    '40013' => '\\ccxt\\ExchangeError', // User status is abnormal
                    '40014' => '\\ccxt\\PermissionDenied', // Incorrect permissions
                    '40015' => '\\ccxt\\ExchangeError', // System is abnormal, please try again later
                    '40016' => '\\ccxt\\PermissionDenied', // The user must bind the phone or Google
                    '40017' => '\\ccxt\\ExchangeError', // Parameter verification failed
                    '40018' => '\\ccxt\\PermissionDenied', // Invalid IP
                    '40102' => '\\ccxt\\BadRequest', // Contract configuration does not exist, please check the parameters
                    '40103' => '\\ccxt\\BadRequest', // Request method cannot be empty
                    '40104' => '\\ccxt\\ExchangeError', // Lever adjustment failure
                    '40105' => '\\ccxt\\ExchangeError', // Abnormal access to current price limit data
                    '40106' => '\\ccxt\\ExchangeError', // Abnormal get next settlement time
                    '40107' => '\\ccxt\\ExchangeError', // Abnormal access to index price data
                    '40108' => '\\ccxt\\InvalidOrder', // Wrong order quantity
                    '40109' => '\\ccxt\\OrderNotFound', // The data of the order cannot be found, please confirm the order number
                    '40200' => '\\ccxt\\OnMaintenance', // Server upgrade, please try again later
                    '40201' => '\\ccxt\\InvalidOrder', // Order number cannot be empty
                    '40202' => '\\ccxt\\ExchangeError', // User information cannot be empty
                    '40203' => '\\ccxt\\BadRequest', // The amount of adjustment margin cannot be empty or negative
                    '40204' => '\\ccxt\\BadRequest', // Adjustment margin type cannot be empty
                    '40205' => '\\ccxt\\BadRequest', // Adjusted margin type data is wrong
                    '40206' => '\\ccxt\\BadRequest', // The direction of the adjustment margin cannot be empty
                    '40207' => '\\ccxt\\BadRequest', // The adjustment margin data is wrong
                    '40208' => '\\ccxt\\BadRequest', // The accuracy of the adjustment margin amount is incorrect
                    '40209' => '\\ccxt\\BadRequest', // The current page number is wrong, please confirm
                    '40300' => '\\ccxt\\ExchangeError', // User does not exist
                    '40301' => '\\ccxt\\PermissionDenied', // Permission has not been obtained yet. If you need to use it, please contact customer service
                    '40302' => '\\ccxt\\BadRequest', // Parameter abnormality
                    '40303' => '\\ccxt\\BadRequest', // Can only query up to 20,000 data
                    '40304' => '\\ccxt\\BadRequest', // Parameter type is abnormal
                    '40305' => '\\ccxt\\BadRequest', // Client_oid length is not greater than 50, and cannot be Martian characters
                    '40306' => '\\ccxt\\ExchangeError', // Batch processing orders can only process up to 20
                    '40308' => '\\ccxt\\OnMaintenance', // The contract is being temporarily maintained
                    '40309' => '\\ccxt\\BadSymbol', // The contract has been removed
                    '40400' => '\\ccxt\\ExchangeError', // Status check abnormal
                    '40401' => '\\ccxt\\ExchangeError', // The operation cannot be performed
                    '40402' => '\\ccxt\\BadRequest', // The opening direction cannot be empty
                    '40403' => '\\ccxt\\BadRequest', // Wrong opening direction format
                    '40404' => '\\ccxt\\BadRequest', // Whether to enable automatic margin call parameters cannot be empty
                    '40405' => '\\ccxt\\BadRequest', // Whether to enable the automatic margin call parameter type is wrong
                    '40406' => '\\ccxt\\BadRequest', // Whether to enable automatic margin call parameters is of unknown type
                    '40407' => '\\ccxt\\ExchangeError', // The query direction is not the direction entrusted by the plan
                    '40408' => '\\ccxt\\ExchangeError', // Wrong time range
                    '40409' => '\\ccxt\\ExchangeError', // Time format error
                    '40500' => '\\ccxt\\InvalidOrder', // Client_oid check error
                    '40501' => '\\ccxt\\ExchangeError', // Channel name error
                    '40502' => '\\ccxt\\ExchangeError', // If it is a copy user, you must pass the copy to whom
                    '40503' => '\\ccxt\\ExchangeError', // With the single type
                    '40504' => '\\ccxt\\ExchangeError', // Platform code must pass
                    '40505' => '\\ccxt\\ExchangeError', // Not the same as single type
                    '40506' => '\\ccxt\\AuthenticationError', // Platform signature error
                    '40507' => '\\ccxt\\AuthenticationError', // Api signature error
                    '40508' => '\\ccxt\\ExchangeError', // KOL is not authorized
                    '40509' => '\\ccxt\\ExchangeError', // Abnormal copy end
                    '40600' => '\\ccxt\\ExchangeError', // Copy function suspended
                    '40601' => '\\ccxt\\ExchangeError', // Followers cannot be KOL
                    '40602' => '\\ccxt\\ExchangeError', // The number of copies has reached the limit and cannot process the request
                    '40603' => '\\ccxt\\ExchangeError', // Abnormal copy end
                    '40604' => '\\ccxt\\ExchangeNotAvailable', // Server is busy, please try again later
                    '40605' => '\\ccxt\\ExchangeError', // Copy type, the copy number must be passed
                    '40606' => '\\ccxt\\ExchangeError', // The type of document number is wrong
                    '40607' => '\\ccxt\\ExchangeError', // Document number must be passed
                    '40608' => '\\ccxt\\ExchangeError', // No documented products currently supported
                    '40609' => '\\ccxt\\ExchangeError', // The contract product does not support copying
                    '40700' => '\\ccxt\\BadRequest', // Cursor parameters are incorrect
                    '40701' => '\\ccxt\\ExchangeError', // KOL is not authorized
                    '40702' => '\\ccxt\\ExchangeError', // Unauthorized copying user
                    '40703' => '\\ccxt\\ExchangeError', // Bill inquiry start and end time cannot be empty
                    '40704' => '\\ccxt\\ExchangeError', // Can only check the data of the last three months
                    '40705' => '\\ccxt\\BadRequest', // The start and end time cannot exceed 90 days
                    '40706' => '\\ccxt\\InvalidOrder', // Wrong order price
                    '40707' => '\\ccxt\\BadRequest', // Start time is greater than end time
                    '40708' => '\\ccxt\\BadRequest', // Parameter verification is abnormal
                    '40709' => '\\ccxt\\ExchangeError', // There is no position in this position, and no automatic margin call can be set
                    '40710' => '\\ccxt\\ExchangeError', // Abnormal account status
                    '40711' => '\\ccxt\\InsufficientFunds', // Insufficient contract account balance
                    '40712' => '\\ccxt\\InsufficientFunds', // Insufficient margin
                    '40713' => '\\ccxt\\ExchangeError', // Cannot exceed the maximum transferable margin amount
                    '40714' => '\\ccxt\\ExchangeError', // No direct margin call is allowed
                    // spot
                    'invalid sign' => '\\ccxt\\AuthenticationError',
                    'invalid currency' => '\\ccxt\\BadSymbol', // invalid trading pair
                    'invalid symbol' => '\\ccxt\\BadSymbol',
                    'invalid period' => '\\ccxt\\BadRequest', // invalid Kline type
                    'invalid user' => '\\ccxt\\ExchangeError',
                    'invalid amount' => '\\ccxt\\InvalidOrder',
                    'invalid type' => '\\ccxt\\InvalidOrder', // array("status":"error","ts":1595700344504,"err_code":"invalid-parameter","err_msg":"invalid type")
                    'invalid orderId' => '\\ccxt\\InvalidOrder',
                    'invalid record' => '\\ccxt\\ExchangeError',
                    'invalid accountId' => '\\ccxt\\BadRequest',
                    'invalid address' => '\\ccxt\\BadRequest',
                    'accesskey not null' => '\\ccxt\\AuthenticationError', // array("status":"error","ts":1595704360508,"err_code":"invalid-parameter","err_msg":"accesskey not null")
                    'illegal accesskey' => '\\ccxt\\AuthenticationError',
                    'sign not null' => '\\ccxt\\AuthenticationError',
                    'req_time is too much difference from server time' => '\\ccxt\\InvalidNonce',
                    'permissions not right' => '\\ccxt\\PermissionDenied', // array("status":"error","ts":1595704490084,"err_code":"invalid-parameter","err_msg":"permissions not right")
                    'illegal sign invalid' => '\\ccxt\\AuthenticationError', // array("status":"error","ts":1595684716042,"err_code":"invalid-parameter","err_msg":"illegal sign invalid")
                    'user locked' => '\\ccxt\\AccountSuspended',
                    'Request Frequency Is Too High' => '\\ccxt\\RateLimitExceeded',
                    'more than a daily rate of cash' => '\\ccxt\\BadRequest',
                    'more than the maximum daily withdrawal amount' => '\\ccxt\\BadRequest',
                    'need to bind email or mobile' => '\\ccxt\\ExchangeError',
                    'user forbid' => '\\ccxt\\PermissionDenied',
                    'User Prohibited Cash Withdrawal' => '\\ccxt\\PermissionDenied',
                    'Cash Withdrawal Is Less Than The Minimum Value' => '\\ccxt\\BadRequest',
                    'Cash Withdrawal Is More Than The Maximum Value' => '\\ccxt\\BadRequest',
                    'the account with in 24 hours ban coin' => '\\ccxt\\PermissionDenied',
                    'order cancel fail' => '\\ccxt\\BadRequest', // array("status":"error","ts":1595703343035,"err_code":"bad-request","err_msg":"order cancel fail")
                    'base symbol error' => '\\ccxt\\BadSymbol',
                    'base date error' => '\\ccxt\\ExchangeError',
                    'api signature not valid' => '\\ccxt\\AuthenticationError',
                    'gateway internal error' => '\\ccxt\\ExchangeError',
                    'audit failed' => '\\ccxt\\ExchangeError',
                    'order queryorder invalid' => '\\ccxt\\BadRequest',
                    'market no need price' => '\\ccxt\\InvalidOrder',
                    'limit need price' => '\\ccxt\\InvalidOrder',
                    'userid not equal to account_id' => '\\ccxt\\ExchangeError',
                    'your balance is low' => '\\ccxt\\InsufficientFunds', // array("status":"error","ts":1595594160149,"err_code":"invalid-parameter","err_msg":"invalid size, valid range => [1,2000]")
                    'address invalid cointype' => '\\ccxt\\ExchangeError',
                    'system exception' => '\\ccxt\\ExchangeError', // array("status":"error","ts":1595711862763,"err_code":"system exception","err_msg":"system exception")
                    '50003' => '\\ccxt\\ExchangeError', // No record
                    '50004' => '\\ccxt\\BadSymbol', // The transaction pair is currently not supported or has been suspended
                    '50006' => '\\ccxt\\PermissionDenied', // The account is forbidden to withdraw. If you have any questions, please contact customer service.
                    '50007' => '\\ccxt\\PermissionDenied', // The account is forbidden to withdraw within 24 hours. If you have any questions, please contact customer service.
                    '50008' => '\\ccxt\\RequestTimeout', // network timeout
                    '50009' => '\\ccxt\\RateLimitExceeded', // The operation is too frequent, please try again later
                    '50010' => '\\ccxt\\ExchangeError', // The account is abnormally frozen. If you have any questions, please contact customer service.
                    '50014' => '\\ccxt\\InvalidOrder', // The transaction amount under minimum limits
                    '50015' => '\\ccxt\\InvalidOrder', // The transaction amount exceed maximum limits
                    '50016' => '\\ccxt\\InvalidOrder', // The price can't be higher than the current price
                    '50017' => '\\ccxt\\InvalidOrder', // Price under minimum limits
                    '50018' => '\\ccxt\\InvalidOrder', // The price exceed maximum limits
                    '50019' => '\\ccxt\\InvalidOrder', // The amount under minimum limits
                    '50020' => '\\ccxt\\InsufficientFunds', // Insufficient balance
                    '50021' => '\\ccxt\\InvalidOrder', // Price is under minimum limits
                    '50026' => '\\ccxt\\InvalidOrder', // Market price parameter error
                    'invalid order query time' => '\\ccxt\\ExchangeError', // start time is greater than end time; or the time interval between start time and end time is greater than 48 hours
                    'invalid start time' => '\\ccxt\\BadRequest', // start time is a date 30 days ago; or start time is a date in the future
                    'invalid end time' => '\\ccxt\\BadRequest', // end time is a date 30 days ago; or end time is a date in the future
                    '20003' => '\\ccxt\\ExchangeError', // operation failed, array("status":"error","ts":1595730308979,"err_code":"bad-request","err_msg":"20003")
                    '01001' => '\\ccxt\\ExchangeError', // order failed, array("status":"fail","err_code":"01001","err_msg":"系统异常，请稍后重试")
                ),
                'broad' => array(
                    'invalid size, valid range' => '\\ccxt\\ExchangeError',
                ),
            ),
            'precisionMode' => TICK_SIZE,
            'commonCurrencies' => array(
                'JADE' => 'Jade Protocol',
            ),
            'options' => array(
                'fetchMarkets' => array(
                    'spot',
                    'swap',
                ),
                'defaultType' => 'spot', // 'spot', 'swap'
                'defaultSubType' => 'linear', // 'linear', 'inverse'
                'broker' => array(
                    'spot' => 'iauIBf#',
                    'swap' => 'iauIBf#',
                ),
            ),
        ));
    }

    public function fetch_time($params = array ()) {
        /**
         * fetches the current integer timestamp in milliseconds from the exchange server
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {int} the current integer timestamp in milliseconds from the exchange server
         */
        $response = $this->publicSpotGetPublicTime ($params);
        //
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645837773501,
        //       data => '1645837773501'
        //     }
        //
        return $this->safe_integer($response, 'data');
    }

    public function fetch_markets($params = array ()) {
        /**
         * retrieves data on all $markets for bitget
         * @param {dict} $params extra parameters specific to the exchange api endpoint
         * @return {[dict]} an array of objects representing market data
         */
        $types = $this->safe_value($this->options, 'fetchMarkets', array( 'spot', 'swap' ));
        $result = array();
        for ($i = 0; $i < count($types); $i++) {
            $type = $types[$i];
            if ($type === 'swap') {
                $subTypes = array( 'umcbl', 'dmcbl' );
                for ($j = 0; $j < count($subTypes); $j++) {
                    $markets = $this->fetch_markets_by_type($type, array_merge($params, array(
                        'productType' => $subTypes[$j],
                    )));
                    $result = $this->array_concat($result, $markets);
                }
            } else {
                $markets = $this->fetch_markets_by_type($types[$i], $params);
                $result = $this->array_concat($result, $markets);
            }
        }
        return $result;
    }

    public function parse_markets($markets) {
        $result = array();
        for ($i = 0; $i < count($markets); $i++) {
            $result[] = $this->parse_market($markets[$i]);
        }
        return $result;
    }

    public function parse_market($market) {
        //
        // $spot
        //
        //     {
        //       $symbol => 'ALPHAUSDT_SPBL',
        //       symbolName => 'ALPHAUSDT',
        //       baseCoin => 'ALPHA',
        //       quoteCoin => 'USDT',
        //       minTradeAmount => '2',
        //       maxTradeAmount => '0',
        //       takerFeeRate => '0.001',
        //       makerFeeRate => '0.001',
        //       $priceScale => '4',
        //       quantityScale => '4',
        //       $status => 'online'
        //     }
        //
        // $swap
        //
        //     {
        //       $symbol => 'BTCUSDT_UMCBL',
        //       makerFeeRate => '0.0002',
        //       takerFeeRate => '0.0006',
        //       feeRateUpRatio => '0.005',
        //       openCostUpRatio => '0.01',
        //       quoteCoin => 'USDT',
        //       baseCoin => 'BTC',
        //       buyLimitPriceRatio => '0.01',
        //       sellLimitPriceRatio => '0.01',
        //       $supportMarginCoins => array( 'USDT' ),
        //       minTradeNum => '0.001',
        //       priceEndStep => '5',
        //       volumePlace => '3',
        //       pricePlace => '1'
        //     }
        //
        //
        $marketId = $this->safe_string($market, 'symbol');
        $quoteId = $this->safe_string($market, 'quoteCoin');
        $baseId = $this->safe_string($market, 'baseCoin');
        $quote = $this->safe_currency_code($quoteId);
        $base = $this->safe_currency_code($baseId);
        $supportMarginCoins = $this->safe_value($market, 'supportMarginCoins', array());
        $settleId = $this->safe_string($supportMarginCoins, 0);
        $settle = $this->safe_currency_code($settleId);
        $symbol = $base . '/' . $quote;
        $parts = explode('_', $marketId);
        $typeId = $this->safe_string($parts, 1);
        $type = null;
        $linear = null;
        $inverse = null;
        $swap = false;
        $spot = false;
        $contract = false;
        $pricePrecision = null;
        $amountPrecision = null;
        if ($typeId === 'SPBL') {
            $type = 'spot';
            $spot = true;
            $priceScale = $this->safe_string($market, 'priceScale');
            $amountScale = $this->safe_string($market, 'quantityScale');
            $pricePrecision = $this->parse_number($this->parse_precision($priceScale));
            $amountPrecision = $this->parse_number($this->parse_precision($amountScale));
        } else {
            $type = 'swap';
            $swap = true;
            $contract = true;
            $symbol = $symbol . ':' . $settle;
            if ($typeId === 'UMCBL') {
                $linear = true;
                $inverse = false;
            } elseif ($typeId === 'DMCBL') {
                $inverse = true;
                $linear = false;
            }
            $priceDecimals = $this->safe_integer($market, 'pricePlace');
            $amountDecimals = $this->safe_integer($market, 'volumePlace');
            $priceStep = $this->safe_string($market, 'priceEndStep');
            $amountStep = $this->safe_string($market, 'minTradeNum');
            $precisePrice = new Precise ($priceStep);
            $precisePrice->decimals = $this->sum($precisePrice->decimals, $priceDecimals);
            $precisePrice->reduce ();
            $priceString = (string) $precisePrice;
            $pricePrecision = $this->parse_number($priceString);
            $preciseAmount = new Precise ($amountStep);
            $preciseAmount->decimals = $this->sum($preciseAmount->decimals, $amountDecimals);
            $preciseAmount->reduce ();
            $amountString = (string) $preciseAmount;
            $amountPrecision = $this->parse_number($amountString);
        }
        $status = $this->safe_string($market, 'status');
        $active = null;
        if ($status !== null) {
            $active = $status === 'online';
        }
        $maker = $this->safe_number($market, 'makerFeeRate');
        $taker = $this->safe_number($market, 'takerFeeRate');
        $precision = array(
            'price' => $pricePrecision,
            'amount' => $amountPrecision,
        );
        $limits = array(
            'amount' => array(
                'min' => $this->safe_number($market, 'minTradeAmount'),
                'max' => null,
            ),
            'price' => array(
                'min' => null,
                'max' => null,
            ),
            'cost' => array(
                'min' => null,
                'max' => null,
            ),
        );
        return array(
            'info' => $market,
            'id' => $marketId,
            'symbol' => $symbol,
            'quoteId' => $quoteId,
            'baseId' => $baseId,
            'quote' => $quote,
            'base' => $base,
            'type' => $type,
            'spot' => $spot,
            'swap' => $swap,
            'future' => false,
            'option' => false,
            'margin' => false,
            'contract' => $contract,
            'contractSize' => null,
            'linear' => $linear,
            'inverse' => $inverse,
            'settleId' => $settleId,
            'settle' => $settle,
            'expiry' => null,
            'expiryDatetime' => null,
            'optionType' => null,
            'strike' => null,
            'active' => $active,
            'maker' => $maker,
            'taker' => $taker,
            'precision' => $precision,
            'limits' => $limits,
        );
    }

    public function fetch_markets_by_type($type, $params = array ()) {
        $method = $this->get_supported_mapping($type, array(
            'spot' => 'publicSpotGetPublicProducts',
            'swap' => 'publicMixGetMarketContracts',
        ));
        $response = $this->$method ($params);
        //
        // spot
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645840064031,
        //       $data => array(
        //         {
        //           symbol => 'ALPHAUSDT_SPBL',
        //           symbolName => 'ALPHAUSDT',
        //           baseCoin => 'ALPHA',
        //           quoteCoin => 'USDT',
        //           minTradeAmount => '2',
        //           maxTradeAmount => '0',
        //           takerFeeRate => '0.001',
        //           makerFeeRate => '0.001',
        //           priceScale => '4',
        //           quantityScale => '4',
        //           status => 'online'
        //         }
        //       )
        //     }
        //
        // swap
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645840821493,
        //       $data => [
        //         {
        //           symbol => 'BTCUSDT_UMCBL',
        //           makerFeeRate => '0.0002',
        //           takerFeeRate => '0.0006',
        //           feeRateUpRatio => '0.005',
        //           openCostUpRatio => '0.01',
        //           quoteCoin => 'USDT',
        //           baseCoin => 'BTC',
        //           buyLimitPriceRatio => '0.01',
        //           sellLimitPriceRatio => '0.01',
        //           supportMarginCoins => [Array],
        //           minTradeNum => '0.001',
        //           priceEndStep => '5',
        //           volumePlace => '3',
        //           pricePlace => '1'
        //         }
        //       ]
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        return $this->parse_markets($data);
    }

    public function fetch_currencies($params = array ()) {
        /**
         * fetches all available currencies on an exchange
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {dict} an associative dictionary of currencies
         */
        $response = $this->publicSpotGetPublicCurrencies ($params);
        //
        //     {
        //       $code => '00000',
        //       msg => 'success',
        //       requestTime => 1645935668288,
        //       $data => array(
        //         {
        //           coinId => '230',
        //           coinName => 'KIN',
        //           transfer => 'false',
        //           $chains => array(
        //             {
        //               $chain => 'SOL',
        //               needTag => 'false',
        //               withdrawable => 'true',
        //               rechargeable => 'true',
        //               withdrawFee => '187500',
        //               depositConfirm => '100',
        //               withdrawConfirm => '100',
        //               minDepositAmount => '12500',
        //               minWithdrawAmount => '250000',
        //               browserUrl => 'https://explorer.solana.com/tx/'
        //             }
        //           )
        //         }
        //       )
        //     }
        //
        $result = array();
        $data = $this->safe_value($response, 'data', array());
        for ($i = 0; $i < count($data); $i++) {
            $entry = $data[$i];
            $id = $this->safe_string($entry, 'coinId');
            $code = $this->safe_currency_code($this->safe_string($entry, 'coinName'));
            $chains = $this->safe_value($entry, 'chains', array());
            $networks = array();
            for ($j = 0; $j < count($chains); $j++) {
                $chain = $chains[$j];
                $networkId = $this->safe_string($chain, 'chain');
                $network = $this->safe_currency_code($networkId);
                $withdrawEnabled = $this->safe_string($chain, 'withdrawable');
                $depositEnabled = $this->safe_string($chain, 'rechargeable');
                $networks[$network] = array(
                    'info' => $chain,
                    'id' => $networkId,
                    'network' => $network,
                    'limits' => array(
                        'withdraw' => array(
                            'min' => $this->safe_number($chain, 'minWithdrawAmount'),
                            'max' => null,
                        ),
                        'deposit' => array(
                            'min' => $this->safe_number($chain, 'minDepositAmount'),
                            'max' => null,
                        ),
                    ),
                    'active' => null,
                    'withdraw' => $withdrawEnabled === 'true',
                    'deposit' => $depositEnabled === 'true',
                    'fee' => $this->safe_number($chain, 'withdrawFee'),
                );
            }
            $result[$code] = array(
                'info' => $entry,
                'id' => $id,
                'code' => $code,
                'networks' => $networks,
                'type' => null,
                'name' => null,
                'active' => null,
                'deposit' => null,
                'withdraw' => null,
                'fee' => null,
                'precision' => null,
                'limits' => array(
                    'amount' => array( 'min' => null, 'max' => null ),
                    'withdraw' => array( 'min' => null, 'max' => null ),
                ),
            );
        }
        return $result;
    }

    public function fetch_order_book($symbol, $limit = null, $params = array ()) {
        /**
         * fetches information on open orders with bid (buy) and ask (sell) prices, volumes and other $data
         * @param {str} $symbol unified $symbol of the $market to fetch the order book for
         * @param {int|null} $limit the maximum amount of order book entries to return
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {dict} A dictionary of {@link https://docs.ccxt.com/en/latest/manual.html#order-book-structure order book structures} indexed by $market symbols
         */
        $this->load_markets();
        $market = $this->market($symbol);
        list($marketType, $query) = $this->handle_market_type_and_params('fetchOrderBook', $market, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'publicSpotGetMarketDepth',
            'swap' => 'publicMixGetMarketDepth',
        ));
        $request = array(
            'symbol' => $market['id'],
        );
        if ($limit !== null) {
            $request['limit'] = $limit;
        }
        $response = $this->$method (array_merge($request, $query));
        //
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645854610294,
        //       $data => {
        //         asks => array( array( '39102', '11.026' ) ),
        //         bids => array( array( '39100.5', '1.773' ) ),
        //         $timestamp => '1645854610294'
        //       }
        //     }
        //
        $data = $this->safe_value($response, 'data');
        $timestamp = $this->safe_integer($data, 'timestamp');
        return $this->parse_order_book($data, $symbol, $timestamp);
    }

    public function parse_ticker($ticker, $market = null) {
        //
        // spot
        //
        //     {
        //         $symbol => 'BTCUSDT',
        //         high24h => '40252.43',
        //         low24h => '38548.54',
        //         $close => '39102.16',
        //         quoteVol => '67295596.1458',
        //         baseVol => '1723.4152',
        //         usdtVol => '67295596.14578',
        //         ts => '1645856170030',
        //         buyOne => '39096.16',
        //         sellOne => '39103.99'
        //     }
        //
        // swap
        //
        //     {
        //         $symbol => 'BTCUSDT_UMCBL',
        //         last => '39086',
        //         bestAsk => '39087',
        //         bestBid => '39086',
        //         high24h => '40312',
        //         low24h => '38524.5',
        //         $timestamp => '1645856591864',
        //         priceChangePercent => '-0.00861',
        //         $baseVolume => '142251.757',
        //         $quoteVolume => '5552388715.9215',
        //         usdtVolume => '5552388715.9215'
        //     }
        //
        $marketId = $this->safe_string($ticker, 'symbol');
        if (!(is_array($this->markets_by_id) && array_key_exists($marketId, $this->markets_by_id))) {
            $marketId .= '_SPBL';
        }
        $symbol = $this->safe_symbol($marketId, $market);
        $high = $this->safe_string($ticker, 'high24h');
        $low = $this->safe_string($ticker, 'low24h');
        $close = $this->safe_string_2($ticker, 'close', 'last');
        $quoteVolume = $this->safe_string_2($ticker, 'quoteVol', 'quoteVolume');
        $baseVolume = $this->safe_string_2($ticker, 'baseVol', 'baseVolume');
        $timestamp = $this->safe_integer_2($ticker, 'ts', 'timestamp');
        $datetime = $this->iso8601($timestamp);
        $bid = $this->safe_string_2($ticker, 'buyOne', 'bestBid');
        $ask = $this->safe_string_2($ticker, 'sellOne', 'bestAsk');
        $percentage = Precise::string_mul($this->safe_string($ticker, 'priceChangePercent'), '100');
        return $this->safe_ticker(array(
            'symbol' => $symbol,
            'timestamp' => $timestamp,
            'datetime' => $datetime,
            'high' => $high,
            'low' => $low,
            'bid' => $bid,
            'bidVolume' => null,
            'ask' => $ask,
            'askVolume' => null,
            'vwap' => null,
            'open' => null,
            'close' => $close,
            'last' => null,
            'previousClose' => null,
            'change' => null,
            'percentage' => $percentage,
            'average' => null,
            'baseVolume' => $baseVolume,
            'quoteVolume' => $quoteVolume,
            'info' => $ticker,
        ), $market);
    }

    public function fetch_ticker($symbol, $params = array ()) {
        /**
         * fetches a price ticker, a statistical calculation with the information calculated over the past 24 hours for a specific $market
         * @param {str} $symbol unified $symbol of the $market to fetch the ticker for
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {dict} a {@link https://docs.ccxt.com/en/latest/manual.html#ticker-structure ticker structure}
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        list($marketType, $query) = $this->handle_market_type_and_params('fetchTicker', $market, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'publicSpotGetMarketTicker',
            'swap' => 'publicMixGetMarketTicker',
        ));
        $response = $this->$method (array_merge($request, $query));
        //
        //     {
        //         code => '00000',
        //         msg => 'success',
        //         requestTime => '1645856138576',
        //         $data => {
        //             $symbol => 'BTCUSDT',
        //             high24h => '40252.43',
        //             low24h => '38548.54',
        //             close => '39104.65',
        //             quoteVol => '67221762.2184',
        //             baseVol => '1721.527',
        //             usdtVol => '67221762.218361',
        //             ts => '1645856138031',
        //             buyOne => '39102.55',
        //             sellOne => '39110.56'
        //         }
        //     }
        //
        $data = $this->safe_value($response, 'data');
        return $this->parse_ticker($data, $market);
    }

    public function fetch_tickers($symbols = null, $params = array ()) {
        /**
         * fetches price tickers for multiple markets, statistical calculations with the information calculated over the past 24 hours each market
         * @param {[str]|null} $symbols unified $symbols of the markets to fetch the ticker for, all market tickers are returned if not assigned
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {dict} an array of {@link https://docs.ccxt.com/en/latest/manual.html#ticker-structure ticker structures}
         */
        $this->load_markets();
        list($marketType, $query) = $this->handle_market_type_and_params('fetchTickers', null, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'publicSpotGetMarketTickers',
            'swap' => 'publicMixGetMarketTickers',
        ));
        $request = array();
        if ($method === 'publicMixGetMarketTickers') {
            $defaultSubType = $this->safe_string($this->options, 'defaultSubType');
            $request['productType'] = ($defaultSubType === 'linear') ? 'UMCBL' : 'DMCBL';
        }
        $response = $this->$method (array_merge($request, $query));
        //
        // spot
        //
        //     {
        //         "code":"00000",
        //         "msg":"success",
        //         "requestTime":1653237548496,
        //         "data":array(
        //             array(
        //                 "symbol":"LINKUSDT",
        //                 "high24h":"7.2634",
        //                 "low24h":"7.1697",
        //                 "close":"7.2444",
        //                 "quoteVol":"330424.2366",
        //                 "baseVol":"46401.3116",
        //                 "usdtVol":"330424.2365573",
        //                 "ts":"1653237548026",
        //                 "buyOne":"7.2382",
        //                 "sellOne":"7.2513"
        //             ),
        //         )
        //     }
        //
        // swap
        //
        //     {
        //         "code":"00000",
        //         "msg":"success",
        //         "requestTime":1653237819762,
        //         "data":array(
        //             array(
        //                 "symbol":"BTCUSDT_UMCBL",
        //                 "last":"29891.5",
        //                 "bestAsk":"29891.5",
        //                 "bestBid":"29889.5",
        //                 "high24h":"29941.5",
        //                 "low24h":"29737.5",
        //                 "timestamp":"1653237819761",
        //                 "priceChangePercent":"0.00163",
        //                 "baseVolume":"127937.56",
        //                 "quoteVolume":"3806276573.6285",
        //                 "usdtVolume":"3806276573.6285"
        //             ),
        //         )
        //     }
        //
        $data = $this->safe_value($response, 'data');
        return $this->parse_tickers($data, $symbols);
    }

    public function parse_trade($trade, $market = null) {
        //
        // spot
        //
        //     {
        //         $symbol => 'BTCUSDT_SPBL',
        //         tradeId => '881371996363608065',
        //         $side => 'sell',
        //         fillPrice => '39123.05',
        //         fillQuantity => '0.0363',
        //         fillTime => '1645861379709'
        //     }
        //
        // swap
        //
        //     {
        //         tradeId => '881373204067311617',
        //         $price => '39119.0',
        //         size => '0.001',
        //         $side => 'buy',
        //         $timestamp => '1645861667648',
        //         $symbol => 'BTCUSDT_UMCBL'
        //     }
        //
        // private
        //
        //     {
        //         accountId => '6394957606',
        //         $symbol => 'LTCUSDT_SPBL',
        //         orderId => '864752115272552448',
        //         fillId => '864752115685969921',
        //         orderType => 'limit',
        //         $side => 'buy',
        //         fillPrice => '127.92000000',
        //         fillQuantity => '0.10000000',
        //         fillTotalAmount => '12.79200000',
        //         feeCcy => 'LTC',
        //         fees => '0.00000000',
        //         cTime => '1641898891373'
        //     }
        //
        //     {
        //         tradeId => '881640729552281602',
        //         $symbol => 'BTCUSDT_UMCBL',
        //         orderId => '881640729145409536',
        //         $price => '38429.50',
        //         sizeQty => '0.001',
        //         $fee => '0',
        //         $side => 'open_long',
        //         fillAmount => '38.4295',
        //         profit => '0',
        //         cTime => '1645925450694'
        //     }
        //
        $marketId = $this->safe_string($trade, 'symbol');
        $symbol = $this->safe_symbol($marketId, $market);
        $id = $this->safe_string_2($trade, 'tradeId', 'fillId');
        $order = $this->safe_string($trade, 'orderId');
        $side = $this->safe_string($trade, 'side');
        $price = $this->safe_string_2($trade, 'fillPrice', 'price');
        $amount = $this->safe_string_2($trade, 'fillQuantity', 'size');
        $amount = $this->safe_string($trade, 'sizeQty', $amount);
        $timestamp = $this->safe_integer_2($trade, 'fillTime', 'timestamp');
        $timestamp = $this->safe_integer($trade, 'cTime', $timestamp);
        $fee = null;
        $feeAmount = $this->safe_string($trade, 'fees');
        $type = $this->safe_string($trade, 'orderType');
        if ($feeAmount !== null) {
            $fee = array(
                'code' => $this->safe_currency_code($this->safe_string($trade, 'feeCcy')),
                'cost' => $feeAmount,
            );
        }
        $datetime = $this->iso8601($timestamp);
        return $this->safe_trade(array(
            'info' => $trade,
            'id' => $id,
            'order' => $order,
            'symbol' => $symbol,
            'side' => $side,
            'type' => $type,
            'takerOrMaker' => null,
            'price' => $price,
            'amount' => $amount,
            'cost' => null,
            'fee' => $fee,
            'timestamp' => $timestamp,
            'datetime' => $datetime,
        ), $market);
    }

    public function fetch_trades($symbol, $limit = null, $since = null, $params = array ()) {
        /**
         * get the list of most recent trades for a particular $symbol
         * @param {str} $symbol unified $symbol of the $market to fetch trades for
         * @param {int|null} $since timestamp in ms of the earliest trade to fetch
         * @param {int|null} $limit the maximum amount of trades to fetch
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {[dict]} a list of ~@link https://docs.ccxt.com/en/latest/manual.html?#public-trades trade structures~
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        if ($limit !== null) {
            $request['limit'] = $limit;
        }
        list($marketType, $query) = $this->handle_market_type_and_params('fetchTrades', $market, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'publicSpotGetMarketFills',
            'swap' => 'publicMixGetMarketFills',
        ));
        $response = $this->$method (array_merge($request, $query));
        //
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => '1645861382032',
        //       $data => array(
        //         {
        //           $symbol => 'BTCUSDT_SPBL',
        //           tradeId => '881371996363608065',
        //           side => 'sell',
        //           fillPrice => '39123.05',
        //           fillQuantity => '0.0363',
        //           fillTime => '1645861379709'
        //         }
        //       )
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        return $this->parse_trades($data, $market, $since, $limit);
    }

    public function fetch_trading_fee($symbol, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        $response = $this->publicSpotGetPublicProduct (array_merge($request, $params));
        //
        //     {
        //         code => '00000',
        //         msg => 'success',
        //         requestTime => '1646255374000',
        //         $data => {
        //           $symbol => 'ethusdt_SPBL',
        //           symbolName => null,
        //           baseCoin => 'ETH',
        //           quoteCoin => 'USDT',
        //           minTradeAmount => '0',
        //           maxTradeAmount => '0',
        //           takerFeeRate => '0.002',
        //           makerFeeRate => '0.002',
        //           priceScale => '2',
        //           quantityScale => '4',
        //           status => 'online'
        //         }
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        return $this->parse_trading_fee($data, $market);
    }

    public function fetch_trading_fees($params = array ()) {
        $this->load_markets();
        $response = $this->publicSpotGetPublicProducts ($params);
        //
        //     {
        //         code => '00000',
        //         msg => 'success',
        //         requestTime => '1646255662391',
        //         $data => array(
        //           array(
        //             $symbol => 'ALPHAUSDT_SPBL',
        //             symbolName => 'ALPHAUSDT',
        //             baseCoin => 'ALPHA',
        //             quoteCoin => 'USDT',
        //             minTradeAmount => '2',
        //             maxTradeAmount => '0',
        //             takerFeeRate => '0.001',
        //             makerFeeRate => '0.001',
        //             priceScale => '4',
        //             quantityScale => '4',
        //             status => 'online'
        //           ),
        //           ...
        //         )
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        $result = array();
        for ($i = 0; $i < count($data); $i++) {
            $feeInfo = $data[$i];
            $fee = $this->parse_trading_fee($feeInfo);
            $symbol = $fee['symbol'];
            $result[$symbol] = $fee;
        }
        return $result;
    }

    public function parse_trading_fee($data, $market = null) {
        $marketId = $this->safe_string($data, 'symbol');
        return array(
            'info' => $data,
            'symbol' => $this->safe_symbol($marketId, $market),
            'maker' => $this->safe_number($data, 'makerFeeRate'),
            'taker' => $this->safe_number($data, 'takerFeeRate'),
        );
    }

    public function parse_ohlcv($ohlcv, $market = null, $timeframe = '1m') {
        //
        // spot
        //
        //     {
        //         open => '57882.31',
        //         high => '58967.24',
        //         low => '57509.56',
        //         close => '57598.96',
        //         quoteVol => '439160536.605821',
        //         baseVol => '7531.2927',
        //         usdtVol => '439160536.605821',
        //         ts => '1637337600000'
        //     }
        //
        // swap
        //
        //     array(
        //         "1645911960000",
        //         "39406",
        //         "39407",
        //         "39374.5",
        //         "39379",
        //         "35.526",
        //         "1399132.341"
        //     )
        //
        return array(
            $this->safe_integer_2($ohlcv, 0, 'ts'),
            $this->safe_number_2($ohlcv, 1, 'open'),
            $this->safe_number_2($ohlcv, 2, 'high'),
            $this->safe_number_2($ohlcv, 3, 'low'),
            $this->safe_number_2($ohlcv, 4, 'close'),
            $this->safe_number_2($ohlcv, 5, 'baseVol'),
        );
    }

    public function fetch_ohlcv($symbol, $timeframe = '1m', $since = null, $limit = null, $params = array ()) {
        /**
         * fetches historical candlestick $data containing the open, high, low, and close price, and the volume of a $market
         * @param {str} $symbol unified $symbol of the $market to fetch OHLCV $data for
         * @param {str} $timeframe the length of time each candle represents
         * @param {int|null} $since timestamp in ms of the earliest candle to fetch
         * @param {int|null} $limit the maximum amount of candles to fetch
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {[[int]]} A list of candles ordered as timestamp, open, high, low, close, volume
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        list($marketType, $query) = $this->handle_market_type_and_params('fetchOHLCV', $market, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'publicSpotGetMarketCandles',
            'swap' => 'publicMixGetMarketCandles',
        ));
        if ($market['type'] === 'spot') {
            $request['period'] = $this->timeframes['spot'][$timeframe];
            if ($limit !== null) {
                $request['limit'] = $limit;
            }
            if ($since !== null) {
                $request['after'] = $since;
            }
        } elseif ($market['type'] === 'swap') {
            $request['granularity'] = $this->timeframes['swap'][$timeframe];
            $duration = $this->parse_timeframe($timeframe);
            $now = $this->milliseconds();
            if ($limit === null) {
                $limit = 100;
            }
            if ($since === null) {
                $request['startTime'] = $now - ($limit - 1) * ($duration * 1000);
                $request['endTime'] = $now;
            } else {
                $request['startTime'] = $this->sum($since, $duration * 1000);
                $request['endTime'] = $this->sum($since, $limit * $duration * 1000);
            }
        }
        $response = $this->$method (array_merge($request, $query));
        //  [ ["1645911960000","39406","39407","39374.5","39379","35.526","1399132.341"] ]
        $data = $this->safe_value($response, 'data', $response);
        return $this->parse_ohlcvs($data, $market, $timeframe, $since, $limit);
    }

    public function fetch_balance($params = array ()) {
        /**
         * $query for balance and get the amount of funds available for trading or funds locked in orders
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {dict} a ~@link https://docs.ccxt.com/en/latest/manual.html?#balance-structure balance structure~
         */
        $this->load_markets();
        list($marketType, $query) = $this->handle_market_type_and_params('fetchBalance', null, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'privateSpotGetAccountAssets',
            'swap' => 'privateMixGetAccountAccounts',
        ));
        $request = array();
        if ($marketType === 'swap') {
            $defaultSubType = $this->safe_string($this->options, 'defaultSubType');
            $request['productType'] = ($defaultSubType === 'linear') ? 'UMCBL' : 'DMCBL';
        }
        $response = $this->$method (array_merge($request, $query));
        // spot
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645928868827,
        //       $data => array(
        //         {
        //           coinId => 1,
        //           coinName => 'BTC',
        //           available => '0.00070000',
        //           frozen => '0.00000000',
        //           lock => '0.00000000',
        //           uTime => '1645921706000'
        //         }
        //       )
        //     }
        //
        // swap
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645928929251,
        //       $data => array(
        //         {
        //           marginCoin => 'USDT',
        //           locked => '0',
        //           available => '8.078525',
        //           crossMaxAvailable => '8.078525',
        //           fixedMaxAvailable => '8.078525',
        //           maxTransferOut => '8.078525',
        //           equity => '10.02508',
        //           usdtEquity => '10.02508',
        //           btcEquity => '0.00026057027'
        //         }
        //       )
        //     }
        $data = $this->safe_value($response, 'data');
        return $this->parse_balance($data);
    }

    public function parse_balance($balance) {
        $result = array( 'info' => $balance );
        for ($i = 0; $i < count($balance); $i++) {
            $entry = $balance[$i];
            $currencyId = $this->safe_string_2($entry, 'coinId', 'marginCoin');
            $code = $this->safe_currency_code($currencyId);
            $account = $this->account();
            $account['used'] = $this->safe_string_2($entry, 'lock', 'locked');
            $account['free'] = $this->safe_string($entry, 'available');
            $result[$code] = $account;
        }
        return $this->safe_balance($result);
    }

    public function parse_order_status($status) {
        $statuses = array(
            'new' => 'open',
            'full_fill' => 'closed',
            'filled' => 'closed',
        );
        return $this->safe_string($statuses, $status, $status);
    }

    public function parse_order($order, $market = null) {
        //
        // spot
        //     {
        //       accountId => '6394957606',
        //       $symbol => 'BTCUSDT_SPBL',
        //       orderId => '881623995442958336',
        //       $clientOrderId => '135335e9-b054-4e43-b00a-499f11d3a5cc',
        //       $price => '39000.000000000000',
        //       quantity => '0.000700000000',
        //       orderType => 'limit',
        //       $side => 'buy',
        //       $status => 'new',
        //       fillPrice => '0.000000000000',
        //       fillQuantity => '0.000000000000',
        //       fillTotalAmount => '0.000000000000',
        //       cTime => '1645921460972'
        //     }
        //
        // swap
        //     {
        //       $symbol => 'BTCUSDT_UMCBL',
        //       size => 0.001,
        //       orderId => '881640729145409536',
        //       clientOid => '881640729204129792',
        //       filledQty => 0.001,
        //       $fee => 0,
        //       $price => null,
        //       priceAvg => 38429.5,
        //       state => 'filled',
        //       $side => 'open_long',
        //       timeInForce => 'normal',
        //       totalProfits => 0,
        //       posSide => 'long',
        //       marginCoin => 'USDT',
        //       filledAmount => 38.4295,
        //       orderType => 'market',
        //       cTime => '1645925450611',
        //       uTime => '1645925450746'
        //     }
        //
        // stop
        //
        //     {
        //         "orderId" => "910246821491617792",
        //         "symbol" => "BTCUSDT_UMCBL",
        //         "marginCoin" => "USDT",
        //         "size" => "16",
        //         "executePrice" => "20000",
        //         "triggerPrice" => "24000",
        //         "status" => "not_trigger",
        //         "orderType" => "limit",
        //         "planType" => "normal_plan",
        //         "side" => "open_long",
        //         "triggerType" => "market_price",
        //         "presetTakeProfitPrice" => "0",
        //         "presetTakeLossPrice" => "0",
        //         "cTime" => "1652745674488"
        //     }
        //
        $marketId = $this->safe_string($order, 'symbol');
        $market = $this->safe_market($marketId);
        $symbol = $market['symbol'];
        $id = $this->safe_string($order, 'orderId');
        $price = $this->safe_string_2($order, 'price', 'executePrice');
        $amount = $this->safe_string_2($order, 'quantity', 'size');
        $filled = $this->safe_string_2($order, 'fillQuantity', 'filledQty');
        $cost = $this->safe_string_2($order, 'fillTotalAmount', 'filledAmount');
        $average = $this->safe_string($order, 'fillPrice');
        $type = $this->safe_string($order, 'orderType');
        $timestamp = $this->safe_integer($order, 'cTime');
        $side = $this->safe_string_2($order, 'side', 'posSide');
        if (($side === 'open_long') || ($side === 'close_short')) {
            $side = 'buy';
        } elseif (($side === 'close_long') || ($side === 'open_short')) {
            $side = 'sell';
        }
        $clientOrderId = $this->safe_string_2($order, 'clientOrderId', 'clientOid');
        $fee = null;
        $rawStatus = $this->safe_string_2($order, 'status', 'state');
        $status = $this->parse_order_status($rawStatus);
        $lastTradeTimestamp = $this->safe_integer($order, 'uTime');
        return $this->safe_order(array(
            'info' => $order,
            'id' => $id,
            'clientOrderId' => $clientOrderId,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'lastTradeTimestamp' => $lastTradeTimestamp,
            'symbol' => $symbol,
            'type' => $type,
            'timeInForce' => null,
            'postOnly' => null,
            'side' => $side,
            'price' => $price,
            'stopPrice' => $this->safe_number($order, 'triggerPrice'),
            'average' => $average,
            'cost' => $cost,
            'amount' => $amount,
            'filled' => $filled,
            'remaining' => null,
            'status' => $status,
            'fee' => $fee,
            'trades' => null,
        ), $market);
    }

    public function create_order($symbol, $type, $side, $amount, $price = null, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        list($marketType, $query) = $this->handle_market_type_and_params('createOrder', $market, $params);
        $request = array(
            'symbol' => $market['id'],
            'orderType' => $type,
        );
        $stopPrice = $this->safe_number_2($params, 'stopPrice', 'triggerPrice');
        if (($type === 'limit') && ($stopPrice === null)) {
            $request['price'] = $price;
        }
        $clientOrderId = $this->safe_string_2($params, 'client_oid', 'clientOrderId');
        if ($clientOrderId === null) {
            $broker = $this->safe_value($this->options, 'broker');
            if ($broker !== null) {
                $brokerId = $this->safe_string($broker, $market['type']);
                if ($brokerId !== null) {
                    $clientOrderId = $brokerId . $this->uuid22();
                }
            }
        }
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'privateSpotPostTradeOrders',
            'swap' => 'privateMixPostOrderPlaceOrder',
        ));
        if ($marketType === 'spot') {
            $request['clientOrderId'] = $clientOrderId;
            $request['quantity'] = $this->amount_to_precision($symbol, $amount);
            $request['side'] = $side;
            $request['force'] = 'gtc';
        } else {
            $request['clientOid'] = $clientOrderId;
            $request['size'] = $this->amount_to_precision($symbol, $amount);
            if ($stopPrice) {
                $triggerType = $this->safe_string($params, 'triggerType');
                if ($triggerType === null) {
                    throw new ArgumentsRequired($this->id . ' createOrder() requires a $triggerType parameter for stop orders, either fill_price or market_price');
                }
                $request['triggerType'] = $triggerType;
                $request['triggerPrice'] = $this->price_to_precision($symbol, $stopPrice);
                $request['executePrice'] = $this->price_to_precision($symbol, $price);
                $method = 'privateMixPostPlanPlacePlan';
            }
            $reduceOnly = $this->safe_value($params, 'reduceOnly', false);
            if ($reduceOnly) {
                $request['side'] = ($side === 'buy') ? 'close_short' : 'close_long';
            } else {
                $request['side'] = ($side === 'buy') ? 'open_long' : 'open_short';
            }
            $request['marginCoin'] = $market['settleId'];
        }
        $params = $this->omit($params, array( 'stopPrice', 'triggerType' ));
        $response = $this->$method (array_merge($request, $query));
        //
        //     {
        //         "code" => "00000",
        //         "msg" => "success",
        //         "requestTime" => 1645932209602,
        //         "data" => {
        //             "orderId" => "881669078313766912",
        //             "clientOrderId" => "iauIBf#a45b595f96474d888d0ada"
        //         }
        //     }
        //
        $data = $this->safe_value($response, 'data');
        return $this->parse_order($data, $market);
    }

    public function cancel_order($id, $symbol = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' cancelOrder() requires a $symbol argument for spot orders');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        list($marketType, $query) = $this->handle_market_type_and_params('cancelOrder', $market, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'privateSpotPostTradeCancelOrder',
            'swap' => 'privateMixPostOrderCancelOrder',
        ));
        $request = array(
            'symbol' => $market['id'],
            'orderId' => $id,
        );
        $stop = $this->safe_value($params, 'stop');
        if ($stop) {
            $planType = $this->safe_string($params, 'planType');
            if ($planType === null) {
                throw new ArgumentsRequired($this->id . ' cancelOrder() requires a $planType parameter for $stop orders, either normal_plan, profit_plan or loss_plan');
            }
            $request['planType'] = $planType;
            $method = 'privateMixPostPlanCancelPlan';
            $params = $this->omit($params, array( 'stop', 'planType' ));
        }
        if ($marketType === 'swap') {
            $request['marginCoin'] = $market['settleId'];
        }
        $response = $this->$method (array_merge($request, $query));
        return $this->parse_order($response, $market);
    }

    public function cancel_orders($ids, $symbol = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' cancelOrders() requires a $symbol argument');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        $type = $this->safe_string($params, 'type', $market['type']);
        if ($type === null) {
            throw new ArgumentsRequired($this->id . " cancelOrders() requires a $type parameter (one of 'spot', 'swap').");
        }
        $params = $this->omit($params, 'type');
        $request = array();
        $method = null;
        if ($type === 'spot') {
            $method = 'apiPostOrderOrdersBatchcancel';
            $request['method'] = 'batchcancel';
            $jsonIds = $this->json($ids);
            $parts = explode('"', $jsonIds);
            $request['order_ids'] = implode('', $parts);
        } elseif ($type === 'swap') {
            $method = 'swapPostOrderCancelBatchOrders';
            $request['symbol'] = $market['id'];
            $request['ids'] = $ids;
        }
        $response = $this->$method (array_merge($request, $params));
        //
        //     spot
        //
        //     {
        //         "status" => "ok",
        //         "data" => {
        //             "success" => array(
        //                 "673451224205135872",
        //             ),
        //             "failed" => array(
        //                 {
        //                 "err-msg" => "invalid record",
        //                 "order-id" => "673451224205135873",
        //                 "err-code" => "base record invalid"
        //                 }
        //             )
        //         }
        //     }
        //
        //     swap
        //
        //     {
        //         "result":true,
        //         "symbol":"cmt_btcusdt",
        //         "order_ids":array(
        //             "258414711",
        //             "478585558"
        //         ),
        //         "fail_infos":array(
        //             {
        //                 "order_id":"258414711",
        //                 "err_code":"401",
        //                 "err_msg":""
        //             }
        //         )
        //     }
        //
        return $response;
    }

    public function fetch_order($id, $symbol = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' fetchOrder() requires a $symbol argument');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        list($marketType, $query) = $this->handle_market_type_and_params('fetchOrder', $market, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'privateSpotPostTradeOrderInfo',
            'swap' => 'privateMixGetOrderDetail',
        ));
        $request = array(
            'symbol' => $market['id'],
            'orderId' => $id,
        );
        $response = $this->$method (array_merge($request, $query));
        // spot
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => '1645926849436',
        //       $data => array(
        //         {
        //           accountId => '6394957606',
        //           $symbol => 'BTCUSDT_SPBL',
        //           orderId => '881626139738935296',
        //           clientOrderId => '525890c8-767e-4cd6-8585-38160ed7bb5e',
        //           price => '38000.000000000000',
        //           quantity => '0.000700000000',
        //           orderType => 'limit',
        //           side => 'buy',
        //           status => 'new',
        //           fillPrice => '0.000000000000',
        //           fillQuantity => '0.000000000000',
        //           fillTotalAmount => '0.000000000000',
        //           cTime => '1645921972212'
        //         }
        //       )
        //     }
        //
        // swap
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => '1645926587877',
        //       $data => {
        //         $symbol => 'BTCUSDT_UMCBL',
        //         size => '0.001',
        //         orderId => '881640729145409536',
        //         clientOid => '881640729204129792',
        //         filledQty => '0.001',
        //         fee => '0E-8',
        //         price => null,
        //         priceAvg => '38429.50',
        //         state => 'filled',
        //         side => 'open_long',
        //         timeInForce => 'normal',
        //         totalProfits => '0E-8',
        //         posSide => 'long',
        //         marginCoin => 'USDT',
        //         filledAmount => '38.4295',
        //         orderType => 'market',
        //         cTime => '1645925450611',
        //         uTime => '1645925450746'
        //       }
        //     }
        //
        $data = $this->safe_value($response, 'data');
        $first = $this->safe_value($data, 0, $data);
        return $this->parse_order($first, $market);
    }

    public function fetch_open_orders($symbol = null, $since = null, $limit = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' fetchOpenOrders() requires a $symbol argument');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        list($marketType, $query) = $this->handle_market_type_and_params('fetchOpenOrders', $market, $params);
        $request = array(
            'symbol' => $market['id'],
        );
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'privateSpotPostTradeOpenOrders',
            'swap' => 'privateMixGetOrderCurrent',
        ));
        $stop = $this->safe_value($params, 'stop');
        if ($stop) {
            $method = 'privateMixGetPlanCurrentPlan';
            $params = $this->omit($params, 'stop');
        }
        $response = $this->$method (array_merge($request, $query));
        //
        //  spot
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645921640193,
        //       $data => array(
        //         {
        //           accountId => '6394957606',
        //           $symbol => 'BTCUSDT_SPBL',
        //           orderId => '881623995442958336',
        //           clientOrderId => '135335e9-b054-4e43-b00a-499f11d3a5cc',
        //           price => '39000.000000000000',
        //           quantity => '0.000700000000',
        //           orderType => 'limit',
        //           side => 'buy',
        //           status => 'new',
        //           fillPrice => '0.000000000000',
        //           fillQuantity => '0.000000000000',
        //           fillTotalAmount => '0.000000000000',
        //           cTime => '1645921460972'
        //         }
        //       )
        //     }
        //
        // swap
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645922324630,
        //       $data => array(
        //         {
        //           $symbol => 'BTCUSDT_UMCBL',
        //           size => 0.001,
        //           orderId => '881627074081226752',
        //           clientOid => '881627074160918528',
        //           filledQty => 0,
        //           fee => 0,
        //           price => 38000,
        //           state => 'new',
        //           side => 'open_long',
        //           timeInForce => 'normal',
        //           totalProfits => 0,
        //           posSide => 'long',
        //           marginCoin => 'USDT',
        //           filledAmount => 0,
        //           orderType => 'limit',
        //           cTime => '1645922194995',
        //           uTime => '1645922194995'
        //         }
        //       )
        //     }
        //
        // $stop
        //
        //     {
        //         "code" => "00000",
        //         "msg" => "success",
        //         "requestTime" => 1652745815697,
        //         "data" => array(
        //             {
        //                 "orderId" => "910246821491617792",
        //                 "symbol" => "BTCUSDT_UMCBL",
        //                 "marginCoin" => "USDT",
        //                 "size" => "16",
        //                 "executePrice" => "20000",
        //                 "triggerPrice" => "24000",
        //                 "status" => "not_trigger",
        //                 "orderType" => "limit",
        //                 "planType" => "normal_plan",
        //                 "side" => "open_long",
        //                 "triggerType" => "market_price",
        //                 "presetTakeProfitPrice" => "0",
        //                 "presetTakeLossPrice" => "0",
        //                 "cTime" => "1652745674488"
        //             }
        //         )
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        return $this->parse_orders($data, $market, $since, $limit);
    }

    public function fetch_closed_orders($symbol = null, $since = null, $limit = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' fetchClosedOrders() requires a $symbol argument');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        list($marketType, $query) = $this->handle_market_type_and_params('fetchClosedOrders', $market, $params);
        $request = array(
            'symbol' => $market['id'],
        );
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'privateSpotPostTradeHistory',
            'swap' => 'privateMixGetOrderHistory',
        ));
        if ($marketType === 'swap') {
            if ($limit === null) {
                $limit = 100;
            }
            $request['pageSize'] = $limit;
            if ($since === null) {
                $since = 0;
            }
            $request['startTime'] = $since;
            $request['endTime'] = $this->milliseconds();
        }
        $response = $this->$method (array_merge($request, $query));
        //
        //  spot
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645925335553,
        //       $data => array(
        //         {
        //           accountId => '6394957606',
        //           $symbol => 'BTCUSDT_SPBL',
        //           orderId => '881623995442958336',
        //           clientOrderId => '135335e9-b054-4e43-b00a-499f11d3a5cc',
        //           price => '39000.000000000000',
        //           quantity => '0.000700000000',
        //           orderType => 'limit',
        //           side => 'buy',
        //           status => 'full_fill',
        //           fillPrice => '39000.000000000000',
        //           fillQuantity => '0.000700000000',
        //           fillTotalAmount => '27.300000000000',
        //           cTime => '1645921460972'
        //         }
        //       )
        //     }
        //
        // swap
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645925688701,
        //       $data => {
        //         nextFlag => false,
        //         endId => '881640729145409536',
        //         $orderList => array(
        //           {
        //             $symbol => 'BTCUSDT_UMCBL',
        //             size => 0.001,
        //             orderId => '881640729145409536',
        //             clientOid => '881640729204129792',
        //             filledQty => 0.001,
        //             fee => 0,
        //             price => null,
        //             priceAvg => 38429.5,
        //             state => 'filled',
        //             side => 'open_long',
        //             timeInForce => 'normal',
        //             totalProfits => 0,
        //             posSide => 'long',
        //             marginCoin => 'USDT',
        //             filledAmount => 38.4295,
        //             orderType => 'market',
        //             cTime => '1645925450611',
        //             uTime => '1645925450746'
        //           }
        //         )
        //       }
        //     }
        //
        $data = $this->safe_value($response, 'data');
        $orderList = $this->safe_value($data, 'orderList', $data);
        return $this->parse_orders($orderList, $market, $since, $limit);
    }

    public function fetch_ledger($code = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $currency = null;
        $request = array();
        if ($code !== null) {
            $currency = $this->currency($code);
            $request['coinId'] = $currency['id'];
        }
        $response = $this->privateSpotPostAccountBills (array_merge($request, $params));
        //
        //     {
        //       $code => '00000',
        //       msg => 'success',
        //       requestTime => '1645929886887',
        //       $data => array(
        //         {
        //           billId => '881626974170554368',
        //           coinId => '2',
        //           coinName => 'USDT',
        //           groupType => 'transfer',
        //           bizType => 'transfer-out',
        //           quantity => '-10.00000000',
        //           balance => '73.36005300',
        //           fees => '0.00000000',
        //           cTime => '1645922171146'
        //         }
        //       )
        //     }
        //
        $data = $this->safe_value($response, 'data');
        return $this->parse_ledger($data, $currency, $since, $limit);
    }

    public function parse_ledger_entry($item, $currency = null) {
        //
        //     {
        //       billId => '881626974170554368',
        //       coinId => '2',
        //       coinName => 'USDT',
        //       groupType => 'transfer',
        //       $bizType => 'transfer-out',
        //       quantity => '-10.00000000',
        //       balance => '73.36005300',
        //       fees => '0.00000000',
        //       cTime => '1645922171146'
        //     }
        //
        $id = $this->safe_string($item, 'billId');
        $currencyId = $this->safe_string($item, 'coinId');
        $code = $this->safe_currency_code($currencyId);
        $amount = $this->parse_number(Precise::string_abs($this->safe_string($item, 'quantity')));
        $timestamp = $this->safe_integer($item, 'cTime');
        $bizType = $this->safe_string($item, 'bizType');
        $direction = null;
        if ($bizType !== null) {
            $parts = explode('-', $bizType);
            $direction = $parts[1];
        }
        $type = $this->safe_string($item, 'groupType');
        $fee = $this->safe_number($item, 'fees');
        $after = $this->safe_number($item, 'balance');
        return array(
            'info' => $item,
            'id' => $id,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'direction' => $direction,
            'account' => null,
            'referenceId' => null,
            'referenceAccount' => null,
            'type' => $type,
            'currency' => $code,
            'amount' => $amount,
            'before' => null,
            'after' => $after,
            'status' => null,
            'fee' => $fee,
        );
    }

    public function fetch_my_trades($symbol = null, $since = null, $limit = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' fetchMyTrades() requires a $symbol argument');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        if ($market['swap']) {
            throw new BadSymbol($this->id . ' fetchMyTrades() only supports spot markets');
        }
        $request = array(
            'symbol' => $market['id'],
        );
        if ($limit !== null) {
            $request['limit'] = $limit;
        }
        $response = $this->privateSpotPostTradeFills (array_merge($request, $params));
        //
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => '1645918954082',
        //       $data => array(
        //         {
        //           accountId => '6394957606',
        //           $symbol => 'LTCUSDT_SPBL',
        //           orderId => '864752115272552448',
        //           fillId => '864752115685969921',
        //           orderType => 'limit',
        //           side => 'buy',
        //           fillPrice => '127.92000000',
        //           fillQuantity => '0.10000000',
        //           fillTotalAmount => '12.79200000',
        //           feeCcy => 'LTC',
        //           fees => '0.00000000',
        //           cTime => '1641898891373'
        //         }
        //       )
        //     }
        //
        $data = $this->safe_value($response, 'data');
        return $this->parse_trades($data, $market, $since, $limit);
    }

    public function fetch_order_trades($id, $symbol = null, $since = null, $limit = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' fetchOrderTrades() requires a $symbol argument');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        list($marketType, $query) = $this->handle_market_type_and_params('fetchOrderTrades', $market, $params);
        $method = $this->get_supported_mapping($marketType, array(
            'spot' => 'privateSpotPostTradeFills',
            'swap' => 'privateMixGetOrderFills',
        ));
        $request = array(
            'symbol' => $market['id'],
            'orderId' => $id,
        );
        $response = $this->$method (array_merge($request, $query));
        // spot
        //
        // swap
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => 1645927862710,
        //       $data => array(
        //         {
        //           tradeId => '881640729552281602',
        //           $symbol => 'BTCUSDT_UMCBL',
        //           orderId => '881640729145409536',
        //           price => '38429.50',
        //           sizeQty => '0.001',
        //           fee => '0',
        //           side => 'open_long',
        //           fillAmount => '38.4295',
        //           profit => '0',
        //           cTime => '1645925450694'
        //         }
        //       )
        //     }
        //
        $data = $this->safe_value($response, 'data');
        return $this->parse_trades($data, $market, $since, $limit);
    }

    public function fetch_position($symbol, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
            'marginCoin' => $market['settleId'],
        );
        $response = $this->privateMixGetPositionSinglePosition (array_merge($request, $params));
        //
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => '1645933957584',
        //       $data => array(
        //         {
        //           marginCoin => 'USDT',
        //           $symbol => 'BTCUSDT_UMCBL',
        //           holdSide => 'long',
        //           openDelegateCount => '0',
        //           margin => '1.921475',
        //           available => '0.001',
        //           locked => '0',
        //           total => '0.001',
        //           leverage => '20',
        //           achievedProfits => '0',
        //           averageOpenPrice => '38429.5',
        //           marginMode => 'fixed',
        //           holdMode => 'double_hold',
        //           unrealizedPL => '0.1634',
        //           liquidationPrice => '0',
        //           keepMarginRate => '0.004',
        //           cTime => '1645922194988'
        //         }
        //       )
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        return $this->parse_position($data[0], $market);
    }

    public function fetch_positions($symbols = null, $params = array ()) {
        $this->load_markets();
        $defaultSubType = $this->safe_string($this->options, 'defaultSubType');
        $request = array(
            'productType' => ($defaultSubType === 'linear') ? 'UMCBL' : 'DMCBL',
        );
        $response = $this->privateMixGetPositionAllPosition (array_merge($request, $params));
        //
        //     {
        //       code => '00000',
        //       msg => 'success',
        //       requestTime => '1645933905060',
        //       data => array(
        //         {
        //           marginCoin => 'USDT',
        //           symbol => 'BTCUSDT_UMCBL',
        //           holdSide => 'long',
        //           openDelegateCount => '0',
        //           margin => '1.921475',
        //           available => '0.001',
        //           locked => '0',
        //           total => '0.001',
        //           leverage => '20',
        //           achievedProfits => '0',
        //           averageOpenPrice => '38429.5',
        //           marginMode => 'fixed',
        //           holdMode => 'double_hold',
        //           unrealizedPL => '0.14869',
        //           liquidationPrice => '0',
        //           keepMarginRate => '0.004',
        //           cTime => '1645922194988'
        //         }
        //       )
        //     }
        //
        $position = $this->safe_value($response, 'data', array());
        $result = array();
        for ($i = 0; $i < count($position); $i++) {
            $result[] = $this->parse_position($position[$i]);
        }
        return $this->filter_by_array($result, 'symbol', $symbols, false);
    }

    public function parse_position($position, $market = null) {
        //
        //     {
        //         marginCoin => 'USDT',
        //         symbol => 'BTCUSDT_UMCBL',
        //         holdSide => 'long',
        //         openDelegateCount => '0',
        //         margin => '1.921475',
        //         available => '0.001',
        //         locked => '0',
        //         total => '0.001',
        //         leverage => '20',
        //         achievedProfits => '0',
        //         averageOpenPrice => '38429.5',
        //         $marginMode => 'fixed',
        //         holdMode => 'double_hold',
        //         unrealizedPL => '0.14869',
        //         liquidationPrice => '0',
        //         keepMarginRate => '0.004',
        //         cTime => '1645922194988'
        //     }
        //
        $marketId = $this->safe_string($position, 'symbol');
        $market = $this->safe_market($marketId, $market);
        $timestamp = $this->safe_integer($position, 'cTime');
        $marginMode = $this->safe_string($position, 'marginMode');
        if ($marginMode === 'fixed') {
            $marginMode = 'isolated';
        } elseif ($marginMode === 'crossed') {
            $marginMode = 'cross';
        }
        $hedged = $this->safe_string($position, 'holdMode');
        if ($hedged === 'double_hold') {
            $hedged = true;
        } elseif ($hedged === 'single_hold') {
            $hedged = false;
        }
        $contracts = $this->safe_integer($position, 'openDelegateCount');
        $liquidation = $this->safe_number($position, 'liquidationPrice');
        if ($contracts === 0) {
            $contracts = null;
        }
        if ($liquidation === 0) {
            $liquidation = null;
        }
        return array(
            'info' => $position,
            'id' => null,
            'symbol' => $market['symbol'],
            'notional' => null,
            'marginMode' => $marginMode,
            'marginType' => null, // deprecated
            'liquidationPrice' => $liquidation,
            'entryPrice' => $this->safe_number($position, 'averageOpenPrice'),
            'unrealizedPnl' => $this->safe_number($position, 'unrealizedPL'),
            'percentage' => null,
            'contracts' => $contracts,
            'contractSize' => $this->safe_number($position, 'total'),
            'markPrice' => null,
            'side' => $this->safe_string($position, 'holdSide'),
            'hedged' => $hedged,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'maintenanceMargin' => null,
            'maintenanceMarginPercentage' => $this->safe_number($position, 'keepMarginRate'),
            'collateral' => $this->safe_number($position, 'margin'),
            'initialMargin' => null,
            'initialMarginPercentage' => null,
            'leverage' => $this->safe_number($position, 'leverage'),
            'marginRatio' => null,
        );
    }

    public function fetch_funding_rate_history($symbol = null, $since = null, $limit = null, $params = array ()) {
        /**
         * fetches historical funding rate prices
         * @param {str|null} $symbol unified $symbol of the $market to fetch the funding rate history for
         * @param {int|null} $since $timestamp in ms of the earliest funding rate to fetch
         * @param {int|null} $limit the maximum amount of ~@link https://docs.ccxt.com/en/latest/manual.html?#funding-rate-history-structure funding rate structures~ to fetch
         * @param {dict} $params extra parameters specific to the bitget api endpoint
         * @return {[dict]} a list of ~@link https://docs.ccxt.com/en/latest/manual.html?#funding-rate-history-structure funding rate structures~
         */
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' fetchFundingRateHistory() requires a $symbol argument');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
            // 'pageSize' => $limit, // default 20
            // 'pageNo' => 1,
            // 'nextPage' => false,
        );
        if ($limit !== null) {
            $request['pageSize'] = $limit;
        }
        $response = $this->publicMixGetMarketHistoryFundRate (array_merge($request, $params));
        //
        //     {
        //         "code" => "00000",
        //         "msg" => "success",
        //         "requestTime" => 1652406728393,
        //         "data" => array(
        //             array(
        //                 "symbol" => "BTCUSDT",
        //                 "fundingRate" => "-0.0003",
        //                 "settleTime" => "1652396400000"
        //             ),
        //         )
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        $rates = array();
        for ($i = 0; $i < count($data); $i++) {
            $entry = $data[$i];
            $marketId = $this->safe_string($entry, 'symbol');
            $symbol = $this->safe_symbol($marketId, $market);
            $timestamp = $this->safe_integer($entry, 'settleTime');
            $rates[] = array(
                'info' => $entry,
                'symbol' => $symbol,
                'fundingRate' => $this->safe_string($entry, 'fundingRate'),
                'timestamp' => $timestamp,
                'datetime' => $this->iso8601($timestamp),
            );
        }
        $sorted = $this->sort_by($rates, 'timestamp');
        return $this->filter_by_symbol_since_limit($sorted, $market['symbol'], $since, $limit);
    }

    public function fetch_funding_rate($symbol, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        if (!$market['swap']) {
            throw new BadSymbol($this->id . ' fetchFundingRate() supports swap contracts only');
        }
        $request = array(
            'symbol' => $market['id'],
        );
        $response = $this->publicMixGetMarketCurrentFundRate (array_merge($request, $params));
        //
        //     {
        //         "code" => "00000",
        //         "msg" => "success",
        //         "requestTime" => 1652401684275,
        //         "data" => {
        //             "symbol" => "BTCUSDT_UMCBL",
        //             "fundingRate" => "-0.000182"
        //         }
        //     }
        //
        $data = $this->safe_value($response, 'data', array());
        return $this->parse_funding_rate($data, $market);
    }

    public function parse_funding_rate($contract, $market = null) {
        //
        //     {
        //         "symbol" => "BTCUSDT_UMCBL",
        //         "fundingRate" => "-0.000182"
        //     }
        //
        $marketId = $this->safe_string($contract, 'symbol');
        $symbol = $this->safe_symbol($marketId, $market);
        return array(
            'info' => $contract,
            'symbol' => $symbol,
            'markPrice' => null,
            'indexPrice' => null,
            'interestRate' => null,
            'estimatedSettlePrice' => null,
            'timestamp' => null,
            'datetime' => null,
            'fundingRate' => $this->safe_number($contract, 'fundingRate'),
            'fundingTimestamp' => null,
            'fundingDatetime' => null,
            'nextFundingRate' => null,
            'nextFundingTimestamp' => null,
            'nextFundingDatetime' => null,
            'previousFundingRate' => null,
            'previousFundingTimestamp' => null,
            'previousFundingDatetime' => null,
        );
    }

    public function modify_margin_helper($symbol, $amount, $type, $params = array ()) {
        $this->load_markets();
        $holdSide = $this->safe_string($params, 'holdSide');
        $market = $this->market($symbol);
        $marginCoin = ($market['linear']) ? $market['quote'] : $market['base'];
        $request = array(
            'symbol' => $market['id'],
            'marginCoin' => $marginCoin,
            'amount' => $this->amount_to_precision($symbol, $amount), // positive value for adding margin, negative for reducing
            'holdSide' => $holdSide, // long or short
        );
        $params = $this->omit($params, 'holdSide');
        $response = $this->privateMixPostAccountSetMargin (array_merge($request, $params));
        //
        //     {
        //         "code" => "00000",
        //         "msg" => "success",
        //         "requestTime" => 1652483636792,
        //         "data" => {
        //             "result" => true
        //         }
        //     }
        //
        return array_merge($this->parse_margin_modification($response, $market), array(
            'amount' => $this->parse_number($amount),
            'type' => $type,
        ));
    }

    public function parse_margin_modification($data, $market = null) {
        $errorCode = $this->safe_string($data, 'code');
        $status = ($errorCode === '00000') ? 'ok' : 'failed';
        $code = ($market['linear']) ? $market['quote'] : $market['base'];
        return array(
            'info' => $data,
            'type' => null,
            'amount' => null,
            'code' => $code,
            'symbol' => $market['symbol'],
            'status' => $status,
        );
    }

    public function reduce_margin($symbol, $amount, $params = array ()) {
        if ($amount > 0) {
            throw new BadRequest($this->id . ' reduceMargin() $amount parameter must be a negative value');
        }
        $holdSide = $this->safe_string($params, 'holdSide');
        if ($holdSide === null) {
            throw new ArgumentsRequired($this->id . ' reduceMargin() requires a $holdSide parameter, either long or short');
        }
        return $this->modify_margin_helper($symbol, $amount, 'reduce', $params);
    }

    public function add_margin($symbol, $amount, $params = array ()) {
        $holdSide = $this->safe_string($params, 'holdSide');
        if ($holdSide === null) {
            throw new ArgumentsRequired($this->id . ' addMargin() requires a $holdSide parameter, either long or short');
        }
        return $this->modify_margin_helper($symbol, $amount, 'add', $params);
    }

    public function sign($path, $api = [], $method = 'GET', $params = array (), $headers = null, $body = null) {
        $signed = $api[0] === 'private';
        $endpoint = $api[1];
        $pathPart = ($endpoint === 'spot') ? '/api/spot/v1' : '/api/mix/v1';
        $request = '/' . $this->implode_params($path, $params);
        $payload = $pathPart . $request;
        $url = $this->implode_hostname($this->urls['api'][$endpoint]) . $payload;
        $query = $this->omit($params, $this->extract_params($path));
        if (!$signed && ($method === 'GET')) {
            $keys = is_array($query) ? array_keys($query) : array();
            if (strlen($keys)) {
                $url = $url . '?' . $this->urlencode($query);
            }
        }
        if ($signed) {
            $this->check_required_credentials();
            $timestamp = (string) $this->milliseconds();
            $auth = $timestamp . $method . $payload;
            if ($method === 'POST') {
                $body = $this->json($params);
                $auth .= $body;
            } else {
                if ($params) {
                    $query = '?' . $this->urlencode($this->keysort($params));
                    $url .= $query;
                    $auth .= $query;
                }
            }
            $signature = $this->hmac($this->encode($auth), $this->encode($this->secret), 'sha256', 'base64');
            $headers = array(
                'ACCESS-KEY' => $this->apiKey,
                'ACCESS-SIGN' => $signature,
                'ACCESS-TIMESTAMP' => $timestamp,
                'ACCESS-PASSPHRASE' => $this->password,
            );
            if ($method === 'POST') {
                $headers['Content-Type'] = 'application/json';
            }
        }
        return array( 'url' => $url, 'method' => $method, 'body' => $body, 'headers' => $headers );
    }

    public function fetch_leverage($symbol, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        $response = $this->publicMixGetMarketSymbolLeverage (array_merge($request, $params));
        //
        //     {
        //         "code" => "00000",
        //         "msg" => "success",
        //         "requestTime" => 1652347673483,
        //         "data" => {
        //             "symbol" => "BTCUSDT_UMCBL",
        //             "minLeverage" => "1",
        //             "maxLeverage" => "125"
        //         }
        //     }
        //
        return $response;
    }

    public function set_leverage($leverage, $symbol = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' setLeverage() requires a $symbol argument');
        }
        $holdSide = $this->safe_string($params, 'holdSide');
        if ($holdSide === null) {
            throw new ArgumentsRequired($this->id . ' setLeverage() requires a $holdSide param');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
            'marginCoin' => $market['settleId'],
            'leverage' => $leverage,
            'holdSide' => $holdSide,
        );
        return $this->privateMixPostAccountSetLeverage (array_merge($request, $params));
    }

    public function set_margin_mode($marginMode, $symbol = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' setMarginMode() requires a $symbol argument');
        }
        $marginMode = strtolower($marginMode);
        if (($marginMode !== 'fixed') && ($marginMode !== 'crossed')) {
            throw new ArgumentsRequired($this->id . ' setMarginMode() $marginMode must be "fixed" or "crossed"');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
            'marginCoin' => $market['settleId'],
            'marginMode' => $marginMode,
        );
        return $this->privateMixPostAccountSetMarginMode (array_merge($request, $params));
    }

    public function handle_errors($code, $reason, $url, $method, $headers, $body, $response, $requestHeaders, $requestBody) {
        if (!$response) {
            return; // fallback to default error handler
        }
        //
        // spot
        //
        //     array("status":"fail","err_code":"01001","err_msg":"系统异常，请稍后重试")
        //     array("status":"error","ts":1595594160149,"err_code":"invalid-parameter","err_msg":"invalid size, valid range => [1,2000]")
        //     array("status":"error","ts":1595684716042,"err_code":"invalid-parameter","err_msg":"illegal sign invalid")
        //     array("status":"error","ts":1595700216275,"err_code":"bad-request","err_msg":"your balance is low!")
        //     array("status":"error","ts":1595700344504,"err_code":"invalid-parameter","err_msg":"invalid type")
        //     array("status":"error","ts":1595703343035,"err_code":"bad-request","err_msg":"order cancel fail")
        //     array("status":"error","ts":1595704360508,"err_code":"invalid-parameter","err_msg":"accesskey not null")
        //     array("status":"error","ts":1595704490084,"err_code":"invalid-parameter","err_msg":"permissions not right")
        //     array("status":"error","ts":1595711862763,"err_code":"system exception","err_msg":"system exception")
        //     array("status":"error","ts":1595730308979,"err_code":"bad-request","err_msg":"20003")
        //
        // swap
        //
        //     array("code":"40015","msg":"","requestTime":1595698564931,"data":null)
        //     array("code":"40017","msg":"Order id must not be blank","requestTime":1595702477835,"data":null)
        //     array("code":"40017","msg":"Order Type must not be blank","requestTime":1595698516162,"data":null)
        //     array("code":"40301","msg":"","requestTime":1595667662503,"data":null)
        //     array("code":"40017","msg":"Contract $code must not be blank","requestTime":1595703151651,"data":null)
        //     array("code":"40108","msg":"","requestTime":1595885064600,"data":null)
        //     array("order_id":"513468410013679613","client_oid":null,"symbol":"ethusd","result":false,"err_code":"order_no_exist_error","err_msg":"订单不存在！")
        //
        $message = $this->safe_string($response, 'err_msg');
        $errorCode = $this->safe_string_2($response, 'code', 'err_code');
        $feedback = $this->id . ' ' . $body;
        $nonEmptyMessage = (($message !== null) && ($message !== ''));
        if ($nonEmptyMessage) {
            $this->throw_exactly_matched_exception($this->exceptions['exact'], $message, $feedback);
            $this->throw_broadly_matched_exception($this->exceptions['broad'], $message, $feedback);
        }
        $nonZeroErrorCode = ($errorCode !== null) && ($errorCode !== '00000');
        if ($nonZeroErrorCode) {
            $this->throw_exactly_matched_exception($this->exceptions['exact'], $errorCode, $feedback);
        }
        if ($nonZeroErrorCode || $nonEmptyMessage) {
            throw new ExchangeError($feedback); // unknown $message
        }
    }
}
