<?php

namespace ccxt;

// PLEASE DO NOT EDIT THIS FILE, IT IS GENERATED AND WILL BE OVERWRITTEN:
// https://github.com/ccxt/ccxt/blob/master/CONTRIBUTING.md#how-to-contribute-code

use Exception; // a common import
use \ccxt\ExchangeError;
use \ccxt\ArgumentsRequired;
use \ccxt\BadRequest;
use \ccxt\BadSymbol;
use \ccxt\InvalidOrder;
use \ccxt\OrderNotFound;
use \ccxt\DDoSProtection;

class bitmex extends Exchange {

    public function describe() {
        return $this->deep_extend(parent::describe (), array(
            'id' => 'bitmex',
            'name' => 'BitMEX',
            'countries' => array( 'SC' ), // Seychelles
            'version' => 'v1',
            'userAgent' => null,
            'rateLimit' => 2000,
            'pro' => true,
            'has' => array(
                'CORS' => null,
                'spot' => false,
                'margin' => false,
                'swap' => true,
                'future' => true,
                'option' => false,
                'addMargin' => null,
                'cancelAllOrders' => true,
                'cancelOrder' => true,
                'cancelOrders' => true,
                'createOrder' => true,
                'createReduceOnlyOrder' => true,
                'editOrder' => true,
                'fetchBalance' => true,
                'fetchClosedOrders' => true,
                'fetchFundingHistory' => false,
                'fetchFundingRate' => false,
                'fetchFundingRateHistory' => true,
                'fetchFundingRates' => true,
                'fetchIndexOHLCV' => false,
                'fetchLedger' => true,
                'fetchLeverage' => false,
                'fetchLeverageTiers' => false,
                'fetchMarketLeverageTiers' => false,
                'fetchMarkets' => true,
                'fetchMarkOHLCV' => false,
                'fetchMyTrades' => true,
                'fetchOHLCV' => true,
                'fetchOpenOrders' => true,
                'fetchOrder' => true,
                'fetchOrderBook' => true,
                'fetchOrders' => true,
                'fetchPosition' => false,
                'fetchPositions' => true,
                'fetchPositionsRisk' => false,
                'fetchPremiumIndexOHLCV' => false,
                'fetchTicker' => true,
                'fetchTickers' => true,
                'fetchTrades' => true,
                'fetchTransactions' => 'emulated',
                'fetchTransfer' => false,
                'fetchTransfers' => false,
                'reduceMargin' => null,
                'setLeverage' => true,
                'setMargin' => null,
                'setMarginMode' => true,
                'setPositionMode' => false,
                'transfer' => false,
                'withdraw' => true,
            ),
            'timeframes' => array(
                '1m' => '1m',
                '5m' => '5m',
                '1h' => '1h',
                '1d' => '1d',
            ),
            'urls' => array(
                'test' => array(
                    'public' => 'https://testnet.bitmex.com',
                    'private' => 'https://testnet.bitmex.com',
                ),
                'logo' => 'https://user-images.githubusercontent.com/1294454/27766319-f653c6e6-5ed4-11e7-933d-f0bc3699ae8f.jpg',
                'api' => array(
                    'public' => 'https://www.bitmex.com',
                    'private' => 'https://www.bitmex.com',
                ),
                'www' => 'https://www.bitmex.com',
                'doc' => array(
                    'https://www.bitmex.com/app/apiOverview',
                    'https://github.com/BitMEX/api-connectors/tree/master/official-http',
                ),
                'fees' => 'https://www.bitmex.com/app/fees',
                'referral' => 'https://www.bitmex.com/register/upZpOX',
            ),
            'api' => array(
                'public' => array(
                    'get' => array(
                        'announcement',
                        'announcement/urgent',
                        'funding',
                        'instrument',
                        'instrument/active',
                        'instrument/activeAndIndices',
                        'instrument/activeIntervals',
                        'instrument/compositeIndex',
                        'instrument/indices',
                        'insurance',
                        'leaderboard',
                        'liquidation',
                        'orderBook',
                        'orderBook/L2',
                        'quote',
                        'quote/bucketed',
                        'schema',
                        'schema/websocketHelp',
                        'settlement',
                        'stats',
                        'stats/history',
                        'trade',
                        'trade/bucketed',
                    ),
                ),
                'private' => array(
                    'get' => array(
                        'apiKey',
                        'chat',
                        'chat/channels',
                        'chat/connected',
                        'execution',
                        'execution/tradeHistory',
                        'notification',
                        'order',
                        'position',
                        'user',
                        'user/affiliateStatus',
                        'user/checkReferralCode',
                        'user/commission',
                        'user/depositAddress',
                        'user/executionHistory',
                        'user/margin',
                        'user/minWithdrawalFee',
                        'user/wallet',
                        'user/walletHistory',
                        'user/walletSummary',
                    ),
                    'post' => array(
                        'apiKey',
                        'apiKey/disable',
                        'apiKey/enable',
                        'chat',
                        'order',
                        'order/bulk',
                        'order/cancelAllAfter',
                        'order/closePosition',
                        'position/isolate',
                        'position/leverage',
                        'position/riskLimit',
                        'position/transferMargin',
                        'user/cancelWithdrawal',
                        'user/confirmEmail',
                        'user/confirmEnableTFA',
                        'user/confirmWithdrawal',
                        'user/disableTFA',
                        'user/logout',
                        'user/logoutAll',
                        'user/preferences',
                        'user/requestEnableTFA',
                        'user/requestWithdrawal',
                    ),
                    'put' => array(
                        'order',
                        'order/bulk',
                        'user',
                    ),
                    'delete' => array(
                        'apiKey',
                        'order',
                        'order/all',
                    ),
                ),
            ),
            'exceptions' => array(
                'exact' => array(
                    'Invalid API Key.' => '\\ccxt\\AuthenticationError',
                    'This key is disabled.' => '\\ccxt\\PermissionDenied',
                    'Access Denied' => '\\ccxt\\PermissionDenied',
                    'Duplicate clOrdID' => '\\ccxt\\InvalidOrder',
                    'orderQty is invalid' => '\\ccxt\\InvalidOrder',
                    'Invalid price' => '\\ccxt\\InvalidOrder',
                    'Invalid stopPx for ordType' => '\\ccxt\\InvalidOrder',
                ),
                'broad' => array(
                    'Signature not valid' => '\\ccxt\\AuthenticationError',
                    'overloaded' => '\\ccxt\\ExchangeNotAvailable',
                    'Account has insufficient Available Balance' => '\\ccxt\\InsufficientFunds',
                    'Service unavailable' => '\\ccxt\\ExchangeNotAvailable', // array("error":array("message":"Service unavailable","name":"HTTPError"))
                    'Server Error' => '\\ccxt\\ExchangeError', // array("error":array("message":"Server Error","name":"HTTPError"))
                    'Unable to cancel order due to existing state' => '\\ccxt\\InvalidOrder',
                ),
            ),
            'precisionMode' => TICK_SIZE,
            'options' => array(
                // https://blog.bitmex.com/api_announcement/deprecation-of-api-nonce-header/
                // https://github.com/ccxt/ccxt/issues/4789
                'api-expires' => 5, // in seconds
                'fetchOHLCVOpenTimestamp' => true,
            ),
            'commonCurrencies' => array(
                'USDt' => 'USDT',
                'XBt' => 'BTC',
                'XBT' => 'BTC',
            ),
        ));
    }

    public function fetch_markets($params = array ()) {
        /**
         * retrieves data on all markets for bitmex
         * @param {dict} $params extra parameters specific to the exchange api endpoint
         * @return {[dict]} an array of objects representing $market data
         */
        $response = $this->publicGetInstrumentActiveAndIndices ($params);
        //
        //    {
        //        "symbol" => "LTCUSDT",
        //        "rootSymbol" => "LTC",
        //        "state" => "Open",
        //        "typ" => "FFWCSX",
        //        "listing" => "2021-11-10T04:00:00.000Z",
        //        "front" => "2021-11-10T04:00:00.000Z",
        //        "expiry" => null,
        //        "settle" => null,
        //        "listedSettle" => null,
        //        "relistInterval" => null,
        //        "inverseLeg" => "",
        //        "sellLeg" => "",
        //        "buyLeg" => "",
        //        "optionStrikePcnt" => null,
        //        "optionStrikeRound" => null,
        //        "optionStrikePrice" => null,
        //        "optionMultiplier" => null,
        //        "positionCurrency" => "LTC",
        //        "underlying" => "LTC",
        //        "quoteCurrency" => "USDT",
        //        "underlyingSymbol" => "LTCT=",
        //        "reference" => "BMEX",
        //        "referenceSymbol" => ".BLTCT",
        //        "calcInterval" => null,
        //        "publishInterval" => null,
        //        "publishTime" => null,
        //        "maxOrderQty" => 1000000000,
        //        "maxPrice" => 1000000,
        //        "lotSize" => 1000,
        //        "tickSize" => 0.01,
        //        "multiplier" => 100,
        //        "settlCurrency" => "USDt",
        //        "underlyingToPositionMultiplier" => 10000,
        //        "underlyingToSettleMultiplier" => null,
        //        "quoteToSettleMultiplier" => 1000000,
        //        "isQuanto" => false,
        //        "isInverse" => false,
        //        "initMargin" => 0.03,
        //        "maintMargin" => 0.015,
        //        "riskLimit" => 1000000000000,
        //        "riskStep" => 1000000000000,
        //        "limit" => null,
        //        "capped" => false,
        //        "taxed" => true,
        //        "deleverage" => true,
        //        "makerFee" => -0.0001,
        //        "takerFee" => 0.0005,
        //        "settlementFee" => 0,
        //        "insuranceFee" => 0,
        //        "fundingBaseSymbol" => ".LTCBON8H",
        //        "fundingQuoteSymbol" => ".USDTBON8H",
        //        "fundingPremiumSymbol" => ".LTCUSDTPI8H",
        //        "fundingTimestamp" => "2022-01-14T20:00:00.000Z",
        //        "fundingInterval" => "2000-01-01T08:00:00.000Z",
        //        "fundingRate" => 0.0001,
        //        "indicativeFundingRate" => 0.0001,
        //        "rebalanceTimestamp" => null,
        //        "rebalanceInterval" => null,
        //        "openingTimestamp" => "2022-01-14T17:00:00.000Z",
        //        "closingTimestamp" => "2022-01-14T18:00:00.000Z",
        //        "sessionInterval" => "2000-01-01T01:00:00.000Z",
        //        "prevClosePrice" => 138.511,
        //        "limitDownPrice" => null,
        //        "limitUpPrice" => null,
        //        "bankruptLimitDownPrice" => null,
        //        "bankruptLimitUpPrice" => null,
        //        "prevTotalVolume" => 12699024000,
        //        "totalVolume" => 12702160000,
        //        "volume" => 3136000,
        //        "volume24h" => 114251000,
        //        "prevTotalTurnover" => 232418052349000,
        //        "totalTurnover" => 232463353260000,
        //        "turnover" => 45300911000,
        //        "turnover24h" => 1604331340000,
        //        "homeNotional24h" => 11425.1,
        //        "foreignNotional24h" => 1604331.3400000003,
        //        "prevPrice24h" => 135.48,
        //        "vwap" => 140.42165,
        //        "highPrice" => 146.42,
        //        "lowPrice" => 135.08,
        //        "lastPrice" => 144.36,
        //        "lastPriceProtected" => 144.36,
        //        "lastTickDirection" => "MinusTick",
        //        "lastChangePcnt" => 0.0655,
        //        "bidPrice" => 143.75,
        //        "midPrice" => 143.855,
        //        "askPrice" => 143.96,
        //        "impactBidPrice" => 143.75,
        //        "impactMidPrice" => 143.855,
        //        "impactAskPrice" => 143.96,
        //        "hasLiquidity" => true,
        //        "openInterest" => 38103000,
        //        "openValue" => 547963053300,
        //        "fairMethod" => "FundingRate",
        //        "fairBasisRate" => 0.1095,
        //        "fairBasis" => 0.004,
        //        "fairPrice" => 143.811,
        //        "markMethod" => "FairPrice",
        //        "markPrice" => 143.811,
        //        "indicativeTaxRate" => null,
        //        "indicativeSettlePrice" => 143.807,
        //        "optionUnderlyingPrice" => null,
        //        "settledPriceAdjustmentRate" => null,
        //        "settledPrice" => null,
        //        "timestamp" => "2022-01-14T17:49:55.000Z"
        //    }
        //
        $result = array();
        for ($i = 0; $i < count($response); $i++) {
            $market = $response[$i];
            $id = $this->safe_string($market, 'symbol');
            $baseId = $this->safe_string($market, 'underlying');
            $quoteId = $this->safe_string($market, 'quoteCurrency');
            $settleId = $this->safe_string($market, 'settlCurrency', '');
            $base = $this->safe_currency_code($baseId);
            $quote = $this->safe_currency_code($quoteId);
            $settle = $this->safe_currency_code($settleId);
            $basequote = $baseId . $quoteId;
            $swap = ($id === $basequote);
            // 'positionCurrency' may be empty ("", as Bitmex currently returns for ETHUSD)
            // so let's take the $quote currency first and then adjust if needed
            $type = null;
            $future = false;
            $prediction = false;
            $index = false;
            $symbol = $base . '/' . $quote . ':' . $settle;
            $expiryDatetime = $this->safe_string($market, 'expiry');
            $expiry = $this->parse8601($expiryDatetime);
            $inverse = $this->safe_value($market, 'isInverse');
            $status = $this->safe_string($market, 'state');
            $active = $status !== 'Unlisted';
            if ($swap) {
                $type = 'swap';
            } elseif (mb_strpos($id, 'B_') !== false) {
                $prediction = true;
                $type = 'prediction';
                $symbol = $id;
            } elseif ($expiry !== null) {
                $future = true;
                $type = 'future';
                $symbol = $symbol . '-' . $this->yymmdd($expiry);
            } else {
                $index = true;
                $type = 'index';
                $symbol = $id;
                $active = false;
            }
            $positionId = $this->safe_string_2($market, 'positionCurrency', 'quoteCurrency');
            $position = $this->safe_currency_code($positionId);
            $positionIsQuote = ($position === $quote);
            $maxOrderQty = $this->safe_number($market, 'maxOrderQty');
            $contract = !$index;
            $initMargin = $this->safe_string($market, 'initMargin', '1');
            $maxLeverage = $this->parse_number(Precise::string_div('1', $initMargin));
            $result[] = array(
                'id' => $id,
                'symbol' => $symbol,
                'base' => $base,
                'quote' => $quote,
                'settle' => $settle,
                'baseId' => $baseId,
                'quoteId' => $quoteId,
                'settleId' => $settleId,
                'type' => $type,
                'spot' => false,
                'margin' => false,
                'swap' => $swap,
                'future' => $future,
                'option' => false,
                'prediction' => $prediction,
                'index' => $index,
                'active' => $active,
                'contract' => $contract,
                'linear' => $contract ? !$inverse : null,
                'inverse' => $contract ? $inverse : null,
                'taker' => $this->safe_number($market, 'takerFee'),
                'maker' => $this->safe_number($market, 'makerFee'),
                'contractSize' => $this->safe_number($market, 'multiplier'),
                'expiry' => $expiry,
                'expiryDatetime' => $expiryDatetime,
                'strike' => $this->safe_number($market, 'optionStrikePrice'),
                'optionType' => null,
                'precision' => array(
                    'amount' => $this->safe_number($market, 'lotSize'),
                    'price' => $this->safe_number($market, 'tickSize'),
                ),
                'limits' => array(
                    'leverage' => array(
                        'min' => $contract ? $this->parse_number('1') : null,
                        'max' => $contract ? $maxLeverage : null,
                    ),
                    'amount' => array(
                        'min' => null,
                        'max' => $positionIsQuote ? null : $maxOrderQty,
                    ),
                    'price' => array(
                        'min' => null,
                        'max' => $this->safe_number($market, 'maxPrice'),
                    ),
                    'cost' => array(
                        'min' => null,
                        'max' => $positionIsQuote ? $maxOrderQty : null,
                    ),
                ),
                'info' => $market,
            );
        }
        return $result;
    }

    public function parse_balance($response) {
        //
        //     array(
        //         {
        //             "account":1455728,
        //             "currency":"XBt",
        //             "riskLimit":1000000000000,
        //             "prevState":"",
        //             "state":"",
        //             "action":"",
        //             "amount":263542,
        //             "pendingCredit":0,
        //             "pendingDebit":0,
        //             "confirmedDebit":0,
        //             "prevRealisedPnl":0,
        //             "prevUnrealisedPnl":0,
        //             "grossComm":0,
        //             "grossOpenCost":0,
        //             "grossOpenPremium":0,
        //             "grossExecCost":0,
        //             "grossMarkValue":0,
        //             "riskValue":0,
        //             "taxableMargin":0,
        //             "initMargin":0,
        //             "maintMargin":0,
        //             "sessionMargin":0,
        //             "targetExcessMargin":0,
        //             "varMargin":0,
        //             "realisedPnl":0,
        //             "unrealisedPnl":0,
        //             "indicativeTax":0,
        //             "unrealisedProfit":0,
        //             "syntheticMargin":null,
        //             "walletBalance":263542,
        //             "marginBalance":263542,
        //             "marginBalancePcnt":1,
        //             "marginLeverage":0,
        //             "marginUsedPcnt":0,
        //             "excessMargin":263542,
        //             "excessMarginPcnt":1,
        //             "availableMargin":263542,
        //             "withdrawableMargin":263542,
        //             "timestamp":"2020-08-03T12:01:01.246Z",
        //             "grossLastValue":0,
        //             "commission":null
        //         }
        //     )
        //
        $result = array( 'info' => $response );
        for ($i = 0; $i < count($response); $i++) {
            $balance = $response[$i];
            $currencyId = $this->safe_string($balance, 'currency');
            $code = $this->safe_currency_code($currencyId);
            $account = $this->account();
            $free = $this->safe_string($balance, 'availableMargin');
            $total = $this->safe_string($balance, 'marginBalance');
            if ($code === 'BTC') {
                $free = Precise::string_div($free, '1e8');
                $total = Precise::string_div($total, '1e8');
            }
            $account['free'] = $free;
            $account['total'] = $total;
            $result[$code] = $account;
        }
        return $this->safe_balance($result);
    }

    public function fetch_balance($params = array ()) {
        /**
         * query for balance and get the amount of funds available for trading or funds locked in orders
         * @param {dict} $params extra parameters specific to the bitmex api endpoint
         * @return {dict} a ~@link https://docs.ccxt.com/en/latest/manual.html?#balance-structure balance structure~
         */
        $this->load_markets();
        $request = array(
            'currency' => 'all',
        );
        $response = $this->privateGetUserMargin (array_merge($request, $params));
        //
        //     array(
        //         {
        //             "account":1455728,
        //             "currency":"XBt",
        //             "riskLimit":1000000000000,
        //             "prevState":"",
        //             "state":"",
        //             "action":"",
        //             "amount":263542,
        //             "pendingCredit":0,
        //             "pendingDebit":0,
        //             "confirmedDebit":0,
        //             "prevRealisedPnl":0,
        //             "prevUnrealisedPnl":0,
        //             "grossComm":0,
        //             "grossOpenCost":0,
        //             "grossOpenPremium":0,
        //             "grossExecCost":0,
        //             "grossMarkValue":0,
        //             "riskValue":0,
        //             "taxableMargin":0,
        //             "initMargin":0,
        //             "maintMargin":0,
        //             "sessionMargin":0,
        //             "targetExcessMargin":0,
        //             "varMargin":0,
        //             "realisedPnl":0,
        //             "unrealisedPnl":0,
        //             "indicativeTax":0,
        //             "unrealisedProfit":0,
        //             "syntheticMargin":null,
        //             "walletBalance":263542,
        //             "marginBalance":263542,
        //             "marginBalancePcnt":1,
        //             "marginLeverage":0,
        //             "marginUsedPcnt":0,
        //             "excessMargin":263542,
        //             "excessMarginPcnt":1,
        //             "availableMargin":263542,
        //             "withdrawableMargin":263542,
        //             "timestamp":"2020-08-03T12:01:01.246Z",
        //             "grossLastValue":0,
        //             "commission":null
        //         }
        //     )
        //
        return $this->parse_balance($response);
    }

    public function fetch_order_book($symbol, $limit = null, $params = array ()) {
        /**
         * fetches information on open orders with bid (buy) and ask (sell) prices, volumes and other data
         * @param {str} $symbol unified $symbol of the $market to fetch the $order book for
         * @param {int|null} $limit the maximum $amount of $order book entries to return
         * @param {dict} $params extra parameters specific to the bitmex api endpoint
         * @return {dict} A dictionary of {@link https://docs.ccxt.com/en/latest/manual.html#$order-book-structure $order book structures} indexed by $market symbols
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        if ($limit !== null) {
            $request['depth'] = $limit;
        }
        $response = $this->publicGetOrderBookL2 (array_merge($request, $params));
        $result = array(
            'symbol' => $symbol,
            'bids' => array(),
            'asks' => array(),
            'timestamp' => null,
            'datetime' => null,
            'nonce' => null,
        );
        for ($i = 0; $i < count($response); $i++) {
            $order = $response[$i];
            $side = ($order['side'] === 'Sell') ? 'asks' : 'bids';
            $amount = $this->safe_number($order, 'size');
            $price = $this->safe_number($order, 'price');
            // https://github.com/ccxt/ccxt/issues/4926
            // https://github.com/ccxt/ccxt/issues/4927
            // the exchange sometimes returns null $price in the orderbook
            if ($price !== null) {
                $result[$side][] = array( $price, $amount );
            }
        }
        $result['bids'] = $this->sort_by($result['bids'], 0, true);
        $result['asks'] = $this->sort_by($result['asks'], 0);
        return $result;
    }

    public function fetch_order($id, $symbol = null, $params = array ()) {
        $filter = array(
            'filter' => array(
                'orderID' => $id,
            ),
        );
        $response = $this->fetch_orders($symbol, null, null, $this->deep_extend($filter, $params));
        $numResults = is_array($response) ? count($response) : 0;
        if ($numResults === 1) {
            return $response[0];
        }
        throw new OrderNotFound($this->id . ' => The order ' . $id . ' not found.');
    }

    public function fetch_orders($symbol = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $market = null;
        $request = array();
        if ($symbol !== null) {
            $market = $this->market($symbol);
            $request['symbol'] = $market['id'];
        }
        if ($since !== null) {
            $request['startTime'] = $this->iso8601($since);
        }
        if ($limit !== null) {
            $request['count'] = $limit;
        }
        $request = $this->deep_extend($request, $params);
        // why the hassle? urlencode in python is kinda broken for nested dicts.
        // E.g. self.urlencode(array("filter" => array("open" => True))) will return "filter=array('open':+True)"
        // Bitmex doesn't like that. Hence resorting to this hack.
        if (is_array($request) && array_key_exists('filter', $request)) {
            $request['filter'] = $this->json($request['filter']);
        }
        $response = $this->privateGetOrder ($request);
        return $this->parse_orders($response, $market, $since, $limit);
    }

    public function fetch_open_orders($symbol = null, $since = null, $limit = null, $params = array ()) {
        $request = array(
            'filter' => array(
                'open' => true,
            ),
        );
        return $this->fetch_orders($symbol, $since, $limit, $this->deep_extend($request, $params));
    }

    public function fetch_closed_orders($symbol = null, $since = null, $limit = null, $params = array ()) {
        // Bitmex barfs if you set 'open' => false in the filter...
        $orders = $this->fetch_orders($symbol, $since, $limit, $params);
        return $this->filter_by($orders, 'status', 'closed');
    }

    public function fetch_my_trades($symbol = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $market = null;
        $request = array();
        if ($symbol !== null) {
            $market = $this->market($symbol);
            $request['symbol'] = $market['id'];
        }
        if ($since !== null) {
            $request['startTime'] = $this->iso8601($since);
        }
        if ($limit !== null) {
            $request['count'] = $limit;
        }
        $request = $this->deep_extend($request, $params);
        // why the hassle? urlencode in python is kinda broken for nested dicts.
        // E.g. self.urlencode(array("filter" => array("open" => True))) will return "filter=array('open':+True)"
        // Bitmex doesn't like that. Hence resorting to this hack.
        if (is_array($request) && array_key_exists('filter', $request)) {
            $request['filter'] = $this->json($request['filter']);
        }
        $response = $this->privateGetExecutionTradeHistory ($request);
        //
        //     array(
        //         {
        //             "execID" => "string",
        //             "orderID" => "string",
        //             "clOrdID" => "string",
        //             "clOrdLinkID" => "string",
        //             "account" => 0,
        //             "symbol" => "string",
        //             "side" => "string",
        //             "lastQty" => 0,
        //             "lastPx" => 0,
        //             "underlyingLastPx" => 0,
        //             "lastMkt" => "string",
        //             "lastLiquidityInd" => "string",
        //             "simpleOrderQty" => 0,
        //             "orderQty" => 0,
        //             "price" => 0,
        //             "displayQty" => 0,
        //             "stopPx" => 0,
        //             "pegOffsetValue" => 0,
        //             "pegPriceType" => "string",
        //             "currency" => "string",
        //             "settlCurrency" => "string",
        //             "execType" => "string",
        //             "ordType" => "string",
        //             "timeInForce" => "string",
        //             "execInst" => "string",
        //             "contingencyType" => "string",
        //             "exDestination" => "string",
        //             "ordStatus" => "string",
        //             "triggered" => "string",
        //             "workingIndicator" => true,
        //             "ordRejReason" => "string",
        //             "simpleLeavesQty" => 0,
        //             "leavesQty" => 0,
        //             "simpleCumQty" => 0,
        //             "cumQty" => 0,
        //             "avgPx" => 0,
        //             "commission" => 0,
        //             "tradePublishIndicator" => "string",
        //             "multiLegReportingType" => "string",
        //             "text" => "string",
        //             "trdMatchID" => "string",
        //             "execCost" => 0,
        //             "execComm" => 0,
        //             "homeNotional" => 0,
        //             "foreignNotional" => 0,
        //             "transactTime" => "2019-03-05T12:47:02.762Z",
        //             "timestamp" => "2019-03-05T12:47:02.762Z"
        //         }
        //     )
        //
        return $this->parse_trades($response, $market, $since, $limit);
    }

    public function parse_ledger_entry_type($type) {
        $types = array(
            'Withdrawal' => 'transaction',
            'RealisedPNL' => 'margin',
            'UnrealisedPNL' => 'margin',
            'Deposit' => 'transaction',
            'Transfer' => 'transfer',
            'AffiliatePayout' => 'referral',
        );
        return $this->safe_string($types, $type, $type);
    }

    public function parse_ledger_entry($item, $currency = null) {
        //
        //     {
        //         transactID => "69573da3-7744-5467-3207-89fd6efe7a47",
        //         $account =>  24321,
        //         $currency => "XBt",
        //         transactType => "Withdrawal", // "AffiliatePayout", "Transfer", "Deposit", "RealisedPNL", ...
        //         $amount =>  -1000000,
        //         $fee =>  300000,
        //         transactStatus => "Completed", // "Canceled", ...
        //         address => "1Ex4fkF4NhQaQdRWNoYpqiPbDBbq18Kdd9",
        //         tx => "3BMEX91ZhhKoWtsH9QRb5dNXnmnGpiEetA",
        //         text => "",
        //         transactTime => "2017-03-21T20:05:14.388Z",
        //         walletBalance =>  0, // balance $after
        //         marginBalance =>  null,
        //         $timestamp => "2017-03-22T13:09:23.514Z"
        //     }
        //
        // ButMEX returns the unrealized pnl from the wallet history endpoint.
        // The unrealized pnl transaction has an empty $timestamp->
        // It is not related to historical pnl it has $status set to "Pending".
        // Therefore it's not a part of the history at all.
        // https://github.com/ccxt/ccxt/issues/6047
        //
        //     {
        //         "transactID":"00000000-0000-0000-0000-000000000000",
        //         "account":121210,
        //         "currency":"XBt",
        //         "transactType":"UnrealisedPNL",
        //         "amount":-5508,
        //         "fee":0,
        //         "transactStatus":"Pending",
        //         "address":"XBTUSD",
        //         "tx":"",
        //         "text":"",
        //         "transactTime":null,  # ←---------------------------- null
        //         "walletBalance":139198767,
        //         "marginBalance":139193259,
        //         "timestamp":null  # ←---------------------------- null
        //     }
        //
        $id = $this->safe_string($item, 'transactID');
        $account = $this->safe_string($item, 'account');
        $referenceId = $this->safe_string($item, 'tx');
        $referenceAccount = null;
        $type = $this->parse_ledger_entry_type($this->safe_string($item, 'transactType'));
        $currencyId = $this->safe_string($item, 'currency');
        $code = $this->safe_currency_code($currencyId, $currency);
        $amount = $this->safe_number($item, 'amount');
        if ($amount !== null) {
            $amount = $amount / 100000000;
        }
        $timestamp = $this->parse8601($this->safe_string($item, 'transactTime'));
        if ($timestamp === null) {
            // https://github.com/ccxt/ccxt/issues/6047
            // set the $timestamp to zero, 1970 Jan 1 00:00:00
            // for unrealized pnl and other transactions without a $timestamp
            $timestamp = 0; // see comments above
        }
        $feeCost = $this->safe_number($item, 'fee', 0);
        if ($feeCost !== null) {
            $feeCost = $feeCost / 100000000;
        }
        $fee = array(
            'cost' => $feeCost,
            'currency' => $code,
        );
        $after = $this->safe_number($item, 'walletBalance');
        if ($after !== null) {
            $after = $after / 100000000;
        }
        $before = $this->sum($after, -$amount);
        $direction = null;
        if ($amount < 0) {
            $direction = 'out';
            $amount = abs($amount);
        } else {
            $direction = 'in';
        }
        $status = $this->parse_transaction_status($this->safe_string($item, 'transactStatus'));
        return array(
            'id' => $id,
            'info' => $item,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'direction' => $direction,
            'account' => $account,
            'referenceId' => $referenceId,
            'referenceAccount' => $referenceAccount,
            'type' => $type,
            'currency' => $code,
            'amount' => $amount,
            'before' => $before,
            'after' => $after,
            'status' => $status,
            'fee' => $fee,
        );
    }

    public function fetch_ledger($code = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $currency = null;
        if ($code !== null) {
            $currency = $this->currency($code);
        }
        $request = array(
            // 'start' => 123,
        );
        //
        //     if ($since !== null) {
        //         // date-based pagination not supported
        //     }
        //
        if ($limit !== null) {
            $request['count'] = $limit;
        }
        $response = $this->privateGetUserWalletHistory (array_merge($request, $params));
        //
        //     array(
        //         {
        //             transactID => "69573da3-7744-5467-3207-89fd6efe7a47",
        //             account =>  24321,
        //             $currency => "XBt",
        //             transactType => "Withdrawal", // "AffiliatePayout", "Transfer", "Deposit", "RealisedPNL", ...
        //             amount =>  -1000000,
        //             fee =>  300000,
        //             transactStatus => "Completed", // "Canceled", ...
        //             address => "1Ex4fkF4NhQaQdRWNoYpqiPbDBbq18Kdd9",
        //             tx => "3BMEX91ZhhKoWtsH9QRb5dNXnmnGpiEetA",
        //             text => "",
        //             transactTime => "2017-03-21T20:05:14.388Z",
        //             walletBalance =>  0, // balance after
        //             marginBalance =>  null,
        //             timestamp => "2017-03-22T13:09:23.514Z"
        //         }
        //     )
        //
        return $this->parse_ledger($response, $currency, $since, $limit);
    }

    public function fetch_transactions($code = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $request = array(
            // 'start' => 123,
        );
        //
        //     if ($since !== null) {
        //         // date-based pagination not supported
        //     }
        //
        if ($limit !== null) {
            $request['count'] = $limit;
        }
        $response = $this->privateGetUserWalletHistory (array_merge($request, $params));
        $transactions = $this->filter_by_array($response, 'transactType', array( 'Withdrawal', 'Deposit' ), false);
        $currency = null;
        if ($code !== null) {
            $currency = $this->currency($code);
        }
        return $this->parse_transactions($transactions, $currency, $since, $limit);
    }

    public function parse_transaction_status($status) {
        $statuses = array(
            'Canceled' => 'canceled',
            'Completed' => 'ok',
            'Pending' => 'pending',
        );
        return $this->safe_string($statuses, $status, $status);
    }

    public function parse_transaction($transaction, $currency = null) {
        //
        //   {
        //      'transactID' => 'ffe699c2-95ee-4c13-91f9-0faf41daec25',
        //      'account' => 123456,
        //      'currency' => 'XBt',
        //      'transactType' => 'Withdrawal',
        //      'amount' => -100100000,
        //      'fee' => 100000,
        //      'transactStatus' => 'Completed',
        //      'address' => '385cR5DM96n1HvBDMzLHPYcw89fZAXULJP',
        //      'tx' => '3BMEXabcdefghijklmnopqrstuvwxyz123',
        //      'text' => '',
        //      'transactTime' => '2019-01-02T01:00:00.000Z',
        //      'walletBalance' => 99900000,
        //      'marginBalance' => None,
        //      'timestamp' => '2019-01-02T13:00:00.000Z'
        //   }
        //
        $id = $this->safe_string($transaction, 'transactID');
        // For deposits, $transactTime == $timestamp
        // For withdrawals, $transactTime is submission, $timestamp is processed
        $transactTime = $this->parse8601($this->safe_string($transaction, 'transactTime'));
        $timestamp = $this->parse8601($this->safe_string($transaction, 'timestamp'));
        $type = $this->safe_string_lower($transaction, 'transactType');
        // Deposits have no from $address or to $address, withdrawals have both
        $address = null;
        $addressFrom = null;
        $addressTo = null;
        if ($type === 'withdrawal') {
            $address = $this->safe_string($transaction, 'address');
            $addressFrom = $this->safe_string($transaction, 'tx');
            $addressTo = $address;
        }
        $amountString = $this->safe_string($transaction, 'amount');
        $amountString = Precise::string_div(Precise::string_abs($amountString), '1e8');
        $feeCostString = $this->safe_string($transaction, 'fee');
        $feeCostString = Precise::string_div($feeCostString, '1e8');
        $fee = array(
            'cost' => $this->parse_number($feeCostString),
            'currency' => 'BTC',
        );
        $status = $this->safe_string($transaction, 'transactStatus');
        if ($status !== null) {
            $status = $this->parse_transaction_status($status);
        }
        return array(
            'info' => $transaction,
            'id' => $id,
            'txid' => null,
            'timestamp' => $transactTime,
            'datetime' => $this->iso8601($transactTime),
            'network' => null,
            'addressFrom' => $addressFrom,
            'address' => $address,
            'addressTo' => $addressTo,
            'tagFrom' => null,
            'tag' => null,
            'tagTo' => null,
            'type' => $type,
            'amount' => $this->parse_number($amountString),
            // BTC is the only $currency on Bitmex
            'currency' => 'BTC',
            'status' => $status,
            'updated' => $timestamp,
            'comment' => null,
            'fee' => $fee,
        );
    }

    public function fetch_ticker($symbol, $params = array ()) {
        /**
         * fetches a price $ticker, a statistical calculation with the information calculated over the past 24 hours for a specific $market
         * @param {str} $symbol unified $symbol of the $market to fetch the $ticker for
         * @param {dict} $params extra parameters specific to the bitmex api endpoint
         * @return {dict} a {@link https://docs.ccxt.com/en/latest/manual.html#$ticker-structure $ticker structure}
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $tickers = $this->fetch_tickers([ $market['symbol'] ], $params);
        $ticker = $this->safe_value($tickers, $market['symbol']);
        if ($ticker === null) {
            throw new BadSymbol($this->id . ' fetchTicker() $symbol ' . $symbol . ' not found');
        }
        return $ticker;
    }

    public function fetch_tickers($symbols = null, $params = array ()) {
        /**
         * fetches price tickers for multiple markets, statistical calculations with the information calculated over the past 24 hours each $market
         * @param {[str]|null} $symbols unified $symbols of the markets to fetch the $ticker for, all $market tickers are returned if not assigned
         * @param {dict} $params extra parameters specific to the bitmex api endpoint
         * @return {dict} an array of {@link https://docs.ccxt.com/en/latest/manual.html#$ticker-structure $ticker structures}
         */
        $this->load_markets();
        $response = $this->publicGetInstrumentActiveAndIndices ($params);
        //
        //     array(
        //         {
        //             "symbol":".EVOL7D",
        //             "rootSymbol":"EVOL",
        //             "state":"Unlisted",
        //             "typ":"MRIXXX",
        //             "listing":null,
        //             "front":null,
        //             "expiry":null,
        //             "settle":null,
        //             "listedSettle":null,
        //             "relistInterval":null,
        //             "inverseLeg":"",
        //             "sellLeg":"",
        //             "buyLeg":"",
        //             "optionStrikePcnt":null,
        //             "optionStrikeRound":null,
        //             "optionStrikePrice":null,
        //             "optionMultiplier":null,
        //             "positionCurrency":"",
        //             "underlying":"ETH",
        //             "quoteCurrency":"XXX",
        //             "underlyingSymbol":".EVOL7D",
        //             "reference":"BMI",
        //             "referenceSymbol":".BETHXBT",
        //             "calcInterval":"2000-01-08T00:00:00.000Z",
        //             "publishInterval":"2000-01-01T00:05:00.000Z",
        //             "publishTime":null,
        //             "maxOrderQty":null,
        //             "maxPrice":null,
        //             "lotSize":null,
        //             "tickSize":0.01,
        //             "multiplier":null,
        //             "settlCurrency":"",
        //             "underlyingToPositionMultiplier":null,
        //             "underlyingToSettleMultiplier":null,
        //             "quoteToSettleMultiplier":null,
        //             "isQuanto":false,
        //             "isInverse":false,
        //             "initMargin":null,
        //             "maintMargin":null,
        //             "riskLimit":null,
        //             "riskStep":null,
        //             "limit":null,
        //             "capped":false,
        //             "taxed":false,
        //             "deleverage":false,
        //             "makerFee":null,
        //             "takerFee":null,
        //             "settlementFee":null,
        //             "insuranceFee":null,
        //             "fundingBaseSymbol":"",
        //             "fundingQuoteSymbol":"",
        //             "fundingPremiumSymbol":"",
        //             "fundingTimestamp":null,
        //             "fundingInterval":null,
        //             "fundingRate":null,
        //             "indicativeFundingRate":null,
        //             "rebalanceTimestamp":null,
        //             "rebalanceInterval":null,
        //             "openingTimestamp":null,
        //             "closingTimestamp":null,
        //             "sessionInterval":null,
        //             "prevClosePrice":null,
        //             "limitDownPrice":null,
        //             "limitUpPrice":null,
        //             "bankruptLimitDownPrice":null,
        //             "bankruptLimitUpPrice":null,
        //             "prevTotalVolume":null,
        //             "totalVolume":null,
        //             "volume":null,
        //             "volume24h":null,
        //             "prevTotalTurnover":null,
        //             "totalTurnover":null,
        //             "turnover":null,
        //             "turnover24h":null,
        //             "homeNotional24h":null,
        //             "foreignNotional24h":null,
        //             "prevPrice24h":5.27,
        //             "vwap":null,
        //             "highPrice":null,
        //             "lowPrice":null,
        //             "lastPrice":4.72,
        //             "lastPriceProtected":null,
        //             "lastTickDirection":"ZeroMinusTick",
        //             "lastChangePcnt":-0.1044,
        //             "bidPrice":null,
        //             "midPrice":null,
        //             "askPrice":null,
        //             "impactBidPrice":null,
        //             "impactMidPrice":null,
        //             "impactAskPrice":null,
        //             "hasLiquidity":false,
        //             "openInterest":null,
        //             "openValue":0,
        //             "fairMethod":"",
        //             "fairBasisRate":null,
        //             "fairBasis":null,
        //             "fairPrice":null,
        //             "markMethod":"LastPrice",
        //             "markPrice":4.72,
        //             "indicativeTaxRate":null,
        //             "indicativeSettlePrice":null,
        //             "optionUnderlyingPrice":null,
        //             "settledPriceAdjustmentRate":null,
        //             "settledPrice":null,
        //             "timestamp":"2022-05-21T04:30:00.000Z"
        //         }
        //     )
        //
        $result = array();
        for ($i = 0; $i < count($response); $i++) {
            $ticker = $this->parse_ticker($response[$i]);
            $symbol = $this->safe_string($ticker, 'symbol');
            if ($symbol !== null) {
                $result[$symbol] = $ticker;
            }
        }
        $uniformSymbols = array();
        if ($symbols !== null) {
            for ($i = 0; $i < count($symbols); $i++) {
                $symbol = $symbols[$i];
                $market = $this->market($symbol);
                $uniformSymbols[] = $market['symbol'];
            }
            return $this->filter_by_array($result, 'symbol', $uniformSymbols);
        }
        return $result;
    }

    public function parse_ticker($ticker, $market = null) {
        //
        //     {                         $symbol => "ETHH19",
        //                           rootSymbol => "ETH",
        //                                state => "Open",
        //                                  typ => "FFCCSX",
        //                              listing => "2018-12-17T04:00:00.000Z",
        //                                front => "2019-02-22T12:00:00.000Z",
        //                               expiry => "2019-03-29T12:00:00.000Z",
        //                               settle => "2019-03-29T12:00:00.000Z",
        //                       relistInterval =>  null,
        //                           inverseLeg => "",
        //                              sellLeg => "",
        //                               buyLeg => "",
        //                     optionStrikePcnt =>  null,
        //                    optionStrikeRound =>  null,
        //                    optionStrikePrice =>  null,
        //                     optionMultiplier =>  null,
        //                     positionCurrency => "ETH",
        //                           underlying => "ETH",
        //                        quoteCurrency => "XBT",
        //                     underlyingSymbol => "ETHXBT=",
        //                            reference => "BMEX",
        //                      referenceSymbol => ".BETHXBT30M",
        //                         calcInterval =>  null,
        //                      publishInterval =>  null,
        //                          publishTime =>  null,
        //                          maxOrderQty =>  100000000,
        //                             maxPrice =>  10,
        //                              lotSize =>  1,
        //                             tickSize =>  0.00001,
        //                           multiplier =>  100000000,
        //                        settlCurrency => "XBt",
        //       underlyingToPositionMultiplier =>  1,
        //         underlyingToSettleMultiplier =>  null,
        //              quoteToSettleMultiplier =>  100000000,
        //                             isQuanto =>  false,
        //                            isInverse =>  false,
        //                           initMargin =>  0.02,
        //                          maintMargin =>  0.01,
        //                            riskLimit =>  5000000000,
        //                             riskStep =>  5000000000,
        //                                limit =>  null,
        //                               capped =>  false,
        //                                taxed =>  true,
        //                           deleverage =>  true,
        //                             makerFee =>  -0.0005,
        //                             takerFee =>  0.0025,
        //                        settlementFee =>  0,
        //                         insuranceFee =>  0,
        //                    fundingBaseSymbol => "",
        //                   fundingQuoteSymbol => "",
        //                 fundingPremiumSymbol => "",
        //                     fundingTimestamp =>  null,
        //                      fundingInterval =>  null,
        //                          fundingRate =>  null,
        //                indicativeFundingRate =>  null,
        //                   rebalanceTimestamp =>  null,
        //                    rebalanceInterval =>  null,
        //                     openingTimestamp => "2019-02-13T08:00:00.000Z",
        //                     closingTimestamp => "2019-02-13T09:00:00.000Z",
        //                      sessionInterval => "2000-01-01T01:00:00.000Z",
        //                       prevClosePrice =>  0.03347,
        //                       limitDownPrice =>  null,
        //                         limitUpPrice =>  null,
        //               bankruptLimitDownPrice =>  null,
        //                 bankruptLimitUpPrice =>  null,
        //                      prevTotalVolume =>  1386531,
        //                          totalVolume =>  1387062,
        //                               volume =>  531,
        //                            volume24h =>  17118,
        //                    prevTotalTurnover =>  4741294246000,
        //                        totalTurnover =>  4743103466000,
        //                             turnover =>  1809220000,
        //                          turnover24h =>  57919845000,
        //                      homeNotional24h =>  17118,
        //                   foreignNotional24h =>  579.19845,
        //                         prevPrice24h =>  0.03349,
        //                                 vwap =>  0.03383564,
        //                            highPrice =>  0.03458,
        //                             lowPrice =>  0.03329,
        //                            lastPrice =>  0.03406,
        //                   lastPriceProtected =>  0.03406,
        //                    lastTickDirection => "ZeroMinusTick",
        //                       lastChangePcnt =>  0.017,
        //                             bidPrice =>  0.03406,
        //                             midPrice =>  0.034065,
        //                             askPrice =>  0.03407,
        //                       impactBidPrice =>  0.03406,
        //                       impactMidPrice =>  0.034065,
        //                       impactAskPrice =>  0.03407,
        //                         hasLiquidity =>  true,
        //                         openInterest =>  83679,
        //                            openValue =>  285010674000,
        //                           fairMethod => "ImpactMidPrice",
        //                        fairBasisRate =>  0,
        //                            fairBasis =>  0,
        //                            fairPrice =>  0.03406,
        //                           markMethod => "FairPrice",
        //                            markPrice =>  0.03406,
        //                    indicativeTaxRate =>  0,
        //                indicativeSettlePrice =>  0.03406,
        //                optionUnderlyingPrice =>  null,
        //                         settledPrice =>  null,
        //                            $timestamp => "2019-02-13T08:40:30.000Z",
        //     }
        //
        $marketId = $this->safe_string($ticker, 'symbol');
        $symbol = $this->safe_symbol($marketId, $market);
        $timestamp = $this->parse8601($this->safe_string($ticker, 'timestamp'));
        $open = $this->safe_string($ticker, 'prevPrice24h');
        $last = $this->safe_string($ticker, 'lastPrice');
        return $this->safe_ticker(array(
            'symbol' => $symbol,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'high' => $this->safe_string($ticker, 'highPrice'),
            'low' => $this->safe_string($ticker, 'lowPrice'),
            'bid' => $this->safe_string($ticker, 'bidPrice'),
            'bidVolume' => null,
            'ask' => $this->safe_string($ticker, 'askPrice'),
            'askVolume' => null,
            'vwap' => $this->safe_string($ticker, 'vwap'),
            'open' => $open,
            'close' => $last,
            'last' => $last,
            'previousClose' => null,
            'change' => null,
            'percentage' => null,
            'average' => null,
            'baseVolume' => $this->safe_string($ticker, 'homeNotional24h'),
            'quoteVolume' => $this->safe_string($ticker, 'foreignNotional24h'),
            'info' => $ticker,
        ), $market);
    }

    public function parse_ohlcv($ohlcv, $market = null) {
        //
        //     {
        //         "timestamp":"2015-09-25T13:38:00.000Z",
        //         "symbol":"XBTUSD",
        //         "open":237.45,
        //         "high":237.45,
        //         "low":237.45,
        //         "close":237.45,
        //         "trades":0,
        //         "volume":0,
        //         "vwap":null,
        //         "lastSize":null,
        //         "turnover":0,
        //         "homeNotional":0,
        //         "foreignNotional":0
        //     }
        //
        return array(
            $this->parse8601($this->safe_string($ohlcv, 'timestamp')),
            $this->safe_number($ohlcv, 'open'),
            $this->safe_number($ohlcv, 'high'),
            $this->safe_number($ohlcv, 'low'),
            $this->safe_number($ohlcv, 'close'),
            $this->safe_number($ohlcv, 'volume'),
        );
    }

    public function fetch_ohlcv($symbol, $timeframe = '1m', $since = null, $limit = null, $params = array ()) {
        /**
         * fetches historical candlestick data containing the open, high, low, and close price, and the volume of a $market
         * @param {str} $symbol unified $symbol of the $market to fetch OHLCV data for
         * @param {str} $timeframe the length of time each candle represents
         * @param {int|null} $since $timestamp in ms of the earliest candle to fetch
         * @param {int|null} $limit the maximum amount of candles to fetch
         * @param {dict} $params extra parameters specific to the bitmex api endpoint
         * @return {[[int]]} A list of candles ordered as $timestamp, open, high, low, close, volume
         */
        $this->load_markets();
        // send JSON key/value pairs, such as array("key" => "value")
        // $filter by individual fields and do advanced queries on timestamps
        // $filter = array( 'key' => 'value' );
        // send a bare series (e.g. XBU) to nearest expiring contract in that series
        // you can also send a $timeframe, e.g. XBU:monthly
        // timeframes => daily, weekly, monthly, quarterly, and biquarterly
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
            'binSize' => $this->timeframes[$timeframe],
            'partial' => true,     // true == include yet-incomplete current bins
            // 'filter' => $filter, // $filter by individual fields and do advanced queries
            // 'columns' => array(),    // will return all columns if omitted
            // 'start' => 0,       // starting point for results (wtf?)
            // 'reverse' => false, // true == newest first
            // 'endTime' => '',    // ending date $filter for results
        );
        if ($limit !== null) {
            $request['count'] = $limit; // default 100, max 500
        }
        $duration = $this->parse_timeframe($timeframe) * 1000;
        $fetchOHLCVOpenTimestamp = $this->safe_value($this->options, 'fetchOHLCVOpenTimestamp', true);
        // if $since is not set, they will return candles starting from 2017-01-01
        if ($since !== null) {
            $timestamp = $since;
            if ($fetchOHLCVOpenTimestamp) {
                $timestamp = $this->sum($timestamp, $duration);
            }
            $ymdhms = $this->ymdhms($timestamp);
            $request['startTime'] = $ymdhms; // starting date $filter for results
        } else {
            $request['reverse'] = true;
        }
        $response = $this->publicGetTradeBucketed (array_merge($request, $params));
        //
        //     array(
        //         array("timestamp":"2015-09-25T13:38:00.000Z","symbol":"XBTUSD","open":237.45,"high":237.45,"low":237.45,"close":237.45,"trades":0,"volume":0,"vwap":null,"lastSize":null,"turnover":0,"homeNotional":0,"foreignNotional":0),
        //         array("timestamp":"2015-09-25T13:39:00.000Z","symbol":"XBTUSD","open":237.45,"high":237.45,"low":237.45,"close":237.45,"trades":0,"volume":0,"vwap":null,"lastSize":null,"turnover":0,"homeNotional":0,"foreignNotional":0),
        //         array("timestamp":"2015-09-25T13:40:00.000Z","symbol":"XBTUSD","open":237.45,"high":237.45,"low":237.45,"close":237.45,"trades":0,"volume":0,"vwap":null,"lastSize":null,"turnover":0,"homeNotional":0,"foreignNotional":0)
        //     )
        //
        $result = $this->parse_ohlcvs($response, $market, $timeframe, $since, $limit);
        if ($fetchOHLCVOpenTimestamp) {
            // bitmex returns the candle's close $timestamp - https://github.com/ccxt/ccxt/issues/4446
            // we can emulate the open $timestamp by shifting all the timestamps one place
            // so the previous close becomes the current open, and we drop the first candle
            for ($i = 0; $i < count($result); $i++) {
                $result[$i][0] = $result[$i][0] - $duration;
            }
        }
        return $result;
    }

    public function parse_trade($trade, $market = null) {
        //
        // fetchTrades (public)
        //
        //     {
        //         $timestamp => '2018-08-28T00:00:02.735Z',
        //         $symbol => 'XBTUSD',
        //         $side => 'Buy',
        //         size => 2000,
        //         price => 6906.5,
        //         tickDirection => 'PlusTick',
        //         trdMatchID => 'b9a42432-0a46-6a2f-5ecc-c32e9ca4baf8',
        //         grossValue => 28958000,
        //         homeNotional => 0.28958,
        //         foreignNotional => 2000
        //     }
        //
        // fetchMyTrades (private)
        //
        //     {
        //         "execID" => "string",
        //         "orderID" => "string",
        //         "clOrdID" => "string",
        //         "clOrdLinkID" => "string",
        //         "account" => 0,
        //         "symbol" => "string",
        //         "side" => "string",
        //         "lastQty" => 0,
        //         "lastPx" => 0,
        //         "underlyingLastPx" => 0,
        //         "lastMkt" => "string",
        //         "lastLiquidityInd" => "string",
        //         "simpleOrderQty" => 0,
        //         "orderQty" => 0,
        //         "price" => 0,
        //         "displayQty" => 0,
        //         "stopPx" => 0,
        //         "pegOffsetValue" => 0,
        //         "pegPriceType" => "string",
        //         "currency" => "string",
        //         "settlCurrency" => "string",
        //         "execType" => "string",
        //         "ordType" => "string",
        //         "timeInForce" => "string",
        //         "execInst" => "string",
        //         "contingencyType" => "string",
        //         "exDestination" => "string",
        //         "ordStatus" => "string",
        //         "triggered" => "string",
        //         "workingIndicator" => true,
        //         "ordRejReason" => "string",
        //         "simpleLeavesQty" => 0,
        //         "leavesQty" => 0,
        //         "simpleCumQty" => 0,
        //         "cumQty" => 0,
        //         "avgPx" => 0,
        //         "commission" => 0,
        //         "tradePublishIndicator" => "string",
        //         "multiLegReportingType" => "string",
        //         "text" => "string",
        //         "trdMatchID" => "string",
        //         "execCost" => 0,
        //         "execComm" => 0,
        //         "homeNotional" => 0,
        //         "foreignNotional" => 0,
        //         "transactTime" => "2019-03-05T12:47:02.762Z",
        //         "timestamp" => "2019-03-05T12:47:02.762Z"
        //     }
        //
        $timestamp = $this->parse8601($this->safe_string($trade, 'timestamp'));
        $priceString = $this->safe_string_2($trade, 'avgPx', 'price');
        $amountString = $this->safe_string_2($trade, 'size', 'lastQty');
        $execCost = $this->safe_string($trade, 'execCost');
        $costString = Precise::string_div(Precise::string_abs($execCost), '1e8');
        $id = $this->safe_string($trade, 'trdMatchID');
        $order = $this->safe_string($trade, 'orderID');
        $side = $this->safe_string_lower($trade, 'side');
        // price * amount doesn't work for all symbols (e.g. XBT, ETH)
        $fee = null;
        $feeCostString = Precise::string_div($this->safe_string($trade, 'execComm'), '1e8');
        if ($feeCostString !== null) {
            $currencyId = $this->safe_string($trade, 'settlCurrency');
            $feeCurrencyCode = $this->safe_currency_code($currencyId);
            $feeRateString = $this->safe_string($trade, 'commission');
            $fee = array(
                'cost' => $feeCostString,
                'currency' => $feeCurrencyCode,
                'rate' => $feeRateString,
            );
        }
        // Trade or Funding
        $execType = $this->safe_string($trade, 'execType');
        $takerOrMaker = null;
        if ($feeCostString !== null && $execType === 'Trade') {
            $takerOrMaker = Precise::string_lt($feeCostString, '0') ? 'maker' : 'taker';
        }
        $marketId = $this->safe_string($trade, 'symbol');
        $symbol = $this->safe_symbol($marketId, $market);
        $type = $this->safe_string_lower($trade, 'ordType');
        return $this->safe_trade(array(
            'info' => $trade,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'symbol' => $symbol,
            'id' => $id,
            'order' => $order,
            'type' => $type,
            'takerOrMaker' => $takerOrMaker,
            'side' => $side,
            'price' => $priceString,
            'cost' => $costString,
            'amount' => $amountString,
            'fee' => $fee,
        ), $market);
    }

    public function parse_order_status($status) {
        $statuses = array(
            'New' => 'open',
            'PartiallyFilled' => 'open',
            'Filled' => 'closed',
            'DoneForDay' => 'open',
            'Canceled' => 'canceled',
            'PendingCancel' => 'open',
            'PendingNew' => 'open',
            'Rejected' => 'rejected',
            'Expired' => 'expired',
            'Stopped' => 'open',
            'Untriggered' => 'open',
            'Triggered' => 'open',
        );
        return $this->safe_string($statuses, $status, $status);
    }

    public function parse_time_in_force($timeInForce) {
        $timeInForces = array(
            'Day' => 'Day',
            'GoodTillCancel' => 'GTC',
            'ImmediateOrCancel' => 'IOC',
            'FillOrKill' => 'FOK',
        );
        return $this->safe_string($timeInForces, $timeInForce, $timeInForce);
    }

    public function parse_order($order, $market = null) {
        //
        //     {
        //         "orderID":"56222c7a-9956-413a-82cf-99f4812c214b",
        //         "clOrdID":"",
        //         "clOrdLinkID":"",
        //         "account":1455728,
        //         "symbol":"XBTUSD",
        //         "side":"Sell",
        //         "simpleOrderQty":null,
        //         "orderQty":1,
        //         "price":40000,
        //         "displayQty":null,
        //         "stopPx":null,
        //         "pegOffsetValue":null,
        //         "pegPriceType":"",
        //         "currency":"USD",
        //         "settlCurrency":"XBt",
        //         "ordType":"Limit",
        //         "timeInForce":"GoodTillCancel",
        //         "execInst":"",
        //         "contingencyType":"",
        //         "exDestination":"XBME",
        //         "ordStatus":"New",
        //         "triggered":"",
        //         "workingIndicator":true,
        //         "ordRejReason":"",
        //         "simpleLeavesQty":null,
        //         "leavesQty":1,
        //         "simpleCumQty":null,
        //         "cumQty":0,
        //         "avgPx":null,
        //         "multiLegReportingType":"SingleSecurity",
        //         "text":"Submitted via API.",
        //         "transactTime":"2021-01-02T21:38:49.246Z",
        //         "timestamp":"2021-01-02T21:38:49.246Z"
        //     }
        //
        $status = $this->parse_order_status($this->safe_string($order, 'ordStatus'));
        $marketId = $this->safe_string($order, 'symbol');
        $symbol = $this->safe_symbol($marketId, $market);
        $timestamp = $this->parse8601($this->safe_string($order, 'timestamp'));
        $lastTradeTimestamp = $this->parse8601($this->safe_string($order, 'transactTime'));
        $price = $this->safe_string($order, 'price');
        $amount = $this->safe_string($order, 'orderQty');
        $filled = $this->safe_string($order, 'cumQty', 0.0);
        $average = $this->safe_string($order, 'avgPx');
        $id = $this->safe_string($order, 'orderID');
        $type = $this->safe_string_lower($order, 'ordType');
        $side = $this->safe_string_lower($order, 'side');
        $clientOrderId = $this->safe_string($order, 'clOrdID');
        $timeInForce = $this->parse_time_in_force($this->safe_string($order, 'timeInForce'));
        $stopPrice = $this->safe_number($order, 'stopPx');
        $execInst = $this->safe_string($order, 'execInst');
        $postOnly = ($execInst === 'ParticipateDoNotInitiate');
        return $this->safe_order(array(
            'info' => $order,
            'id' => $id,
            'clientOrderId' => $clientOrderId,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'lastTradeTimestamp' => $lastTradeTimestamp,
            'symbol' => $symbol,
            'type' => $type,
            'timeInForce' => $timeInForce,
            'postOnly' => $postOnly,
            'side' => $side,
            'price' => $price,
            'stopPrice' => $stopPrice,
            'amount' => $amount,
            'cost' => null,
            'average' => $average,
            'filled' => $filled,
            'remaining' => null,
            'status' => $status,
            'fee' => null,
            'trades' => null,
        ), $market);
    }

    public function fetch_trades($symbol, $since = null, $limit = null, $params = array ()) {
        /**
         * get the list of most recent trades for a particular $symbol
         * @param {str} $symbol unified $symbol of the $market to fetch trades for
         * @param {int|null} $since timestamp in ms of the earliest trade to fetch
         * @param {int|null} $limit the maximum amount of trades to fetch
         * @param {dict} $params extra parameters specific to the bitmex api endpoint
         * @return {[dict]} a list of ~@link https://docs.ccxt.com/en/latest/manual.html?#public-trades trade structures~
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        if ($since !== null) {
            $request['startTime'] = $this->iso8601($since);
        } else {
            // by default reverse=false, i.e. trades are fetched $since the time of $market inception (year 2015 for XBTUSD)
            $request['reverse'] = true;
        }
        if ($limit !== null) {
            $request['count'] = $limit;
        }
        $response = $this->publicGetTrade (array_merge($request, $params));
        //
        //     array(
        //         array(
        //             timestamp => '2018-08-28T00:00:02.735Z',
        //             $symbol => 'XBTUSD',
        //             side => 'Buy',
        //             size => 2000,
        //             price => 6906.5,
        //             tickDirection => 'PlusTick',
        //             trdMatchID => 'b9a42432-0a46-6a2f-5ecc-c32e9ca4baf8',
        //             grossValue => 28958000,
        //             homeNotional => 0.28958,
        //             foreignNotional => 2000
        //         ),
        //         array(
        //             timestamp => '2018-08-28T00:00:03.778Z',
        //             $symbol => 'XBTUSD',
        //             side => 'Sell',
        //             size => 1000,
        //             price => 6906,
        //             tickDirection => 'MinusTick',
        //             trdMatchID => '0d4f1682-5270-a800-569b-4a0eb92db97c',
        //             grossValue => 14480000,
        //             homeNotional => 0.1448,
        //             foreignNotional => 1000
        //         ),
        //     )
        //
        return $this->parse_trades($response, $market, $since, $limit);
    }

    public function create_order($symbol, $type, $side, $amount, $price = null, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        $orderType = $this->capitalize($type);
        $reduceOnly = $this->safe_value($params, 'reduceOnly');
        if ($reduceOnly !== null) {
            if (($market['type'] !== 'swap') && ($market['type'] !== 'future')) {
                throw new InvalidOrder($this->id . ' createOrder() does not support $reduceOnly for ' . $market['type'] . ' orders, $reduceOnly orders are supported for swap and future markets only');
            }
        }
        $request = array(
            'symbol' => $market['id'],
            'side' => $this->capitalize($side),
            'orderQty' => floatval($this->amount_to_precision($symbol, $amount)), // lot size multiplied by the number of contracts
            'ordType' => $orderType,
        );
        if ($reduceOnly) {
            $request['execInst'] = 'ReduceOnly';
        }
        if (($orderType === 'Stop') || ($orderType === 'StopLimit') || ($orderType === 'MarketIfTouched') || ($orderType === 'LimitIfTouched')) {
            $stopPrice = $this->safe_number_2($params, 'stopPx', 'stopPrice');
            if ($stopPrice === null) {
                throw new ArgumentsRequired($this->id . ' createOrder() requires a stopPx or $stopPrice parameter for the ' . $orderType . ' order type');
            } else {
                $request['stopPx'] = floatval($this->price_to_precision($symbol, $stopPrice));
                $params = $this->omit($params, array( 'stopPx', 'stopPrice' ));
            }
        }
        if (($orderType === 'Limit') || ($orderType === 'StopLimit') || ($orderType === 'LimitIfTouched')) {
            $request['price'] = floatval($this->price_to_precision($symbol, $price));
        }
        $clientOrderId = $this->safe_string_2($params, 'clOrdID', 'clientOrderId');
        if ($clientOrderId !== null) {
            $request['clOrdID'] = $clientOrderId;
            $params = $this->omit($params, array( 'clOrdID', 'clientOrderId' ));
        }
        $response = $this->privatePostOrder (array_merge($request, $params));
        return $this->parse_order($response, $market);
    }

    public function edit_order($id, $symbol, $type, $side, $amount = null, $price = null, $params = array ()) {
        $this->load_markets();
        $request = array();
        $origClOrdID = $this->safe_string_2($params, 'origClOrdID', 'clientOrderId');
        if ($origClOrdID !== null) {
            $request['origClOrdID'] = $origClOrdID;
            $clientOrderId = $this->safe_string($params, 'clOrdID', 'clientOrderId');
            if ($clientOrderId !== null) {
                $request['clOrdID'] = $clientOrderId;
            }
            $params = $this->omit($params, array( 'origClOrdID', 'clOrdID', 'clientOrderId' ));
        } else {
            $request['orderID'] = $id;
        }
        if ($amount !== null) {
            $request['orderQty'] = $amount;
        }
        if ($price !== null) {
            $request['price'] = $price;
        }
        $response = $this->privatePutOrder (array_merge($request, $params));
        return $this->parse_order($response);
    }

    public function cancel_order($id, $symbol = null, $params = array ()) {
        $this->load_markets();
        // https://github.com/ccxt/ccxt/issues/6507
        $clientOrderId = $this->safe_value_2($params, 'clOrdID', 'clientOrderId');
        $request = array();
        if ($clientOrderId === null) {
            $request['orderID'] = $id;
        } else {
            $request['clOrdID'] = $clientOrderId;
            $params = $this->omit($params, array( 'clOrdID', 'clientOrderId' ));
        }
        $response = $this->privateDeleteOrder (array_merge($request, $params));
        $order = $this->safe_value($response, 0, array());
        $error = $this->safe_string($order, 'error');
        if ($error !== null) {
            if (mb_strpos($error, 'Unable to cancel $order due to existing state') !== false) {
                throw new OrderNotFound($this->id . ' cancelOrder() failed => ' . $error);
            }
        }
        return $this->parse_order($order);
    }

    public function cancel_orders($ids, $symbol = null, $params = array ()) {
        return $this->cancel_order($ids, $symbol, $params);
    }

    public function cancel_all_orders($symbol = null, $params = array ()) {
        $this->load_markets();
        $request = array();
        $market = null;
        if ($symbol !== null) {
            $market = $this->market($symbol);
            $request['symbol'] = $market['id'];
        }
        $response = $this->privateDeleteOrderAll (array_merge($request, $params));
        //
        //     array(
        //         {
        //             "orderID" => "string",
        //             "clOrdID" => "string",
        //             "clOrdLinkID" => "string",
        //             "account" => 0,
        //             "symbol" => "string",
        //             "side" => "string",
        //             "simpleOrderQty" => 0,
        //             "orderQty" => 0,
        //             "price" => 0,
        //             "displayQty" => 0,
        //             "stopPx" => 0,
        //             "pegOffsetValue" => 0,
        //             "pegPriceType" => "string",
        //             "currency" => "string",
        //             "settlCurrency" => "string",
        //             "ordType" => "string",
        //             "timeInForce" => "string",
        //             "execInst" => "string",
        //             "contingencyType" => "string",
        //             "exDestination" => "string",
        //             "ordStatus" => "string",
        //             "triggered" => "string",
        //             "workingIndicator" => true,
        //             "ordRejReason" => "string",
        //             "simpleLeavesQty" => 0,
        //             "leavesQty" => 0,
        //             "simpleCumQty" => 0,
        //             "cumQty" => 0,
        //             "avgPx" => 0,
        //             "multiLegReportingType" => "string",
        //             "text" => "string",
        //             "transactTime" => "2020-06-01T09:36:35.290Z",
        //             "timestamp" => "2020-06-01T09:36:35.290Z"
        //         }
        //     )
        //
        return $this->parse_orders($response, $market);
    }

    public function fetch_positions($symbols = null, $params = array ()) {
        $this->load_markets();
        $response = $this->privateGetPosition ($params);
        //
        //     array(
        //         {
        //             "account" => 0,
        //             "symbol" => "string",
        //             "currency" => "string",
        //             "underlying" => "string",
        //             "quoteCurrency" => "string",
        //             "commission" => 0,
        //             "initMarginReq" => 0,
        //             "maintMarginReq" => 0,
        //             "riskLimit" => 0,
        //             "leverage" => 0,
        //             "crossMargin" => true,
        //             "deleveragePercentile" => 0,
        //             "rebalancedPnl" => 0,
        //             "prevRealisedPnl" => 0,
        //             "prevUnrealisedPnl" => 0,
        //             "prevClosePrice" => 0,
        //             "openingTimestamp" => "2020-11-09T06:53:59.892Z",
        //             "openingQty" => 0,
        //             "openingCost" => 0,
        //             "openingComm" => 0,
        //             "openOrderBuyQty" => 0,
        //             "openOrderBuyCost" => 0,
        //             "openOrderBuyPremium" => 0,
        //             "openOrderSellQty" => 0,
        //             "openOrderSellCost" => 0,
        //             "openOrderSellPremium" => 0,
        //             "execBuyQty" => 0,
        //             "execBuyCost" => 0,
        //             "execSellQty" => 0,
        //             "execSellCost" => 0,
        //             "execQty" => 0,
        //             "execCost" => 0,
        //             "execComm" => 0,
        //             "currentTimestamp" => "2020-11-09T06:53:59.893Z",
        //             "currentQty" => 0,
        //             "currentCost" => 0,
        //             "currentComm" => 0,
        //             "realisedCost" => 0,
        //             "unrealisedCost" => 0,
        //             "grossOpenCost" => 0,
        //             "grossOpenPremium" => 0,
        //             "grossExecCost" => 0,
        //             "isOpen" => true,
        //             "markPrice" => 0,
        //             "markValue" => 0,
        //             "riskValue" => 0,
        //             "homeNotional" => 0,
        //             "foreignNotional" => 0,
        //             "posState" => "string",
        //             "posCost" => 0,
        //             "posCost2" => 0,
        //             "posCross" => 0,
        //             "posInit" => 0,
        //             "posComm" => 0,
        //             "posLoss" => 0,
        //             "posMargin" => 0,
        //             "posMaint" => 0,
        //             "posAllowance" => 0,
        //             "taxableMargin" => 0,
        //             "initMargin" => 0,
        //             "maintMargin" => 0,
        //             "sessionMargin" => 0,
        //             "targetExcessMargin" => 0,
        //             "varMargin" => 0,
        //             "realisedGrossPnl" => 0,
        //             "realisedTax" => 0,
        //             "realisedPnl" => 0,
        //             "unrealisedGrossPnl" => 0,
        //             "longBankrupt" => 0,
        //             "shortBankrupt" => 0,
        //             "taxBase" => 0,
        //             "indicativeTaxRate" => 0,
        //             "indicativeTax" => 0,
        //             "unrealisedTax" => 0,
        //             "unrealisedPnl" => 0,
        //             "unrealisedPnlPcnt" => 0,
        //             "unrealisedRoePcnt" => 0,
        //             "simpleQty" => 0,
        //             "simpleCost" => 0,
        //             "simpleValue" => 0,
        //             "simplePnl" => 0,
        //             "simplePnlPcnt" => 0,
        //             "avgCostPrice" => 0,
        //             "avgEntryPrice" => 0,
        //             "breakEvenPrice" => 0,
        //             "marginCallPrice" => 0,
        //             "liquidationPrice" => 0,
        //             "bankruptPrice" => 0,
        //             "timestamp" => "2020-11-09T06:53:59.894Z",
        //             "lastPrice" => 0,
        //             "lastValue" => 0
        //         }
        //     )
        //
        return $this->parse_positions($response, $symbols);
    }

    public function parse_position($position, $market = null) {
        //
        //     {
        //         "account" => 9371654,
        //         "symbol" => "ETHUSDT",
        //         "currency" => "USDt",
        //         "underlying" => "ETH",
        //         "quoteCurrency" => "USDT",
        //         "commission" => 0.00075,
        //         "initMarginReq" => 0.3333333333333333,
        //         "maintMarginReq" => 0.01,
        //         "riskLimit" => 1000000000000,
        //         "leverage" => 3,
        //         "crossMargin" => false,
        //         "deleveragePercentile" => 1,
        //         "rebalancedPnl" => 0,
        //         "prevRealisedPnl" => 0,
        //         "prevUnrealisedPnl" => 0,
        //         "prevClosePrice" => 2053.738,
        //         "openingTimestamp" => "2022-05-21T04:00:00.000Z",
        //         "openingQty" => 0,
        //         "openingCost" => 0,
        //         "openingComm" => 0,
        //         "openOrderBuyQty" => 0,
        //         "openOrderBuyCost" => 0,
        //         "openOrderBuyPremium" => 0,
        //         "openOrderSellQty" => 0,
        //         "openOrderSellCost" => 0,
        //         "openOrderSellPremium" => 0,
        //         "execBuyQty" => 2000,
        //         "execBuyCost" => 39260000,
        //         "execSellQty" => 0,
        //         "execSellCost" => 0,
        //         "execQty" => 2000,
        //         "execCost" => 39260000,
        //         "execComm" => 26500,
        //         "currentTimestamp" => "2022-05-21T04:35:16.397Z",
        //         "currentQty" => 2000,
        //         "currentCost" => 39260000,
        //         "currentComm" => 26500,
        //         "realisedCost" => 0,
        //         "unrealisedCost" => 39260000,
        //         "grossOpenCost" => 0,
        //         "grossOpenPremium" => 0,
        //         "grossExecCost" => 39260000,
        //         "isOpen" => true,
        //         "markPrice" => 1964.195,
        //         "markValue" => 39283900,
        //         "riskValue" => 39283900,
        //         "homeNotional" => 0.02,
        //         "foreignNotional" => -39.2839,
        //         "posState" => "",
        //         "posCost" => 39260000,
        //         "posCost2" => 39260000,
        //         "posCross" => 0,
        //         "posInit" => 13086667,
        //         "posComm" => 39261,
        //         "posLoss" => 0,
        //         "posMargin" => 13125928,
        //         "posMaint" => 435787,
        //         "posAllowance" => 0,
        //         "taxableMargin" => 0,
        //         "initMargin" => 0,
        //         "maintMargin" => 13149828,
        //         "sessionMargin" => 0,
        //         "targetExcessMargin" => 0,
        //         "varMargin" => 0,
        //         "realisedGrossPnl" => 0,
        //         "realisedTax" => 0,
        //         "realisedPnl" => -26500,
        //         "unrealisedGrossPnl" => 23900,
        //         "longBankrupt" => 0,
        //         "shortBankrupt" => 0,
        //         "taxBase" => 0,
        //         "indicativeTaxRate" => null,
        //         "indicativeTax" => 0,
        //         "unrealisedTax" => 0,
        //         "unrealisedPnl" => 23900,
        //         "unrealisedPnlPcnt" => 0.0006,
        //         "unrealisedRoePcnt" => 0.0018,
        //         "simpleQty" => null,
        //         "simpleCost" => null,
        //         "simpleValue" => null,
        //         "simplePnl" => null,
        //         "simplePnlPcnt" => null,
        //         "avgCostPrice" => 1963,
        //         "avgEntryPrice" => 1963,
        //         "breakEvenPrice" => 1964.35,
        //         "marginCallPrice" => 1328.5,
        //         "liquidationPrice" => 1328.5,
        //         "bankruptPrice" => 1308.7,
        //         "timestamp" => "2022-05-21T04:35:16.397Z",
        //         "lastPrice" => 1964.195,
        //         "lastValue" => 39283900
        //     }
        //
        $market = $this->safe_market($this->safe_string($position, 'symbol'), $market);
        $symbol = $market['symbol'];
        $datetime = $this->safe_string($position, 'timestamp');
        $crossMargin = $this->safe_value($position, 'crossMargin');
        $marginMode = ($crossMargin === true) ? 'cross' : 'isolated';
        $notional = null;
        if ($market['quote'] === 'USDT') {
            $notional = Precise::string_mul($this->safe_string($position, 'foreignNotional'), '-1');
        }
        $maintenanceMargin = $this->safe_number($position, 'maintMargin');
        $unrealisedPnl = $this->safe_number($position, 'unrealisedPnl');
        return array(
            'info' => $position,
            'id' => $this->safe_string($position, 'account'),
            'symbol' => $symbol,
            'timestamp' => $this->parse8601($datetime),
            'datetime' => $datetime,
            'hedged' => null,
            'side' => null,
            'contracts' => null,
            'contractSize' => null,
            'entryPrice' => $this->safe_number($position, 'avgEntryPrice'),
            'markPrice' => $this->safe_number($position, 'markPrice'),
            'notional' => $notional,
            'leverage' => $this->safe_number($position, 'leverage'),
            'collateral' => null,
            'initialMargin' => null,
            'initialMarginPercentage' => $this->safe_number($position, 'initMarginReq'),
            'maintenanceMargin' => $this->convert_value($maintenanceMargin, $market),
            'maintenanceMarginPercentage' => null,
            'unrealizedPnl' => $this->convert_value($unrealisedPnl, $market),
            'liquidationPrice' => $this->safe_number($position, 'liquidationPrice'),
            'marginMode' => $marginMode,
            'marginRatio' => null,
            'percentage' => $this->safe_number($position, 'unrealisedPnlPcnt'),
        );
    }

    public function convert_value($value, $market = null) {
        if (($value === null) || ($market === null)) {
            return $value;
        }
        $resultValue = null;
        $value = $this->number_to_string($value);
        if (($market['quote'] === 'USD') || ($market['quote'] === 'EUR')) {
            $resultValue = Precise::string_mul($value, '0.00000001');
        }
        if ($market['quote'] === 'USDT') {
            $resultValue = Precise::string_mul($value, '0.000001');
        }
        return floatval($resultValue);
    }

    public function is_fiat($currency) {
        if ($currency === 'EUR') {
            return true;
        }
        if ($currency === 'PLN') {
            return true;
        }
        return false;
    }

    public function withdraw($code, $amount, $address, $tag = null, $params = array ()) {
        list($tag, $params) = $this->handle_withdraw_tag_and_params($tag, $params);
        $this->check_address($address);
        $this->load_markets();
        // $currency = $this->currency($code);
        if ($code !== 'BTC') {
            throw new ExchangeError($this->id . ' supoprts BTC withdrawals only, other currencies coming soon...');
        }
        $currency = $this->currency($code);
        $request = array(
            'currency' => 'XBt', // temporarily
            'amount' => $amount,
            'address' => $address,
            // 'otpToken' => '123456', // requires if two-factor auth (OTP) is enabled
            // 'fee' => 0.001, // bitcoin network fee
        );
        $response = $this->privatePostUserRequestWithdrawal (array_merge($request, $params));
        return $this->parse_transaction($response, $currency);
    }

    public function fetch_funding_rates($symbols = null, $params = array ()) {
        $this->load_markets();
        $response = $this->publicGetInstrumentActiveAndIndices ($params);
        //
        //    array(
        //        {
        //            "symbol" => "LTCUSDT",
        //            "rootSymbol" => "LTC",
        //            "state" => "Open",
        //            "typ" => "FFWCSX",
        //            "listing" => "2021-11-10T04:00:00.000Z",
        //            "front" => "2021-11-10T04:00:00.000Z",
        //            "expiry" => null,
        //            "settle" => null,
        //            "listedSettle" => null,
        //            "relistInterval" => null,
        //            "inverseLeg" => "",
        //            "sellLeg" => "",
        //            "buyLeg" => "",
        //            "optionStrikePcnt" => null,
        //            "optionStrikeRound" => null,
        //            "optionStrikePrice" => null,
        //            "optionMultiplier" => null,
        //            "positionCurrency" => "LTC",
        //            "underlying" => "LTC",
        //            "quoteCurrency" => "USDT",
        //            "underlyingSymbol" => "LTCT=",
        //            "reference" => "BMEX",
        //            "referenceSymbol" => ".BLTCT",
        //            "calcInterval" => null,
        //            "publishInterval" => null,
        //            "publishTime" => null,
        //            "maxOrderQty" => 1000000000,
        //            "maxPrice" => 1000000,
        //            "lotSize" => 1000,
        //            "tickSize" => 0.01,
        //            "multiplier" => 100,
        //            "settlCurrency" => "USDt",
        //            "underlyingToPositionMultiplier" => 10000,
        //            "underlyingToSettleMultiplier" => null,
        //            "quoteToSettleMultiplier" => 1000000,
        //            "isQuanto" => false,
        //            "isInverse" => false,
        //            "initMargin" => 0.03,
        //            "maintMargin" => 0.015,
        //            "riskLimit" => 1000000000000,
        //            "riskStep" => 1000000000000,
        //            "limit" => null,
        //            "capped" => false,
        //            "taxed" => true,
        //            "deleverage" => true,
        //            "makerFee" => -0.0001,
        //            "takerFee" => 0.0005,
        //            "settlementFee" => 0,
        //            "insuranceFee" => 0,
        //            "fundingBaseSymbol" => ".LTCBON8H",
        //            "fundingQuoteSymbol" => ".USDTBON8H",
        //            "fundingPremiumSymbol" => ".LTCUSDTPI8H",
        //            "fundingTimestamp" => "2022-01-14T20:00:00.000Z",
        //            "fundingInterval" => "2000-01-01T08:00:00.000Z",
        //            "fundingRate" => 0.0001,
        //            "indicativeFundingRate" => 0.0001,
        //            "rebalanceTimestamp" => null,
        //            "rebalanceInterval" => null,
        //            "openingTimestamp" => "2022-01-14T17:00:00.000Z",
        //            "closingTimestamp" => "2022-01-14T18:00:00.000Z",
        //            "sessionInterval" => "2000-01-01T01:00:00.000Z",
        //            "prevClosePrice" => 138.511,
        //            "limitDownPrice" => null,
        //            "limitUpPrice" => null,
        //            "bankruptLimitDownPrice" => null,
        //            "bankruptLimitUpPrice" => null,
        //            "prevTotalVolume" => 12699024000,
        //            "totalVolume" => 12702160000,
        //            "volume" => 3136000,
        //            "volume24h" => 114251000,
        //            "prevTotalTurnover" => 232418052349000,
        //            "totalTurnover" => 232463353260000,
        //            "turnover" => 45300911000,
        //            "turnover24h" => 1604331340000,
        //            "homeNotional24h" => 11425.1,
        //            "foreignNotional24h" => 1604331.3400000003,
        //            "prevPrice24h" => 135.48,
        //            "vwap" => 140.42165,
        //            "highPrice" => 146.42,
        //            "lowPrice" => 135.08,
        //            "lastPrice" => 144.36,
        //            "lastPriceProtected" => 144.36,
        //            "lastTickDirection" => "MinusTick",
        //            "lastChangePcnt" => 0.0655,
        //            "bidPrice" => 143.75,
        //            "midPrice" => 143.855,
        //            "askPrice" => 143.96,
        //            "impactBidPrice" => 143.75,
        //            "impactMidPrice" => 143.855,
        //            "impactAskPrice" => 143.96,
        //            "hasLiquidity" => true,
        //            "openInterest" => 38103000,
        //            "openValue" => 547963053300,
        //            "fairMethod" => "FundingRate",
        //            "fairBasisRate" => 0.1095,
        //            "fairBasis" => 0.004,
        //            "fairPrice" => 143.811,
        //            "markMethod" => "FairPrice",
        //            "markPrice" => 143.811,
        //            "indicativeTaxRate" => null,
        //            "indicativeSettlePrice" => 143.807,
        //            "optionUnderlyingPrice" => null,
        //            "settledPriceAdjustmentRate" => null,
        //            "settledPrice" => null,
        //            "timestamp" => "2022-01-14T17:49:55.000Z"
        //        }
        //    )
        //
        $filteredResponse = array();
        for ($i = 0; $i < count($response); $i++) {
            $item = $response[$i];
            $marketId = $this->safe_string($item, 'symbol');
            $market = $this->safe_market($marketId);
            $swap = $this->safe_value($market, 'swap', false);
            if ($swap) {
                $filteredResponse[] = $item;
            }
        }
        return $this->parse_funding_rates($filteredResponse, $symbols);
    }

    public function parse_funding_rate($premiumIndex, $market = null) {
        //
        //    {
        //        "symbol" => "LTCUSDT",
        //        "rootSymbol" => "LTC",
        //        "state" => "Open",
        //        "typ" => "FFWCSX",
        //        "listing" => "2021-11-10T04:00:00.000Z",
        //        "front" => "2021-11-10T04:00:00.000Z",
        //        "expiry" => null,
        //        "settle" => null,
        //        "listedSettle" => null,
        //        "relistInterval" => null,
        //        "inverseLeg" => "",
        //        "sellLeg" => "",
        //        "buyLeg" => "",
        //        "optionStrikePcnt" => null,
        //        "optionStrikeRound" => null,
        //        "optionStrikePrice" => null,
        //        "optionMultiplier" => null,
        //        "positionCurrency" => "LTC",
        //        "underlying" => "LTC",
        //        "quoteCurrency" => "USDT",
        //        "underlyingSymbol" => "LTCT=",
        //        "reference" => "BMEX",
        //        "referenceSymbol" => ".BLTCT",
        //        "calcInterval" => null,
        //        "publishInterval" => null,
        //        "publishTime" => null,
        //        "maxOrderQty" => 1000000000,
        //        "maxPrice" => 1000000,
        //        "lotSize" => 1000,
        //        "tickSize" => 0.01,
        //        "multiplier" => 100,
        //        "settlCurrency" => "USDt",
        //        "underlyingToPositionMultiplier" => 10000,
        //        "underlyingToSettleMultiplier" => null,
        //        "quoteToSettleMultiplier" => 1000000,
        //        "isQuanto" => false,
        //        "isInverse" => false,
        //        "initMargin" => 0.03,
        //        "maintMargin" => 0.015,
        //        "riskLimit" => 1000000000000,
        //        "riskStep" => 1000000000000,
        //        "limit" => null,
        //        "capped" => false,
        //        "taxed" => true,
        //        "deleverage" => true,
        //        "makerFee" => -0.0001,
        //        "takerFee" => 0.0005,
        //        "settlementFee" => 0,
        //        "insuranceFee" => 0,
        //        "fundingBaseSymbol" => ".LTCBON8H",
        //        "fundingQuoteSymbol" => ".USDTBON8H",
        //        "fundingPremiumSymbol" => ".LTCUSDTPI8H",
        //        "fundingTimestamp" => "2022-01-14T20:00:00.000Z",
        //        "fundingInterval" => "2000-01-01T08:00:00.000Z",
        //        "fundingRate" => 0.0001,
        //        "indicativeFundingRate" => 0.0001,
        //        "rebalanceTimestamp" => null,
        //        "rebalanceInterval" => null,
        //        "openingTimestamp" => "2022-01-14T17:00:00.000Z",
        //        "closingTimestamp" => "2022-01-14T18:00:00.000Z",
        //        "sessionInterval" => "2000-01-01T01:00:00.000Z",
        //        "prevClosePrice" => 138.511,
        //        "limitDownPrice" => null,
        //        "limitUpPrice" => null,
        //        "bankruptLimitDownPrice" => null,
        //        "bankruptLimitUpPrice" => null,
        //        "prevTotalVolume" => 12699024000,
        //        "totalVolume" => 12702160000,
        //        "volume" => 3136000,
        //        "volume24h" => 114251000,
        //        "prevTotalTurnover" => 232418052349000,
        //        "totalTurnover" => 232463353260000,
        //        "turnover" => 45300911000,
        //        "turnover24h" => 1604331340000,
        //        "homeNotional24h" => 11425.1,
        //        "foreignNotional24h" => 1604331.3400000003,
        //        "prevPrice24h" => 135.48,
        //        "vwap" => 140.42165,
        //        "highPrice" => 146.42,
        //        "lowPrice" => 135.08,
        //        "lastPrice" => 144.36,
        //        "lastPriceProtected" => 144.36,
        //        "lastTickDirection" => "MinusTick",
        //        "lastChangePcnt" => 0.0655,
        //        "bidPrice" => 143.75,
        //        "midPrice" => 143.855,
        //        "askPrice" => 143.96,
        //        "impactBidPrice" => 143.75,
        //        "impactMidPrice" => 143.855,
        //        "impactAskPrice" => 143.96,
        //        "hasLiquidity" => true,
        //        "openInterest" => 38103000,
        //        "openValue" => 547963053300,
        //        "fairMethod" => "FundingRate",
        //        "fairBasisRate" => 0.1095,
        //        "fairBasis" => 0.004,
        //        "fairPrice" => 143.811,
        //        "markMethod" => "FairPrice",
        //        "markPrice" => 143.811,
        //        "indicativeTaxRate" => null,
        //        "indicativeSettlePrice" => 143.807,
        //        "optionUnderlyingPrice" => null,
        //        "settledPriceAdjustmentRate" => null,
        //        "settledPrice" => null,
        //        "timestamp" => "2022-01-14T17:49:55.000Z"
        //    }
        //
        $datetime = $this->safe_string($premiumIndex, 'timestamp');
        $marketId = $this->safe_string($premiumIndex, 'symbol');
        $fundingDatetime = $this->safe_string($premiumIndex, 'fundingTimestamp');
        return array(
            'info' => $premiumIndex,
            'symbol' => $this->safe_symbol($marketId, $market),
            'markPrice' => $this->safe_number($premiumIndex, 'markPrice'),
            'indexPrice' => null,
            'interestRate' => null,
            'estimatedSettlePrice' => $this->safe_number($premiumIndex, 'indicativeSettlePrice'),
            'timestamp' => $this->parse8601($datetime),
            'datetime' => $datetime,
            'fundingRate' => $this->safe_number($premiumIndex, 'fundingRate'),
            'fundingTimestamp' => $this->iso8601($fundingDatetime),
            'fundingDatetime' => $fundingDatetime,
            'nextFundingRate' => $this->safe_number($premiumIndex, 'indicativeFundingRate'),
            'nextFundingTimestamp' => null,
            'nextFundingDatetime' => null,
            'previousFundingRate' => null,
            'previousFundingTimestamp' => null,
            'previousFundingDatetime' => null,
        );
    }

    public function fetch_funding_rate_history($symbol = null, $since = null, $limit = null, $params = array ()) {
        /**
         * Fetches the history of funding rates
         * @param {str|null} $symbol unified $symbol of the $market to fetch the funding rate history for
         * @param {int|null} $since timestamp in ms of the earliest funding rate to fetch
         * @param {int|null} $limit the maximum amount of ~@link https://docs.ccxt.com/en/latest/manual.html?#funding-rate-history-structure funding rate structures~ to fetch
         * @param {dict} $params extra parameters specific to the bitmex api endpoint
         * @param {int|null} $params->till timestamp in ms for ending date filter
         * @param {bool|null} $params->reverse if true, will sort results newest first
         * @param {int|null} $params->start starting point for results
         * @param {str|null} $params->columns array of column names to fetch in info, if omitted, will return all columns
         * @param {str|null} $params->filter generic table filter, send json key/value pairs, such as array("key" => "value"), you can key on individual fields, and do more advanced querying on timestamps, see the {@link https://www.bitmex.com/app/restAPI#Timestamp-Filters timestamp docs} for more details
         * @return {[dict]} a list of ~@link https://docs.ccxt.com/en/latest/manual.html?#funding-rate-history-structure funding rate structures~
         */
        $this->load_markets();
        $request = array();
        $market = null;
        if (is_array($this->currencies) && array_key_exists($symbol, $this->currencies)) {
            $code = $this->currency($symbol);
            $request['symbol'] = $code['id'];
        } elseif ($symbol !== null) {
            $splitSymbol = explode(':', $symbol);
            $splitSymbolLength = is_array($splitSymbol) ? count($splitSymbol) : 0;
            $timeframes = array( 'nearest', 'daily', 'weekly', 'monthly', 'quarterly', 'biquarterly', 'perpetual' );
            if (($splitSymbolLength > 1) && $this->in_array($splitSymbol[1], $timeframes)) {
                $code = $this->currency($splitSymbol[0]);
                $symbol = $code['id'] . ':' . $splitSymbol[1];
                $request['symbol'] = $symbol;
            } else {
                $market = $this->market($symbol);
                $request['symbol'] = $market['id'];
            }
        }
        if ($since !== null) {
            $request['startTime'] = $this->iso8601($since);
        }
        if ($limit !== null) {
            $request['count'] = $limit;
        }
        $till = $this->safe_integer($params, 'till');
        $params = $this->omit($params, array( 'till' ));
        if ($till !== null) {
            $request['endTime'] = $this->iso8601($till);
        }
        $response = $this->publicGetFunding (array_merge($request, $params));
        //
        //    array(
        //        {
        //            "timestamp" => "2016-05-07T12:00:00.000Z",
        //            "symbol" => "ETHXBT",
        //            "fundingInterval" => "2000-01-02T00:00:00.000Z",
        //            "fundingRate" => 0.0010890000000000001,
        //            "fundingRateDaily" => 0.0010890000000000001
        //        }
        //    )
        //
        return $this->parse_funding_rate_histories($response, $market, $since, $limit);
    }

    public function parse_funding_rate_history($info, $market = null) {
        //
        //    {
        //        "timestamp" => "2016-05-07T12:00:00.000Z",
        //        "symbol" => "ETHXBT",
        //        "fundingInterval" => "2000-01-02T00:00:00.000Z",
        //        "fundingRate" => 0.0010890000000000001,
        //        "fundingRateDaily" => 0.0010890000000000001
        //    }
        //
        $marketId = $this->safe_string($info, 'symbol');
        $datetime = $this->safe_string($info, 'timestamp');
        return array(
            'info' => $info,
            'symbol' => $this->safe_symbol($marketId, $market),
            'fundingRate' => $this->safe_number($info, 'fundingRate'),
            'timestamp' => $this->parse8601($datetime),
            'datetime' => $datetime,
        );
    }

    public function set_leverage($leverage, $symbol = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' setLeverage() requires a $symbol argument');
        }
        if (($leverage < 0.01) || ($leverage > 100)) {
            throw new BadRequest($this->id . ' $leverage should be between 0.01 and 100');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        if ($market['type'] !== 'swap' && $market['type'] !== 'future') {
            throw new BadSymbol($this->id . ' setLeverage() supports future and swap contracts only');
        }
        $request = array(
            'symbol' => $market['id'],
            'leverage' => $leverage,
        );
        return $this->privatePostPositionLeverage (array_merge($request, $params));
    }

    public function set_margin_mode($marginMode, $symbol = null, $params = array ()) {
        if ($symbol === null) {
            throw new ArgumentsRequired($this->id . ' setMarginMode() requires a $symbol argument');
        }
        $marginMode = strtolower($marginMode);
        if ($marginMode !== 'isolated' && $marginMode !== 'cross') {
            throw new BadRequest($this->id . ' setMarginMode() $marginMode argument should be isolated or cross');
        }
        $this->load_markets();
        $market = $this->market($symbol);
        if (($market['type'] !== 'swap') && ($market['type'] !== 'future')) {
            throw new BadSymbol($this->id . ' setMarginMode() supports swap and future contracts only');
        }
        $enabled = ($marginMode === 'cross') ? false : true;
        $request = array(
            'symbol' => $market['id'],
            'enabled' => $enabled,
        );
        return $this->privatePostPositionIsolate (array_merge($request, $params));
    }

    public function handle_errors($code, $reason, $url, $method, $headers, $body, $response, $requestHeaders, $requestBody) {
        if ($response === null) {
            return;
        }
        if ($code === 429) {
            throw new DDoSProtection($this->id . ' ' . $body);
        }
        if ($code >= 400) {
            $error = $this->safe_value($response, 'error', array());
            $message = $this->safe_string($error, 'message');
            $feedback = $this->id . ' ' . $body;
            $this->throw_exactly_matched_exception($this->exceptions['exact'], $message, $feedback);
            $this->throw_broadly_matched_exception($this->exceptions['broad'], $message, $feedback);
            if ($code === 400) {
                throw new BadRequest($feedback);
            }
            throw new ExchangeError($feedback); // unknown $message
        }
    }

    public function nonce() {
        return $this->milliseconds();
    }

    public function sign($path, $api = 'public', $method = 'GET', $params = array (), $headers = null, $body = null) {
        $query = '/api/' . $this->version . '/' . $path;
        if ($method === 'GET') {
            if ($params) {
                $query .= '?' . $this->urlencode($params);
            }
        } else {
            $format = $this->safe_string($params, '_format');
            if ($format !== null) {
                $query .= '?' . $this->urlencode(array( '_format' => $format ));
                $params = $this->omit($params, '_format');
            }
        }
        $url = $this->urls['api'][$api] . $query;
        if ($api === 'private') {
            $this->check_required_credentials();
            $auth = $method . $query;
            $expires = $this->safe_integer($this->options, 'api-expires');
            $headers = array(
                'Content-Type' => 'application/json',
                'api-key' => $this->apiKey,
            );
            $expires = $this->sum($this->seconds(), $expires);
            $expires = (string) $expires;
            $auth .= $expires;
            $headers['api-expires'] = $expires;
            if ($method === 'POST' || $method === 'PUT' || $method === 'DELETE') {
                if ($params) {
                    $body = $this->json($params);
                    $auth .= $body;
                }
            }
            $headers['api-signature'] = $this->hmac($this->encode($auth), $this->encode($this->secret));
        }
        return array( 'url' => $url, 'method' => $method, 'body' => $body, 'headers' => $headers );
    }
}
