<?php

namespace ccxt;

// PLEASE DO NOT EDIT THIS FILE, IT IS GENERATED AND WILL BE OVERWRITTEN:
// https://github.com/ccxt/ccxt/blob/master/CONTRIBUTING.md#how-to-contribute-code

use Exception; // a common import
use \ccxt\ExchangeError;
use \ccxt\InvalidOrder;
use \ccxt\OrderNotFound;
use \ccxt\ExchangeNotAvailable;

class hitbtc extends Exchange {

    public function describe() {
        return $this->deep_extend(parent::describe (), array(
            'id' => 'hitbtc',
            'name' => 'HitBTC',
            'countries' => array( 'HK' ),
            // 300 requests per second => 1000ms / 300 = 3.333ms between requests on average (Trading)
            // 100 requests per second => ( 1000ms / rateLimit ) / 100 => cost = 3.0003 (Market Data)
            // 20 requests per second => ( 1000ms / rateLimit ) / 20 => cost = 15.0015 (Other Requests)
            'rateLimit' => 3.333,
            'version' => '2',
            'pro' => true,
            'has' => array(
                'CORS' => null,
                'spot' => true,
                'margin' => false,
                'swap' => false,
                'future' => false,
                'option' => false,
                'addMargin' => false,
                'cancelOrder' => true,
                'createDepositAddress' => true,
                'createOrder' => true,
                'createReduceOnlyOrder' => false,
                'editOrder' => true,
                'fetchBalance' => true,
                'fetchBorrowRate' => false,
                'fetchBorrowRateHistories' => false,
                'fetchBorrowRateHistory' => false,
                'fetchBorrowRates' => false,
                'fetchBorrowRatesPerSymbol' => false,
                'fetchClosedOrders' => true,
                'fetchCurrencies' => true,
                'fetchDepositAddress' => true,
                'fetchDeposits' => null,
                'fetchFundingHistory' => false,
                'fetchFundingRate' => false,
                'fetchFundingRateHistory' => false,
                'fetchFundingRates' => false,
                'fetchIndexOHLCV' => false,
                'fetchLeverage' => false,
                'fetchLeverageTiers' => false,
                'fetchMarkets' => true,
                'fetchMarkOHLCV' => false,
                'fetchMyTrades' => true,
                'fetchOHLCV' => true,
                'fetchOpenInterestHistory' => false,
                'fetchOpenOrder' => true,
                'fetchOpenOrders' => true,
                'fetchOrder' => true,
                'fetchOrderBook' => true,
                'fetchOrders' => null,
                'fetchOrderTrades' => true,
                'fetchPosition' => false,
                'fetchPositions' => false,
                'fetchPositionsRisk' => false,
                'fetchPremiumIndexOHLCV' => false,
                'fetchTicker' => true,
                'fetchTickers' => true,
                'fetchTrades' => true,
                'fetchTradingFee' => true,
                'fetchTradingFees' => false,
                'fetchTransactions' => true,
                'fetchWithdrawals' => null,
                'reduceMargin' => false,
                'setLeverage' => false,
                'setMarginMode' => false,
                'setPositionMode' => false,
                'transfer' => true,
                'withdraw' => true,
            ),
            'timeframes' => array(
                '1m' => 'M1',
                '3m' => 'M3',
                '5m' => 'M5',
                '15m' => 'M15',
                '30m' => 'M30', // default
                '1h' => 'H1',
                '4h' => 'H4',
                '1d' => 'D1',
                '1w' => 'D7',
                '1M' => '1M',
            ),
            'urls' => array(
                'logo' => 'https://user-images.githubusercontent.com/1294454/27766555-8eaec20e-5edc-11e7-9c5b-6dc69fc42f5e.jpg',
                'test' => array(
                    'public' => 'https://api.demo.hitbtc.com',
                    'private' => 'https://api.demo.hitbtc.com',
                ),
                'api' => array(
                    'public' => 'https://api.hitbtc.com',
                    'private' => 'https://api.hitbtc.com',
                ),
                'www' => 'https://hitbtc.com',
                'referral' => 'https://hitbtc.com/?ref_id=5a5d39a65d466',
                'doc' => array(
                    'https://api.hitbtc.com/v2',
                ),
                'fees' => array(
                    'https://hitbtc.com/fees-and-limits',
                    'https://support.hitbtc.com/hc/en-us/articles/115005148605-Fees-and-limits',
                ),
            ),
            'api' => array(
                'public' => array(
                    'get' => array(
                        'currency' => 3, // Available Currencies
                        'currency/{currency}' => 3, // Get currency info
                        'symbol' => 3, // Available Currency Symbols
                        'symbol/{symbol}' => 3, // Get symbol info
                        'ticker' => 3, // Ticker list for all symbols
                        'ticker/{symbol}' => 3, // Ticker for symbol
                        'trades' => 3,
                        'trades/{symbol}' => 3, // Trades
                        'orderbook' => 3,
                        'orderbook/{symbol}' => 3, // Orderbook
                        'candles' => 3,
                        'candles/{symbol}' => 3, // Candles
                    ),
                ),
                'private' => array(
                    'get' => array(
                        'trading/balance' => 15.0015, // Get trading balance
                        'order' => 15.0015, // List your current open orders
                        'order/{clientOrderId}' => 15.0015, // Get a single order by clientOrderId
                        'trading/fee/all' => 15.0015, // Get trading fee rate
                        'trading/fee/{symbol}' => 15.0015, // Get trading fee rate
                        'margin/account' => 15.0015,
                        'margin/account/{symbol}' => 15.0015,
                        'margin/position' => 15.0015,
                        'margin/position/{symbol}' => 15.0015,
                        'margin/order' => 15.0015,
                        'margin/order/{clientOrderId}' => 15.0015,
                        'history/order' => 15.0015, // Get historical orders
                        'history/trades' => 15.0015, // Get historical trades
                        'history/order/{orderId}/trades' => 15.0015, // Get historical trades by specified order
                        'account/balance' => 15.0015, // Get main acccount balance
                        'account/crypto/address/{currency}' => 15.0015, // Get current address
                        'account/crypto/addresses/{currency}' => 15.0015, // Get last 10 deposit addresses for currency
                        'account/crypto/used-addresses/{currency}' => 15.0015, // Get last 10 unique addresses used for withdraw by currency
                        'account/crypto/estimate-withdraw' => 15.0015,
                        'account/crypto/is-mine/{address}' => 15.0015,
                        'account/transactions' => 15.0015, // Get account transactions
                        'account/transactions/{id}' => 15.0015, // Get account transaction by id
                        'sub-acc' => 15.0015,
                        'sub-acc/acl' => 15.0015,
                        'sub-acc/balance/{subAccountUserID}' => 15.0015,
                        'sub-acc/deposit-address/{subAccountUserId}/{currency}' => 15.0015,
                    ),
                    'post' => array(
                        'order' => 1, // Create new order
                        'margin/order' => 1,
                        'account/crypto/address/{currency}' => 1, // Create new crypto deposit address
                        'account/crypto/withdraw' => 1, // Withdraw crypto
                        'account/crypto/transfer-convert' => 1,
                        'account/transfer' => 1, // Transfer amount to trading account or to main account
                        'account/transfer/internal' => 1,
                        'sub-acc/freeze' => 1,
                        'sub-acc/activate' => 1,
                        'sub-acc/transfer' => 1,
                    ),
                    'put' => array(
                        'order/{clientOrderId}' => 1, // Create new order
                        'margin/account/{symbol}' => 1,
                        'margin/order/{clientOrderId}' => 1,
                        'account/crypto/withdraw/{id}' => 1, // Commit crypto withdrawal
                        'sub-acc/acl/{subAccountUserId}' => 1,
                    ),
                    'delete' => array(
                        'order' => 1, // Cancel all open orders
                        'order/{clientOrderId}' => 1, // Cancel order
                        'margin/account' => 1,
                        'margin/account/{symbol}' => 1,
                        'margin/position' => 1,
                        'margin/position/{symbol}' => 1,
                        'margin/order' => 1,
                        'margin/order/{clientOrderId}' => 1,
                        'account/crypto/withdraw/{id}' => 1, // Rollback crypto withdrawal
                    ),
                    // outdated?
                    'patch' => array(
                        'order/{clientOrderId}' => 1, // Cancel Replace order
                    ),
                ),
            ),
            'precisionMode' => TICK_SIZE,
            'fees' => array(
                'trading' => array(
                    'tierBased' => false,
                    'percentage' => true,
                    'maker' => 0.1 / 100,
                    'taker' => 0.2 / 100,
                ),
            ),
            'options' => array(
                'networks' => array(
                    'ETH' => 'T20',
                    'ERC20' => 'T20',
                    'TRX' => 'TTRX',
                    'TRC20' => 'TTRX',
                    'OMNI' => '',
                ),
                'defaultTimeInForce' => 'FOK',
                'accountsByType' => array(
                    'funding' => 'bank',
                    'spot' => 'exchange',
                ),
                'fetchBalanceMethod' => array(
                    'account' => 'account',
                    'bank' => 'account',
                    'main' => 'account',
                    'funding' => 'account',
                    'exchange' => 'trading',
                    'spot' => 'trading',
                    'trade' => 'trading',
                    'trading' => 'trading',
                ),
            ),
            'commonCurrencies' => array(
                'AUTO' => 'Cube',
                'BCC' => 'BCC', // initial symbol for Bitcoin Cash, now inactive
                'BDP' => 'BidiPass',
                'BET' => 'DAO.Casino',
                'BIT' => 'BitRewards',
                'BOX' => 'BOX Token',
                'CPT' => 'Cryptaur', // conflict with CPT = Contents Protocol https://github.com/ccxt/ccxt/issues/4920 and https://github.com/ccxt/ccxt/issues/6081
                'GET' => 'Themis',
                'GMT' => 'GMT Token',
                'HSR' => 'HC',
                'IQ' => 'IQ.Cash',
                'LNC' => 'LinkerCoin',
                'PLA' => 'PlayChip',
                'PNT' => 'Penta',
                'SBTC' => 'Super Bitcoin',
                'STEPN' => 'GMT',
                'STX' => 'STOX',
                'TV' => 'Tokenville',
                'USD' => 'USDT',
                'XMT' => 'MTL',
                'XPNT' => 'PNT',
            ),
            'exceptions' => array(
                '504' => '\\ccxt\\RequestTimeout', // array("error":array("code":504,"message":"Gateway Timeout"))
                '1002' => '\\ccxt\\AuthenticationError', // array("error":array("code":1002,"message":"Authorization failed","description":""))
                '1003' => '\\ccxt\\PermissionDenied', // "Action is forbidden for this API key"
                '2010' => '\\ccxt\\InvalidOrder', // "Quantity not a valid number"
                '2001' => '\\ccxt\\BadSymbol', // "Symbol not found"
                '2011' => '\\ccxt\\InvalidOrder', // "Quantity too low"
                '2020' => '\\ccxt\\InvalidOrder', // "Price not a valid number"
                '20002' => '\\ccxt\\OrderNotFound', // canceling non-existent order
                '20001' => '\\ccxt\\InsufficientFunds', // array("error":array("code":20001,"message":"Insufficient funds","description":"Check that the funds are sufficient, given commissions"))
                '20010' => '\\ccxt\\BadSymbol', // array("error":array("code":20010,"message":"Exchange temporary closed","description":"Exchange market for this symbol is temporary closed"))
                '20045' => '\\ccxt\\InvalidOrder', // array("error":array("code":20045,"message":"Fat finger limit exceeded"))
            ),
        ));
    }

    public function fee_to_precision($symbol, $fee) {
        return $this->decimal_to_precision($fee, TRUNCATE, 8, DECIMAL_PLACES);
    }

    public function fetch_markets($params = array ()) {
        /**
         * retrieves data on all markets for hitbtc
         * @param {dict} $params extra parameters specific to the exchange api endpoint
         * @return {[dict]} an array of objects representing $market data
         */
        $response = $this->publicGetSymbol ($params);
        //
        //     array(
        //         {
        //             "id":"BCNBTC",
        //             "baseCurrency":"BCN",
        //             "quoteCurrency":"BTC",
        //             "quantityIncrement":"100",
        //             "tickSize":"0.00000000001",
        //             "takeLiquidityRate":"0.002",
        //             "provideLiquidityRate":"0.001",
        //             "feeCurrency":"BTC"
        //         }
        //     )
        //
        $result = array();
        for ($i = 0; $i < count($response); $i++) {
            $market = $response[$i];
            $id = $this->safe_string($market, 'id');
            $baseId = $this->safe_string($market, 'baseCurrency');
            $quoteId = $this->safe_string($market, 'quoteCurrency');
            $base = $this->safe_currency_code($baseId);
            $quote = $this->safe_currency_code($quoteId);
            // bequant fix
            $symbol = $base . '/' . $quote;
            if (mb_strpos($id, '_') !== false) {
                $symbol = $id;
            }
            $lotString = $this->safe_string($market, 'quantityIncrement');
            $stepString = $this->safe_string($market, 'tickSize');
            $lot = $this->parse_number($lotString);
            $step = $this->parse_number($stepString);
            $feeCurrencyId = $this->safe_string($market, 'feeCurrency');
            $result[] = array_merge($this->fees['trading'], array(
                'id' => $id,
                'symbol' => $symbol,
                'base' => $base,
                'quote' => $quote,
                'settle' => null,
                'baseId' => $baseId,
                'quoteId' => $quoteId,
                'settleId' => null,
                'type' => 'spot',
                'spot' => true,
                'margin' => false,
                'swap' => false,
                'future' => false,
                'option' => false,
                'active' => true,
                'contract' => false,
                'linear' => null,
                'inverse' => null,
                'taker' => $this->safe_number($market, 'takeLiquidityRate'),
                'maker' => $this->safe_number($market, 'provideLiquidityRate'),
                'contractSize' => null,
                'expiry' => null,
                'expiryDatetime' => null,
                'strike' => null,
                'optionType' => null,
                'feeCurrency' => $this->safe_currency_code($feeCurrencyId),
                'precision' => array(
                    'amount' => $lot,
                    'price' => $step,
                ),
                'limits' => array(
                    'leverage' => array(
                        'min' => null,
                        'max' => null,
                    ),
                    'amount' => array(
                        'min' => $lot,
                        'max' => null,
                    ),
                    'price' => array(
                        'min' => $step,
                        'max' => null,
                    ),
                    'cost' => array(
                        'min' => $this->parse_number(Precise::string_mul($lotString, $stepString)),
                        'max' => null,
                    ),
                ),
                'info' => $market,
            ));
        }
        return $result;
    }

    public function transfer($code, $amount, $fromAccount, $toAccount, $params = array ()) {
        // account can be "exchange" or "bank", with aliases "main" or "trading" respectively
        $this->load_markets();
        $currency = $this->currency($code);
        $requestAmount = $this->currency_to_precision($code, $amount);
        $request = array(
            'currency' => $currency['id'],
            'amount' => $requestAmount,
        );
        $type = $this->safe_string($params, 'type');
        if ($type === null) {
            $accountsByType = $this->safe_value($this->options, 'accountsByType', array());
            $fromId = $this->safe_string($accountsByType, $fromAccount, $fromAccount);
            $toId = $this->safe_string($accountsByType, $toAccount, $toAccount);
            if ($fromId === $toId) {
                throw new ExchangeError($this->id . ' $transfer() from and to cannot be the same account');
            }
            $type = $fromId . 'To' . $this->capitalize($toId);
        }
        $request['type'] = $type;
        $response = $this->privatePostAccountTransfer (array_merge($request, $params));
        //
        //     {
        //         'id' => '2db6ebab-fb26-4537-9ef8-1a689472d236'
        //     }
        //
        $transfer = $this->parse_transfer($response, $currency);
        return array_merge($transfer, array(
            'fromAccount' => $fromAccount,
            'toAccount' => $toAccount,
            'amount' => $this->parse_number($requestAmount),
        ));
    }

    public function parse_transfer($transfer, $currency = null) {
        //
        //     {
        //         'id' => '2db6ebab-fb26-4537-9ef8-1a689472d236'
        //     }
        //
        $timestamp = $this->milliseconds();
        return array(
            'id' => $this->safe_string($transfer, 'id'),
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'currency' => $this->safe_currency_code(null, $currency),
            'amount' => null,
            'fromAccount' => null,
            'toAccount' => null,
            'status' => null,
            'info' => $transfer,
        );
    }

    public function fetch_currencies($params = array ()) {
        /**
         * fetches all available currencies on an exchange
         * @param {dict} $params extra parameters specific to the hitbtc api endpoint
         * @return {dict} an associative dictionary of currencies
         */
        $response = $this->publicGetCurrency ($params);
        //
        //     array(
        //         {
        //             "id":"XPNT",
        //             "fullName":"pToken",
        //             "crypto":true,
        //             "payinEnabled":true,
        //             "payinPaymentId":false,
        //             "payinConfirmations":9,
        //             "payoutEnabled":true,
        //             "payoutIsPaymentId":false,
        //             "transferEnabled":true,
        //             "delisted":false,
        //             "payoutFee":"26.510000000000",
        //             "precisionPayout":18,
        //             "precisionTransfer":8
        //         }
        //     )
        //
        $result = array();
        for ($i = 0; $i < count($response); $i++) {
            $currency = $response[$i];
            $id = $this->safe_string($currency, 'id');
            // todo => will need to rethink the fees
            // to add support for multiple withdrawal/deposit methods and
            // differentiated fees for each particular method
            $decimals = $this->safe_integer($currency, 'precisionTransfer', 8);
            $precision = 1 / pow(10, $decimals);
            $code = $this->safe_currency_code($id);
            $payin = $this->safe_value($currency, 'payinEnabled');
            $payout = $this->safe_value($currency, 'payoutEnabled');
            $transfer = $this->safe_value($currency, 'transferEnabled');
            $active = $payin && $payout && $transfer;
            if (is_array($currency) && array_key_exists('disabled', $currency)) {
                if ($currency['disabled']) {
                    $active = false;
                }
            }
            $type = 'fiat';
            if ((is_array($currency) && array_key_exists('crypto', $currency)) && $currency['crypto']) {
                $type = 'crypto';
            }
            $name = $this->safe_string($currency, 'fullName');
            $result[$code] = array(
                'id' => $id,
                'code' => $code,
                'type' => $type,
                'payin' => $payin,
                'payout' => $payout,
                'transfer' => $transfer,
                'info' => $currency,
                'name' => $name,
                'active' => $active,
                'deposit' => $payin,
                'withdraw' => $payout,
                'fee' => $this->safe_number($currency, 'payoutFee'), // todo => redesign
                'precision' => $precision,
                'limits' => array(
                    'amount' => array(
                        'min' => 1 / pow(10, $decimals),
                        'max' => pow(10, $decimals),
                    ),
                    'withdraw' => array(
                        'min' => null,
                        'max' => pow(10, $precision),
                    ),
                ),
            );
        }
        return $result;
    }

    public function parse_trading_fee($fee, $market = null) {
        //
        //
        //     {
        //         takeLiquidityRate => '0.001',
        //         provideLiquidityRate => '-0.0001'
        //     }
        //
        return array(
            'info' => $fee,
            'symbol' => $this->safe_symbol(null, $market),
            'maker' => $this->safe_number($fee, 'provideLiquidityRate'),
            'taker' => $this->safe_number($fee, 'takeLiquidityRate'),
            'percentage' => true,
            'tierBased' => true,
        );
    }

    public function fetch_trading_fee($symbol, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        $response = $this->privateGetTradingFeeSymbol ($request);
        //
        //     {
        //         takeLiquidityRate => '0.001',
        //         provideLiquidityRate => '-0.0001'
        //     }
        //
        return $this->parse_trading_fee($response, $market);
    }

    public function parse_balance($response) {
        $result = array(
            'info' => $response,
            'timestamp' => null,
            'datetime' => null,
        );
        for ($i = 0; $i < count($response); $i++) {
            $balance = $response[$i];
            $currencyId = $this->safe_string($balance, 'currency');
            $code = $this->safe_currency_code($currencyId);
            $account = $this->account();
            $account['free'] = $this->safe_string($balance, 'available');
            $account['used'] = $this->safe_string($balance, 'reserved');
            $result[$code] = $account;
        }
        return $this->safe_balance($result);
    }

    public function fetch_balance($params = array ()) {
        /**
         * $query for balance and get the amount of funds available for trading or funds locked in orders
         * @param {dict} $params extra parameters specific to the hitbtc api endpoint
         * @return {dict} a ~@link https://docs.ccxt.com/en/latest/manual.html?#balance-structure balance structure~
         */
        $this->load_markets();
        $type = $this->safe_string($params, 'type', 'trading');
        $fetchBalanceAccounts = $this->safe_value($this->options, 'fetchBalanceMethod', array());
        $typeId = $this->safe_string($fetchBalanceAccounts, $type);
        if ($typeId === null) {
            throw new ExchangeError($this->id . ' fetchBalance() account $type must be either main or trading');
        }
        $method = 'privateGet' . $this->capitalize($typeId) . 'Balance';
        $query = $this->omit($params, 'type');
        $response = $this->$method ($query);
        //
        //     array(
        //         array("currency":"SPI","available":"0","reserved":"0"),
        //         array("currency":"GRPH","available":"0","reserved":"0"),
        //         array("currency":"DGTX","available":"0","reserved":"0"),
        //     )
        //
        return $this->parse_balance($response);
    }

    public function parse_ohlcv($ohlcv, $market = null) {
        //
        //     {
        //         "timestamp":"2015-08-20T19:01:00.000Z",
        //         "open":"0.006",
        //         "close":"0.006",
        //         "min":"0.006",
        //         "max":"0.006",
        //         "volume":"0.003",
        //         "volumeQuote":"0.000018"
        //     }
        //
        return array(
            $this->parse8601($this->safe_string($ohlcv, 'timestamp')),
            $this->safe_number($ohlcv, 'open'),
            $this->safe_number($ohlcv, 'max'),
            $this->safe_number($ohlcv, 'min'),
            $this->safe_number($ohlcv, 'close'),
            $this->safe_number($ohlcv, 'volume'),
        );
    }

    public function fetch_ohlcv($symbol, $timeframe = '1m', $since = null, $limit = null, $params = array ()) {
        /**
         * fetches historical candlestick data containing the open, high, low, and close price, and the volume of a $market
         * @param {str} $symbol unified $symbol of the $market to fetch OHLCV data for
         * @param {str} $timeframe the length of time each candle represents
         * @param {int|null} $since timestamp in ms of the earliest candle to fetch
         * @param {int|null} $limit the maximum amount of candles to fetch
         * @param {dict} $params extra parameters specific to the hitbtc api endpoint
         * @return {[[int]]} A list of candles ordered as timestamp, open, high, low, close, volume
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
            'period' => $this->timeframes[$timeframe],
        );
        if ($since !== null) {
            $request['from'] = $this->iso8601($since);
        }
        if ($limit !== null) {
            $request['limit'] = $limit;
        }
        $response = $this->publicGetCandlesSymbol (array_merge($request, $params));
        //
        //     array(
        //         array("timestamp":"2015-08-20T19:01:00.000Z","open":"0.006","close":"0.006","min":"0.006","max":"0.006","volume":"0.003","volumeQuote":"0.000018"),
        //         array("timestamp":"2015-08-20T19:03:00.000Z","open":"0.006","close":"0.006","min":"0.006","max":"0.006","volume":"0.013","volumeQuote":"0.000078"),
        //         array("timestamp":"2015-08-20T19:06:00.000Z","open":"0.0055","close":"0.005","min":"0.005","max":"0.0055","volume":"0.003","volumeQuote":"0.0000155"),
        //     )
        //
        return $this->parse_ohlcvs($response, $market, $timeframe, $since, $limit);
    }

    public function fetch_order_book($symbol, $limit = null, $params = array ()) {
        /**
         * fetches information on open orders with bid (buy) and ask (sell) prices, volumes and other data
         * @param {str} $symbol unified $symbol of the market to fetch the order book for
         * @param {int|null} $limit the maximum amount of order book entries to return
         * @param {dict} $params extra parameters specific to the hitbtc api endpoint
         * @return {dict} A dictionary of {@link https://docs.ccxt.com/en/latest/manual.html#order-book-structure order book structures} indexed by market symbols
         */
        $this->load_markets();
        $request = array(
            'symbol' => $this->market_id($symbol),
        );
        if ($limit !== null) {
            $request['limit'] = $limit; // default = 100, 0 = unlimited
        }
        $response = $this->publicGetOrderbookSymbol (array_merge($request, $params));
        return $this->parse_order_book($response, $symbol, null, 'bid', 'ask', 'price', 'size');
    }

    public function parse_ticker($ticker, $market = null) {
        $timestamp = $this->parse8601($ticker['timestamp']);
        $symbol = $this->safe_symbol(null, $market);
        $baseVolume = $this->safe_string($ticker, 'volume');
        $quoteVolume = $this->safe_string($ticker, 'volumeQuote');
        $open = $this->safe_string($ticker, 'open');
        $last = $this->safe_string($ticker, 'last');
        return $this->safe_ticker(array(
            'symbol' => $symbol,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'high' => $this->safe_string($ticker, 'high'),
            'low' => $this->safe_string($ticker, 'low'),
            'bid' => $this->safe_string($ticker, 'bid'),
            'bidVolume' => null,
            'ask' => $this->safe_string($ticker, 'ask'),
            'askVolume' => null,
            'vwap' => null,
            'open' => $open,
            'close' => $last,
            'last' => $last,
            'previousClose' => null,
            'change' => null,
            'percentage' => null,
            'average' => null,
            'baseVolume' => $baseVolume,
            'quoteVolume' => $quoteVolume,
            'info' => $ticker,
        ), $market);
    }

    public function fetch_tickers($symbols = null, $params = array ()) {
        /**
         * fetches price tickers for multiple markets, statistical calculations with the information calculated over the past 24 hours each $market
         * @param {[str]|null} $symbols unified $symbols of the markets to fetch the $ticker for, all $market tickers are returned if not assigned
         * @param {dict} $params extra parameters specific to the hitbtc api endpoint
         * @return {dict} an array of {@link https://docs.ccxt.com/en/latest/manual.html#$ticker-structure $ticker structures}
         */
        $this->load_markets();
        $response = $this->publicGetTicker ($params);
        $result = array();
        for ($i = 0; $i < count($response); $i++) {
            $ticker = $response[$i];
            $marketId = $this->safe_string($ticker, 'symbol');
            $market = $this->safe_market($marketId);
            $symbol = $market['symbol'];
            $result[$symbol] = $this->parse_ticker($ticker, $market);
        }
        return $this->filter_by_array($result, 'symbol', $symbols);
    }

    public function fetch_ticker($symbol, $params = array ()) {
        /**
         * fetches a price ticker, a statistical calculation with the information calculated over the past 24 hours for a specific $market
         * @param {str} $symbol unified $symbol of the $market to fetch the ticker for
         * @param {dict} $params extra parameters specific to the hitbtc api endpoint
         * @return {dict} a {@link https://docs.ccxt.com/en/latest/manual.html#ticker-structure ticker structure}
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        $response = $this->publicGetTickerSymbol (array_merge($request, $params));
        if (is_array($response) && array_key_exists('message', $response)) {
            throw new ExchangeError($this->id . ' ' . $response['message']);
        }
        return $this->parse_ticker($response, $market);
    }

    public function parse_trade($trade, $market = null) {
        // createMarketOrder
        //
        //  {       $fee => "0.0004644",
        //           $id =>  386394956,
        //        price => "0.4644",
        //     quantity => "1",
        //    $timestamp => "2018-10-25T16:41:44.780Z" }
        //
        // fetchTrades
        //
        // { $id => 974786185,
        //   price => '0.032462',
        //   quantity => '0.3673',
        //   $side => 'buy',
        //   $timestamp => '2020-10-16T12:57:39.846Z' }
        //
        // fetchMyTrades
        //
        // { $id => 277210397,
        //   clientOrderId => '6e102f3e7f3f4e04aeeb1cdc95592f1a',
        //   $orderId => 28102855393,
        //   $symbol => 'ETHBTC',
        //   $side => 'sell',
        //   quantity => '0.002',
        //   price => '0.073365',
        //   $fee => '0.000000147',
        //   $timestamp => '2018-04-28T18:39:55.345Z' }
        //
        //  {
        //      "id":1568938909,
        //      "orderId":793293348428,
        //      "clientOrderId":"fbc5c5b753e8476cb14697458cb928ef",
        //      "symbol":"DOGEUSD",
        //      "side":"sell",
        //      "quantity":"100",
        //      "price":"0.03904191",
        //      "fee":"0.009760477500",
        //      "timestamp":"2022-01-25T15:15:41.353Z",
        //      "taker":true
        //  }
        //
        $timestamp = $this->parse8601($trade['timestamp']);
        $marketId = $this->safe_string($trade, 'symbol');
        $market = $this->safe_market($marketId, $market);
        $symbol = $market['symbol'];
        $fee = null;
        $feeCostString = $this->safe_string($trade, 'fee');
        if ($feeCostString !== null) {
            $feeCurrencyCode = $market ? $market['feeCurrency'] : null;
            $fee = array(
                'cost' => $feeCostString,
                'currency' => $feeCurrencyCode,
            );
        }
        // we use clientOrderId as the order $id with this exchange intentionally
        // because most of their endpoints will require clientOrderId
        // explained here => https://github.com/ccxt/ccxt/issues/5674
        $orderId = $this->safe_string($trade, 'clientOrderId');
        $priceString = $this->safe_string($trade, 'price');
        $amountString = $this->safe_string($trade, 'quantity');
        $side = $this->safe_string($trade, 'side');
        $id = $this->safe_string($trade, 'id');
        return $this->safe_trade(array(
            'info' => $trade,
            'id' => $id,
            'order' => $orderId,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'symbol' => $symbol,
            'type' => null,
            'side' => $side,
            'takerOrMaker' => null,
            'price' => $priceString,
            'amount' => $amountString,
            'cost' => null,
            'fee' => $fee,
        ), $market);
    }

    public function fetch_transactions($code = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $currency = null;
        $request = array();
        if ($code !== null) {
            $currency = $this->currency($code);
            $request['asset'] = $currency['id'];
        }
        if ($since !== null) {
            $request['startTime'] = $since;
        }
        $response = $this->privateGetAccountTransactions (array_merge($request, $params));
        return $this->parse_transactions($response, $currency, $since, $limit);
    }

    public function parse_transaction($transaction, $currency = null) {
        //
        // transactions
        //
        //     array(
        //         $id => 'd53ee9df-89bf-4d09-886e-849f8be64647',
        //         index => 1044718371,
        //         $type => 'payout', // payout, payin
        //         $status => 'success',
        //         $currency => 'ETH',
        //         $amount => '4.522683200000000000000000',
        //         createdAt => '2018-06-07T00:43:32.426Z',
        //         updatedAt => '2018-06-07T00:45:36.447Z',
        //         hash => '0x973e5683dfdf80a1fb1e0b96e19085b6489221d2ddf864daa46903c5ec283a0f',
        //         $address => '0xC5a59b21948C1d230c8C54f05590000Eb3e1252c',
        //         $fee => '0.00958',
        //     ),
        //     array(
        //         $id => 'e6c63331-467e-4922-9edc-019e75d20ba3',
        //         index => 1044714672,
        //         $type => 'exchangeToBank', // exchangeToBank, bankToExchange, withdraw
        //         $status => 'success',
        //         $currency => 'ETH',
        //         $amount => '4.532263200000000000',
        //         createdAt => '2018-06-07T00:42:39.543Z',
        //         updatedAt => '2018-06-07T00:42:39.683Z',
        //     ),
        //
        // withdraw
        //
        //     {
        //         "id" => "d2ce578f-647d-4fa0-b1aa-4a27e5ee597b"
        //     }
        //
        $id = $this->safe_string($transaction, 'id');
        $timestamp = $this->parse8601($this->safe_string($transaction, 'createdAt'));
        $updated = $this->parse8601($this->safe_string($transaction, 'updatedAt'));
        $currencyId = $this->safe_string($transaction, 'currency');
        $code = $this->safe_currency_code($currencyId, $currency);
        $status = $this->parse_transaction_status($this->safe_string($transaction, 'status'));
        $amount = $this->safe_number($transaction, 'amount');
        $address = $this->safe_string($transaction, 'address');
        $txid = $this->safe_string($transaction, 'hash');
        $fee = null;
        $feeCost = $this->safe_number($transaction, 'fee');
        if ($feeCost !== null) {
            $fee = array(
                'cost' => $feeCost,
                'currency' => $code,
            );
        }
        $type = $this->parse_transaction_type($this->safe_string($transaction, 'type'));
        return array(
            'info' => $transaction,
            'id' => $id,
            'txid' => $txid,
            'timestamp' => $timestamp,
            'datetime' => $this->iso8601($timestamp),
            'network' => null,
            'address' => $address,
            'addressTo' => null,
            'addressFrom' => null,
            'tag' => null,
            'tagTo' => null,
            'tagFrom' => null,
            'type' => $type,
            'amount' => $amount,
            'currency' => $code,
            'status' => $status,
            'updated' => $updated,
            'fee' => $fee,
        );
    }

    public function parse_transaction_status($status) {
        $statuses = array(
            'pending' => 'pending',
            'failed' => 'failed',
            'success' => 'ok',
        );
        return $this->safe_string($statuses, $status, $status);
    }

    public function parse_transaction_type($type) {
        $types = array(
            'payin' => 'deposit',
            'payout' => 'withdrawal',
            'withdraw' => 'withdrawal',
        );
        return $this->safe_string($types, $type, $type);
    }

    public function fetch_trades($symbol, $since = null, $limit = null, $params = array ()) {
        /**
         * get the list of most recent trades for a particular $symbol
         * @param {str} $symbol unified $symbol of the $market to fetch trades for
         * @param {int|null} $since timestamp in ms of the earliest trade to fetch
         * @param {int|null} $limit the maximum amount of trades to fetch
         * @param {dict} $params extra parameters specific to the hitbtc api endpoint
         * @return {[dict]} a list of ~@link https://docs.ccxt.com/en/latest/manual.html?#public-trades trade structures~
         */
        $this->load_markets();
        $market = $this->market($symbol);
        $request = array(
            'symbol' => $market['id'],
        );
        if ($limit !== null) {
            $request['limit'] = $limit;
        }
        if ($since !== null) {
            $request['sort'] = 'ASC';
            $request['from'] = $this->iso8601($since);
        }
        $response = $this->publicGetTradesSymbol (array_merge($request, $params));
        return $this->parse_trades($response, $market, $since, $limit);
    }

    public function create_order($symbol, $type, $side, $amount, $price = null, $params = array ()) {
        $this->load_markets();
        $market = $this->market($symbol);
        // we use $clientOrderId as the $order id with this exchange intentionally
        // because most of their endpoints will require $clientOrderId
        // explained here => https://github.com/ccxt/ccxt/issues/5674
        // their max accepted length is 32 characters
        $uuid = $this->uuid();
        $parts = explode('-', $uuid);
        $clientOrderId = implode('', $parts);
        $clientOrderId = mb_substr($clientOrderId, 0, 32 - 0);
        $amount = floatval($amount);
        $request = array(
            'clientOrderId' => $clientOrderId,
            'symbol' => $market['id'],
            'side' => $side,
            'quantity' => $this->amount_to_precision($symbol, $amount),
            'type' => $type,
        );
        if ($type === 'limit') {
            $request['price'] = $this->price_to_precision($symbol, $price);
        } else {
            $request['timeInForce'] = $this->options['defaultTimeInForce'];
        }
        $response = $this->privatePostOrder (array_merge($request, $params));
        $order = $this->parse_order($response);
        if ($order['status'] === 'rejected') {
            throw new InvalidOrder($this->id . ' $order was rejected by the exchange ' . $this->json($order));
        }
        return $order;
    }

    public function edit_order($id, $symbol, $type, $side, $amount = null, $price = null, $params = array ()) {
        $this->load_markets();
        // we use clientOrderId as the order $id with this exchange intentionally
        // because most of their endpoints will require clientOrderId
        // explained here => https://github.com/ccxt/ccxt/issues/5674
        // their max accepted length is 32 characters
        $uuid = $this->uuid();
        $parts = explode('-', $uuid);
        $requestClientId = implode('', $parts);
        $requestClientId = mb_substr($requestClientId, 0, 32 - 0);
        $request = array(
            'clientOrderId' => $id,
            'requestClientId' => $requestClientId,
        );
        if ($amount !== null) {
            $request['quantity'] = $this->amount_to_precision($symbol, $amount);
        }
        if ($price !== null) {
            $request['price'] = $this->price_to_precision($symbol, $price);
        }
        $response = $this->privatePatchOrderClientOrderId (array_merge($request, $params));
        return $this->parse_order($response);
    }

    public function cancel_order($id, $symbol = null, $params = array ()) {
        $this->load_markets();
        // we use clientOrderId as the order $id with this exchange intentionally
        // because most of their endpoints will require clientOrderId
        // explained here => https://github.com/ccxt/ccxt/issues/5674
        $request = array(
            'clientOrderId' => $id,
        );
        $response = $this->privateDeleteOrderClientOrderId (array_merge($request, $params));
        return $this->parse_order($response);
    }

    public function parse_order_status($status) {
        $statuses = array(
            'new' => 'open',
            'suspended' => 'open',
            'partiallyFilled' => 'open',
            'filled' => 'closed',
            'canceled' => 'canceled',
            'expired' => 'failed',
        );
        return $this->safe_string($statuses, $status, $status);
    }

    public function parse_order($order, $market = null) {
        //
        // createMarketOrder
        //
        //     {
        //         $clientOrderId => "fe36aa5e190149bf9985fb673bbb2ea0",
        //         createdAt => "2018-10-25T16:41:44.780Z",
        //         cumQuantity => "1",
        //         $id => "66799540063",
        //         quantity => "1",
        //         $side => "sell",
        //         $status => "filled",
        //         $symbol => "XRPUSDT",
        //         $timeInForce => "FOK",
        //         tradesReport => array(
        //             {
        //                 $fee => "0.0004644",
        //                 $id =>  386394956,
        //                 $price => "0.4644",
        //                 quantity => "1",
        //                 timestamp => "2018-10-25T16:41:44.780Z"
        //             }
        //         ),
        //         $type => "market",
        //         updatedAt => "2018-10-25T16:41:44.780Z"
        //     }
        //
        //     {
        //         "id" => 119499457455,
        //         "clientOrderId" => "87baab109d58401b9202fa0749cb8288",
        //         "symbol" => "ETHUSD",
        //         "side" => "buy",
        //         "status" => "filled",
        //         "type" => "market",
        //         "timeInForce" => "FOK",
        //         "quantity" => "0.0007",
        //         "price" => "181.487",
        //         "avgPrice" => "164.989",
        //         "cumQuantity" => "0.0007",
        //         "createdAt" => "2019-04-17T13:27:38.062Z",
        //         "updatedAt" => "2019-04-17T13:27:38.062Z"
        //     }
        //
        $created = $this->parse8601($this->safe_string($order, 'createdAt'));
        $updated = $this->parse8601($this->safe_string($order, 'updatedAt'));
        $marketId = $this->safe_string($order, 'symbol');
        $market = $this->safe_market($marketId, $market);
        $symbol = $market['symbol'];
        $amount = $this->safe_string($order, 'quantity');
        $filled = $this->safe_string($order, 'cumQuantity');
        $status = $this->parse_order_status($this->safe_string($order, 'status'));
        // we use $clientOrderId as the $order $id with this exchange intentionally
        // because most of their endpoints will require $clientOrderId
        // explained here => https://github.com/ccxt/ccxt/issues/5674
        $id = $this->safe_string($order, 'clientOrderId');
        $clientOrderId = $id;
        $price = $this->safe_string($order, 'price');
        $type = $this->safe_string($order, 'type');
        $side = $this->safe_string($order, 'side');
        $trades = $this->safe_value($order, 'tradesReport');
        $fee = null;
        $average = $this->safe_string($order, 'avgPrice');
        $timeInForce = $this->safe_string($order, 'timeInForce');
        return $this->safe_order(array(
            'id' => $id,
            'clientOrderId' => $clientOrderId, // https://github.com/ccxt/ccxt/issues/5674
            'timestamp' => $created,
            'datetime' => $this->iso8601($created),
            'lastTradeTimestamp' => $updated,
            'status' => $status,
            'symbol' => $symbol,
            'type' => $type,
            'timeInForce' => $timeInForce,
            'side' => $side,
            'price' => $price,
            'stopPrice' => null,
            'average' => $average,
            'amount' => $amount,
            'cost' => null,
            'filled' => $filled,
            'remaining' => null,
            'fee' => $fee,
            'trades' => $trades,
            'info' => $order,
        ), $market);
    }

    public function fetch_order($id, $symbol = null, $params = array ()) {
        $this->load_markets();
        // we use clientOrderId as the order $id with this exchange intentionally
        // because most of their endpoints will require clientOrderId
        // explained here => https://github.com/ccxt/ccxt/issues/5674
        $request = array(
            'clientOrderId' => $id,
        );
        $response = $this->privateGetHistoryOrder (array_merge($request, $params));
        $numOrders = is_array($response) ? count($response) : 0;
        if ($numOrders > 0) {
            return $this->parse_order($response[0]);
        }
        throw new OrderNotFound($this->id . ' order ' . $id . ' not found');
    }

    public function fetch_open_order($id, $symbol = null, $params = array ()) {
        $this->load_markets();
        // we use clientOrderId as the order $id with this exchange intentionally
        // because most of their endpoints will require clientOrderId
        // explained here => https://github.com/ccxt/ccxt/issues/5674
        $request = array(
            'clientOrderId' => $id,
        );
        $response = $this->privateGetOrderClientOrderId (array_merge($request, $params));
        return $this->parse_order($response);
    }

    public function fetch_open_orders($symbol = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $market = null;
        $request = array();
        if ($symbol !== null) {
            $market = $this->market($symbol);
            $request['symbol'] = $market['id'];
        }
        $response = $this->privateGetOrder (array_merge($request, $params));
        return $this->parse_orders($response, $market, $since, $limit);
    }

    public function fetch_closed_orders($symbol = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $market = null;
        $request = array();
        if ($symbol !== null) {
            $market = $this->market($symbol);
            $request['symbol'] = $market['id'];
        }
        if ($limit !== null) {
            $request['limit'] = $limit;
        }
        if ($since !== null) {
            $request['from'] = $this->iso8601($since);
        }
        $response = $this->privateGetHistoryOrder (array_merge($request, $params));
        $parsedOrders = $this->parse_orders($response, $market);
        $orders = array();
        for ($i = 0; $i < count($parsedOrders); $i++) {
            $order = $parsedOrders[$i];
            $status = $order['status'];
            if (($status === 'closed') || ($status === 'canceled')) {
                $orders[] = $order;
            }
        }
        return $this->filter_by_since_limit($orders, $since, $limit);
    }

    public function fetch_my_trades($symbol = null, $since = null, $limit = null, $params = array ()) {
        $this->load_markets();
        $request = array(
            // 'symbol' => 'BTC/USD', // optional
            // 'sort' =>   'DESC', // or 'ASC'
            // 'by' =>     'timestamp', // or 'id' String timestamp by default, or id
            // 'from' =>   'Datetime or Number', // ISO 8601
            // 'till' =>   'Datetime or Number',
            // 'limit' =>  100,
            // 'offset' => 0,
        );
        $market = null;
        if ($symbol !== null) {
            $market = $this->market($symbol);
            $request['symbol'] = $market['id'];
        }
        if ($since !== null) {
            $request['from'] = $this->iso8601($since);
        }
        if ($limit !== null) {
            $request['limit'] = $limit;
        }
        $response = $this->privateGetHistoryTrades (array_merge($request, $params));
        //
        //     array(
        //         array(
        //             "id" => 9535486,
        //             "clientOrderId" => "f8dbaab336d44d5ba3ff578098a68454",
        //             "orderId" => 816088377,
        //             "symbol" => "ETHBTC",
        //             "side" => "sell",
        //             "quantity" => "0.061",
        //             "price" => "0.045487",
        //             "fee" => "0.000002775",
        //             "timestamp" => "2017-05-17T12:32:57.848Z"
        //         ),
        //         {
        //             "id" => 9535437,
        //             "clientOrderId" => "27b9bfc068b44194b1f453c7af511ed6",
        //             "orderId" => 816088021,
        //             "symbol" => "ETHBTC",
        //             "side" => "buy",
        //             "quantity" => "0.038",
        //             "price" => "0.046000",
        //             "fee" => "-0.000000174",
        //             "timestamp" => "2017-05-17T12:30:57.848Z"
        //         }
        //     )
        //
        return $this->parse_trades($response, $market, $since, $limit);
    }

    public function fetch_order_trades($id, $symbol = null, $since = null, $limit = null, $params = array ()) {
        // The $id needed here is the exchange's $id, and not the clientOrderID,
        // which is the $id that is stored in the unified order $id
        // To get the exchange's $id you need to grab it from order['info']['id']
        $this->load_markets();
        $market = null;
        if ($symbol !== null) {
            $market = $this->market($symbol);
        }
        $request = array(
            'orderId' => $id,
        );
        $response = $this->privateGetHistoryOrderOrderIdTrades (array_merge($request, $params));
        $numOrders = is_array($response) ? count($response) : 0;
        if ($numOrders > 0) {
            return $this->parse_trades($response, $market, $since, $limit);
        }
        throw new OrderNotFound($this->id . ' order ' . $id . ' not found, ' . $this->id . '.fetchOrderTrades() requires an exchange-specific order $id, you need to grab it from order["info"]["id"]');
    }

    public function create_deposit_address($code, $params = array ()) {
        $this->load_markets();
        $currency = $this->currency($code);
        $request = array(
            'currency' => $currency['id'],
        );
        $response = $this->privatePostAccountCryptoAddressCurrency (array_merge($request, $params));
        $address = $this->safe_string($response, 'address');
        $this->check_address($address);
        $tag = $this->safe_string($response, 'paymentId');
        return array(
            'currency' => $currency,
            'address' => $address,
            'tag' => $tag,
            'info' => $response,
        );
    }

    public function fetch_deposit_address($code, $params = array ()) {
        $this->load_markets();
        $currency = $this->currency($code);
        $request = array(
            'currency' => $currency['id'],
        );
        $network = $this->safe_string($params, 'network');
        if ($network !== null) {
            $params = $this->omit($params, 'network');
            $networks = $this->safe_value($this->options, 'networks');
            $endpart = $this->safe_string($networks, $network, $network);
            $request['currency'] .= $endpart;
        }
        $response = $this->privateGetAccountCryptoAddressCurrency (array_merge($request, $params));
        $address = $this->safe_string($response, 'address');
        $this->check_address($address);
        $tag = $this->safe_string($response, 'paymentId');
        return array(
            'currency' => $currency['code'],
            'address' => $address,
            'tag' => $tag,
            'network' => null,
            'info' => $response,
        );
    }

    public function convert_currency_network($code, $amount, $fromNetwork, $toNetwork, $params) {
        $this->load_markets();
        $currency = $this->currency($code);
        $networks = $this->safe_value($this->options, 'networks', array());
        $fromNetwork = $this->safe_string($networks, $fromNetwork, $fromNetwork); // handle ETH>ERC20 alias
        $toNetwork = $this->safe_string($networks, $toNetwork, $toNetwork); // handle ETH>ERC20 alias
        if ($fromNetwork === $toNetwork) {
            throw new ExchangeError($this->id . ' convertCurrencyNetwork() $fromNetwork cannot be the same as toNetwork');
        }
        $request = array(
            'fromCurrency' => $currency['id'] . $fromNetwork,
            'toCurrency' => $currency['id'] . $toNetwork,
            'amount' => floatval($this->currency_to_precision($code, $amount)),
        );
        $response = $this->privatePostAccountCryptoTransferConvert (array_merge($request, $params));
        return array(
            'info' => $response,
        );
    }

    public function withdraw($code, $amount, $address, $tag = null, $params = array ()) {
        list($tag, $params) = $this->handle_withdraw_tag_and_params($tag, $params);
        $this->load_markets();
        $this->check_address($address);
        $currency = $this->currency($code);
        $request = array(
            'currency' => $currency['id'],
            'amount' => floatval($amount),
            'address' => $address,
        );
        if ($tag) {
            $request['paymentId'] = $tag;
        }
        $networks = $this->safe_value($this->options, 'networks', array());
        $network = $this->safe_string_upper($params, 'network'); // this line allows the user to specify either ERC20 or ETH
        $network = $this->safe_string($networks, $network, $network); // handle ERC20>ETH alias
        if ($network !== null) {
            $request['currency'] .= $network; // when $network the $currency need to be changed to $currency . $network
            $params = $this->omit($params, 'network');
        }
        $response = $this->privatePostAccountCryptoWithdraw (array_merge($request, $params));
        //
        //     {
        //         "id" => "d2ce578f-647d-4fa0-b1aa-4a27e5ee597b"
        //     }
        //
        return $this->parse_transaction($response, $currency);
    }

    public function nonce() {
        return $this->milliseconds();
    }

    public function sign($path, $api = 'public', $method = 'GET', $params = array (), $headers = null, $body = null) {
        $url = '/api/' . $this->version . '/';
        $query = $this->omit($params, $this->extract_params($path));
        if ($api === 'public') {
            $url .= $api . '/' . $this->implode_params($path, $params);
            if ($query) {
                $url .= '?' . $this->urlencode($query);
            }
        } else {
            $this->check_required_credentials();
            $url .= $this->implode_params($path, $params);
            if ($method === 'GET') {
                if ($query) {
                    $url .= '?' . $this->urlencode($query);
                }
            } elseif ($query) {
                $body = $this->json($query);
            }
            $payload = $this->encode($this->apiKey . ':' . $this->secret);
            $auth = base64_encode($payload);
            $headers = array(
                'Authorization' => 'Basic ' . $this->decode($auth),
                'Content-Type' => 'application/json',
            );
        }
        $url = $this->urls['api'][$api] . $url;
        return array( 'url' => $url, 'method' => $method, 'body' => $body, 'headers' => $headers );
    }

    public function handle_errors($code, $reason, $url, $method, $headers, $body, $response, $requestHeaders, $requestBody) {
        if ($response === null) {
            return;
        }
        if ($code >= 400) {
            $feedback = $this->id . ' ' . $body;
            // array("code":504,"message":"Gateway Timeout","description":"")
            if (($code === 503) || ($code === 504)) {
                throw new ExchangeNotAvailable($feedback);
            }
            // fallback to default error handler on rate limit errors
            // array("code":429,"message":"Too many requests","description":"Too many requests")
            if ($code === 429) {
                return;
            }
            // array("error":array("code":20002,"message":"Order not found","description":""))
            if ($body[0] === '{') {
                if (is_array($response) && array_key_exists('error', $response)) {
                    $errorCode = $this->safe_string($response['error'], 'code');
                    $this->throw_exactly_matched_exception($this->exceptions, $errorCode, $feedback);
                    $message = $this->safe_string($response['error'], 'message');
                    if ($message === 'Duplicate clientOrderId') {
                        throw new InvalidOrder($feedback);
                    }
                }
            }
            throw new ExchangeError($feedback);
        }
    }
}
